<?php

function httpPost($url, $data = null, $verify = false)
{
	$curl = curl_init();

	curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
	curl_setopt($curl, CURLOPT_TIMEOUT, 500);
	//curl_setopt($curl, CURLOPT_SSLVERSION, 3); 
	curl_setopt($curl, CURLOPT_HEADER, false);
	curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, $verify);
	curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, $verify);
	curl_setopt($curl, CURLOPT_URL, $url);
	if($data) {
		curl_setopt($curl, CURLOPT_POST, 1);
		curl_setopt($curl, CURLOPT_POSTFIELDS, $data);//http_build_query($data));
	}

	$res = curl_exec($curl);

	//var_dump($res);
	curl_close($curl);

	return $res;
}

function get_real_ip()
{
	$ip = false;

	if(isset($_REQUEST["_src_client_ip"]) && !empty($_REQUEST["_src_client_ip"])) {
		return $_REQUEST["_src_client_ip"];
	}

	if(!empty($_SERVER["HTTP_CLIENT_IP"]))
		$ip = $_SERVER["HTTP_CLIENT_IP"];

	if (!empty($_SERVER['HTTP_X_FORWARDED_FOR'])) {

		$ips = explode(", ", $_SERVER['HTTP_X_FORWARDED_FOR']);
		if ($ip) {
			array_unshift($ips, $ip);
			$ip = false;
		}

		for ($i = 0; $i < count($ips); $i++) {
			if (!eregi("^(10|172\.16|192\.168)\.", $ips[$i])) {
				$ip = $ips[$i];
				break;
			}
		}

	}

	return ($ip ? $ip : (isset($_SERVER['REMOTE_ADDR']) ? $_SERVER['REMOTE_ADDR'] : '127.0.0.1'));
}

function text_error_exit($ret, $msg, $data = '')
{
	if($ret)
		echo "ERR {$msg}\n";
	else
		echo "OK {$msg}\n";
	echo $data;
	exit;
}

function ckarg_str($data, $key, $default_errmsg)
{
	if(!isset($data[$key]))
		text_error_exit(1, $default_errmsg);
	if(empty($data[$key] = trim($data[$key])))
		text_error_exit(1, $default_errmsg);

	return $_REQUEST[$key];
}

function ckarg_id($data, $key, $default_errmsg)
{
	$id = intval(ckarg_str($data, $key, $default_errmsg));
	if($id <= 0)
		text_error_exit(1, $default_errmsg);

	return $id;
}

function get_phpfile_conf($file)
{
	return trim(substr(file_get_contents($file), 15));
}

function put_phpfile_conf($file, $content)
{
	$fp = fopen($file, "w");
	if($fp) {
		fwrite($fp, "<?php exit();?>" . $content);
		fclose($fp);
		return true;
	}
	return false;
}

function db_connect($errmode = PDO::ERRMODE_EXCEPTION)
{
	$driver_options = array(
		PDO::ATTR_PERSISTENT		=> true,
		PDO::ATTR_EMULATE_PREPARES	=> false
	);
	$driver_options[PDO::ATTR_ERRMODE] = $errmode;

	try {
		$db = new PDO('mysql:host=localhost;dbname=panabit_raas;charset=utf8', 
					'raas',
					'db-paraas-20190330',
				);
	}
	catch (PDOException $e) {
		text_error_exit(1, "db err: " . $e->getMessage());
	}

	return $db;
}

function db_fetch($db, $sql, $data = NULL, $fetch_style = PDO::FETCH_ASSOC)
{
	try {
		$stm = $db->prepare($sql);
		if(!$stm->execute($data))
			return false;
		$item = $stm->fetch($fetch_style);
	}
	catch (PDOException $e) {
		text_error_exit(1, "db err: " . $e->getMessage());
	}

	return $item;
}
