<?php
/*
 * API
 *
 * 用户自助查询时间与带宽接口
 *
 */
namespace raas\apps\account;

$appdir = dirname(dirname(__FILE__));
$appname = basename($appdir);
$appmethod = basename(__FILE__, '.php');

// $token = $appname . '_' . $appmethod;


// 支持库装载 | load lib
// ni_library_load('nidb');

// 装载功能 | load function
ni_app_load('user', 'login');
ni_app_load('account', 'info');
ni_app_load('group', 'info');
ni_app_load('enterpise', 'find');

if(isset($_REQUEST['domain']) == false || ($domain = trim($_REQUEST['domain'])) == '') 
	json_error_exit(ERR_FAILURE, 'ARG');

if(isset($_REQUEST['user']) == false || ($account = trim($_REQUEST['user'])) == '') 
	json_error_exit(ERR_FAILURE, 'ARG');

if(isset($_REQUEST['pass']) == false || ($pass = trim($_REQUEST['pass'])) == '')
	json_error_exit(ERR_FAILURE, 'ARG');

if(isset($_REQUEST['charset']) == 'GB2312') {
	$account = iconv('GB2312', 'UTF-8', $account);
	$_REQUEST['user'] = $account;
}

if(($ent = \raas\apps\enterpise\_finddomain($domain)) === false){
	json_error_exit(2, 'NENT');
}

$frmData = array(
	'ent_id' => $ent->ent_id,
	'account' => $account,
);

if(($acct = \raas\apps\account\info($frmData, 1)) === false) {
	json_error_exit(3, 'NUSER');
}

if($acct->pass != $pass)
	json_error_exit(4, 'ERR_PASS');

$rate_in = $acct->rate_in;
$rate_out = $acct->rate_out;

if($acct->group_id > 0) {
	if(($grp = \raas\apps\group\info(array('group_id' => $acct->group_id))) === false){
		json_error_exit(2, 'GET_GROUP_INFO');
	}

	if(!$acct->rate_in)
		$rate_in = $grp->rate_in;
	if(!$acct->rate_out)
		$rate_out = $grp->rate_out;
}

$data = array(
	'rate_in' => $rate_in,
	'rate_out' => $rate_out,
	'start_time' => $acct->start_time,
	'expire_time' => $acct->expire_time,
);

json_error_exit(ERR_OK, 'OK', $data);
