function dateFormatter(data, type, row, meta) {
	return $.myTime.UnixToStrDate(data);
}

function ipFormatter(data, type, row, meta) {
	return _int2iP(data);
}

$(document).ready(function(){
	App.init();

	$(".datetimepicker").datetimepicker(OPTIONS_CONSTANT.DATA_DATETIMEPICKER);
	
	$("#reg-account").click(function(){
		showAjaxModal('create_account', {
			content:{
				ajax: {
					url: 'modal.php?r=account@create',
				}
			},
			options:{
				data: {
					success: function(e, d, msg){
						$table.ajax.reload();
					}
				}
			}
		}, true, 'modal-bgcolor modal-effect-16');
	});
	
	$("#reg-group").click(function(){
		showAjaxModal('create_group', {
			content:{
				ajax: {
					url: 'modal.php?r=group@create',
				}
			},
			options:{
				data: {
					success: function(e, d, msg){
						$table.ajax.reload();
					}
				}
			}
		}, true, 'modal-bgcolor modal-effect-16');
	});

	$("#del-selected").click(function(){

		var selectitem = $(":checkbox[name!='cb-check-all']:checked", $('#tablelist'));

		if(selectitem.length <= 0) return;

		showAjaxModal('account_delete', {
			content: {
				body: {
					content: [
						'<div class="text-center">',
						'<h3>删除当前选中用户!</h3>',
						'<p>是否要继续删除当前选中的“<span style="color: #ea4335; font-weight: 700;">' + selectitem.length + '</span>”个用户？确认后将无法找回！</p>',
						'<div class="mt-4">',
							'<button type="button" data-dismiss="modal" class="btn btn-secondary btn-space modal-close btn-cancel">否</button>',
							'<button type="button" data-dismiss="modal" class="btn btn-success btn-space modal-close btn-ok">是</button>',
						'</div>',
						'</div>'
					].join('')
				},
			},
			options: {
				buttons: [
				  {
					class: 'btn-ok',
					callback: function ( btn, modal, event ) {
					  //You can cancel the modal hide event by returning false
						var i, item, count = 0, success = 0;
						for(i = 0; i < selectitem.length; i++) {
							item = $table.row(selectitem.eq(i).closest('tr')).data();
							ajaxgo({
								type: 'POST',
								url: 'api.php?r=account@remove',
								data: {acct_id: item.acct_id, ent_id: item.ent_id}
							},
							function (d, msg){},
							function (d){
								success++;
								if(++count == selectitem.length) {
									$table.ajax.reload();
									if(selectitem.length - count == 0) {
										$.gritter.add({
											title: "操作完毕",
											text: "共计删除“" + success + "”个用户！",
											class_name: "color success"
										});
									}
									else {
										$.gritter.add({
											title: "错误",
											text: "有“" + (selectitem.length - success) + "”个用户未删除成功！",
											class_name: "color danger"
										});
									}
								}
								
								return false;
							});
						}
						return true;
					}
				  }
				]
			}
		});
	});
	
	var $table = $('#tablelist').DataTable($.extend(true,{},OPTIONS_CONSTANT.DATA_TABLES.DEFAULT_OPTION, {
		pageLength: 50,
		displayLength: 20,
		dom: "<'row'><'row be-datatable-body'<'table-responsive'tr>><'row be-datatable-footer'<'col-sm-5'i><'col-sm-7'p>>",
		columns: [

			$.extend(true,{},OPTIONS_CONSTANT.DATA_TABLES.COLUMN.CHECKBOX,{
				title: '<input type="checkbox" name="cb-check-all">'
			}),

			{
				title: '索引',
				data: 'index_js_id',
				width: 30,
				searchable: false,
				orderable: false,
				render: function(data, type, row, meta) {
					return meta.row + 1;
				}
			},
			{
				title: '帐号',
				data: "account",
				width: 90
			},
			{
				title: '姓名',
				data: "name",
				width: 90
			},
			{
				title: '用户组',
				data: "group",
				width: 70
			},
			{
				title: '开户时间',
				data: "create_time",
				width: 60,
				render: dateFormatter
			},
			{
				title: '到期时间',
				data: "expire_time",
				width: 60,
				render: dateFormatter
			},
			{
				title: '最大用户数',
				data: "maxcnt",
				width: 66
			},
			{
				title: '绑定IP',
				data: "bind_ipv4",
				width: 60,
				render: ipFormatter
			},
			{
				title: '代拨帐号',
				data: "pxyacct",
				width: 90,
			},
			{
				title: '备注',
				orderable: false,
				data: "remark",
				fnCreatedCell: function (nTd, sData, oData, iRow, iCol) {
					$(nTd).addClass('inputTd').attr('id', 'td_' + sData + '_' + oData.account);
				}
			},
			{
				title: "操作",
				orderable: false,
				data: null,
				width: 50,
				defaultContent: '<div class="row">\
								<div class="icon-container icon-td col-md-4">\
									<div class="icon btn-logger"><span class="mdi mdi-calendar-note"></span></div>\
								</div>\
								<div class="icon-container icon-td col-md-4">\
									<div class="icon btn-edit"><span class="mdi mdi-edit"></span></div>\
								</div>\
								<div class="icon-container icon-td col-md-4">\
									<div class="icon btn-del"><span class="mdi mdi-delete"></span></div>\
								</div></div>'
		}],
		fnDrawCallback: function (data) {
			$(":checkbox[name='cb-check-all']").prop('checked', false);
			//默认选中第一行
			$("tbody tr", $table).eq(0).click();
/*
			$('#tablelist tbody td.selectTd').editable('editable.php');
			$('#tablelist tbody td.inputTd').editable('api.php?r=account@list',
			{
				//data:{"10":"10","20":"20","30":"30"},
				data   : '{"E":"Letter E","F":"Letter F","G":"Letter G", "selected":"F"}',
				type: 'text',
				submit : '确定',
				submitdata: { _method: "post"},
				onblur    : "ignore",
				cancel    : '取消',
				cssclass : 'form-group',
				cancelcssclass : 'btn btn-space btn-danger',
				submitcssclass : 'btn btn-space btn-success',
				formid : 'abc-123',
				onedit : function() { console.log('If I return false edition will be canceled'); return true;},
				before : function() { console.log('Triggered before form appears')},
				callback : function(result, settings, submitdata) {
					console.log('Triggered after submit');
					console.log('Result: ' + result);
					console.log('Settings.width: ' + settings.width);
					console.log('Submitdata: ' + submitdata.pwet);
				},
			});
*/
		},
		footerCallback: function (row, data, start, end, display ) {
			var api = this.api(), data;
			// Remove the formatting to get integer data for summation
			var intVal = function ( i ) {
				return typeof i === 'string' ?
					i.replace(/[\$,]/g, '')*1 :
					typeof i === 'number' ?
						i : 0;
			};
 /*
			// Total over all pages
			total = api
				.column( 4 )
				.data()
				.reduce( function (a, b) {
					return intVal(a) + intVal(b);
				} );
 
			// Total over this page
			pageTotal = api
				.column( 4, { page: 'current'} )
				.data()
				.reduce( function (a, b) {
					return intVal(a) + intVal(b);
				}, 0 );
 
			// Update footer
			$( api.column( 4 ).footer() ).html(
				'$'+pageTotal +' ( $'+ total +' total)'
			);
*/
		},
		ajax: $.extend(true,{},OPTIONS_CONSTANT.DATA_TABLES.AJAX, {
			url: 'api.php?r=account@list',
			data: function (d) {
				var form_date = $.trim($('#form_date').val()), 
					to_date = $.trim($('#form_date').val()), 
					search = $.trim($('#search_val').val()),
					group_id = strToInt($("#group_id").val());
				
				if(search != '') d.search.value = search;
				if(form_date != '') d.form_date = form_date;
				if(to_date != '') d.to_date = to_date;
				if(group_id > 0)
					d.group_id = group_id;
				else 
				if(group_id < 0) 
					d.ent_id = group_id * -1;

				return $.extend({}, d, {
					extra_search: $('#extra').val()
				});
			},
		})
	})).on('xhr.dt', function ( e, settings, json, xhr ) {
		// Note no return - manipulate the data directly in the JSON object.
	}).on("change", ":checkbox", function() {
        if($(this).is("[name='cb-check-all']")) {
            //全选
            $(":checkbox", $('#tablelist')).prop("checked",$(this).prop("checked"));
        }else{
            //一般复选
            var checkbox = $("tbody :checkbox", $('#tablelist'));
            $(":checkbox[name='cb-check-all']", $('#tablelist')).prop('checked', checkbox.length == checkbox.filter(':checked').length);
        }
    }).on("click", ".td-checkbox", function(event) {
        !$(event.target).is(":checkbox") && $(":checkbox",this).trigger("click");
    }).on("click", ".btn-logger", function() {
        var item = $table.row($(this).closest('tr')).data();
        $(this).closest('tr').addClass("active").siblings().removeClass("active");
        // window.location.href = 'index.php?r=group@edit&id=' + item.group_id;
		var params = {acct_id: item.acct_id, ent_id: item.ent_id};

		showAjaxModal('user_logger', {
			content:{
				ajax: {
					url: 'modal.php?r=account@logger',
					data: params,
				}
			},
			options:{
				data: {
					data: item,
					success: function(e, d, msg){
						$table.ajax.reload();
					}
				}
			}
		}, true, 'modal-bgcolor modal-effect-16');
    }).on("click", ".btn-edit", function() {
        var item = $table.row($(this).closest('tr')).data();
        $(this).closest('tr').addClass("active").siblings().removeClass("active");
        // window.location.href = 'index.php?r=group@edit&id=' + item.group_id;
		showAjaxModal('edit_group', {
			content:{
				ajax: {
					url: 'modal.php?r=account@edit',
				}
			},
			options:{
				data: {
					data: item,
					success: function(e, d, msg){
						$table.ajax.reload();
					}
				}
			}
		}, true, 'modal-bgcolor modal-effect-16');
    }).on("click", ".btn-del", function() {
        var item = $table.row($(this).closest('tr')).data();
        $(this).closest('tr').addClass("active").siblings().removeClass("active");
		showAjaxModal('itemdel', {
			content: {
				body: {
					content: [
						'<div class="text-center">',
						'<h3>用户删除!</h3>',
						'<p>您是否要继续删除“<span style="color: #ea4335; font-weight: 700;">' + item.name + '</span>”用户，确认后将无法找回！</p>',
						'<div class="mt-4">',
                            '<button type="button" data-dismiss="modal" class="btn btn-secondary btn-space modal-close btn-cancel">否</button>',
                            '<button type="button" data-dismiss="modal" class="btn btn-success btn-space modal-close btn-ok">是</button>',
						'</div>',
						'</div>'
					].join('')
				},
			},
			options: {
				data: item,
				buttons: [
				  {
					class: 'btn-ok',
					callback: function ( btn, modal, event ) {
					  //You can cancel the modal hide event by returning false
						var params = {acct_id: item.acct_id, ent_id: item.ent_id};
						ajaxgo({
							type: 'POST',
							url: 'api.php?r=account@remove',
							data: params
						},
						function (d, msg){
							// success reload
							$table.ajax.reload();
						});
						return true;
					}
				  }
				]
			}
		});
    }).on("click", ".edit-btn", function() {
		var tds = $(this).parents("tr").children();
		$.each(tds, function(i,val){
			var jqob = $(val);
			if(i < 2 || jqob.has('button').length ){return true;}//跳过第1项 序号,按钮
			var txt=jqob.text();
			var put=$("<input type='text'>");
			put.val(txt);
			jqob.html(put);
		});
		$(this).html("保存");
		$(this).toggleClass("edit-btn");
		$(this).toggleClass("save-btn");
	});

	$('#search_btn').click(function(){
		$table.draw();
	});

	$("#group_id").select2({
		ajax: {
			url: 'api.php?r=group@list&limit=20',
			delay: 600, // wait 600 milliseconds before triggering the request
			processResults: function (data, params) {
				if(ajax_resultCallBack(data) === false) return false;
				params.page = params.page || 1;
				var i, results = {}, ret = $.map(data.data.rows, function (dr) {
					dr.id = dr.group_id;
					dr.text = dr.name || dr.text;
					dr.ent = dr.ent || dr.name;
					dr.text += ' ['+dr.acctcnt +']';
					return dr;
				});
				for(i = ret.length - 1; i >= 0; i--) {
					if(results[ret[i].ent] == undefined)
						results[ret[i].ent] = [];
					results[ret[i].ent].push(ret[i]);
				}
				var children;
				ret = [{id: 0, text: '请选择'}];
				for(i in results) {
					results[i].sort(function(a,b){return a.name - b.name});
					children = [{id: -1 * results[i][0].ent_id, text: '显示所有'}].concat(results[i]);
					ret.push({text: results[i][0].ent, children: children});
				}
				results = ret.sort(function(a,b){
					if(a.name > b.name) return 1;
					else if(a.name < b.name) return -1;
					else return 0;
				});
				return {
					results: results,
					pagination: {
						more: (params.page * 10) < data.data.total
					}
				};
			},
			data: function (params) {
				var query = {
					search:{value: params.term, regex: false},
					page: params.page || 1
				};
				// Query parameters will be ?search=[term]&page=[page]
				return query;
			},
		},
		// minimumInputLength: 1,
		escapeMarkup: function (markup) {return markup;}
	}).on("change", function(e) {
		// $('#select2-group_id-container').text(e.ent + ' -> ' + e.name + ' [' + e.acctcnt + ']');
		$table.ajax.reload();
	});
/*
	var lastIdx = null;
	$('#tablelist').on( 'mouseover', 'td', function () {
		var colIdx = $('#tablelist').cell(this).index().column;
		if ( colIdx !== lastIdx ) {
			$( $('#tablelist').cells().nodes() ).removeClass( 'column-hover' );
			$( $('#tablelist').column( colIdx ).nodes() ).addClass( 'column-hover' );
		}
	}).on( 'mouseleave', function () {
		$( $('#tablelist').cells().nodes() ).removeClass( 'column-hover' );
	});
*/
});
