<?php
namespace raas\apps\account;


function _find($account, $ent_id, $own_id = 0)
{
	global $nidb;

	// set custom options
	$keys = '`acct_id`,
		`parent_id`,
		`ent_id`,
		`own_id`,
		`group_id`,
		`account`,
		`group`,
		`disabled`,
		`webuser_id`,
		`pxyacct`,
		`pxypass`,
		`pxyvlan_in`,
		`pxyvlan_out`,
		`start_time`,
		`expire_time`,
		`bind_ipv4`,
		`bind_v4mac`,
		`bind_vlan`,
		`rate_out`,
		`rate_in`,
		`maxcnt`,
		`name`,
		`idcard`,
		`phone`,
		`email`,
		`remark`,
		`update_time`,
		`create_time`';

	$sql = "select $keys from cloud_account where `account` = ? and `ent_id` = ?";

	try {
		if($own_id > 0) $sql .= ' and `own_id` = ?';
		$sth = $nidb->prepare($sql);

		$index = 1;
		$sth->bindParam($index++, $account, \PDO::PARAM_STR);
		$sth->bindParam($index++, $ent_id, \PDO::PARAM_INT);
		if($own_id > 0) 
			$sth->bindParam($index++, $own_id, \PDO::PARAM_INT);

		$sth->execute();
		$rows = $sth->fetchAll(\PDO::FETCH_CLASS);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	if(count($rows) <= 0) {
		set_errmsg(MSG_LEVEL_DEF, __function__, "无效的用户。");
		return false;
	}
	
	return $rows[0];
}

function find($data)
{
	global $nidb;

	// set custom options
	if(format_and_push($data, 'account', $optional, '', 'string', false) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, 'err: account can\'t empty.');
		return false;
	}
	if(format_and_push($data, 'own_id', $optional, '', 'int', false) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, 'err: own_id can\'t empty.');
		return false;
	}

	return _find($optional['account'], $optional['own_id']);
}

