<?php
namespace raas\apps\account;


function info($data, $allinfo = 0)
{
	global $nidb;

	$optional = array();

	$where_str = '';

	// set custom options
	if(format_and_push($data, 'acct_id', $optional, '', 'int', false))
		$where_str .= "`acct_id` = " . $optional['acct_id']  . " and ";
	else
	if(format_and_push($data, 'account', $optional, '', 'string', false))
		$where_str .= "`account` = '" . $optional['account']  . "' and ";
	if($where_str == '') {
		set_errmsg(MSG_LEVEL_ARG, __function__, 'err: acct_id or account can\'t empty.');
		return false;
	}

	if(format_and_push($data, 'ent_id', $optional, '', 'int', false))
		$where_str .= "`ent_id` = " . $optional['ent_id']  . " and ";

	if(format_and_push($data, 'own_id', $optional, '', 'int', false))
		$where_str .= "`own_id` = " . $optional['own_id']  . " and ";

	$where_str .= "`disabled` < " . TB_ROW_DEL_VALUE  . " and ";

	if($where_str != '')
		$where_str = substr("where $where_str", 0, -5);

	$keys = '`acct_id`,
		`parent_id`,
		`ent_id`,
		`own_id`,
		`group_id`,
		`account`,
		`group`,
		`disabled`,
		`webuser_id`,
		`pxyacct`,
		`pxypass`,
		`pxyvlan_in`,
		`pxyvlan_out`,
		`start_time`,
		`expire_time`,
		`bind_ipv4`,
		`bind_v4mac`,
		`bind_vlan`,
		`rate_out`,
		`rate_in`,
		`maxcnt`,
		`name`,
		`idcard`,
		`phone`,
		`email`,
		`remark`,
		`update_time`,
		`create_time`';

	if($allinfo)
		$sql = "select * from cloud_account $where_str";
	else
		$sql = "select $keys from cloud_account $where_str";

	try {
		$sth = $nidb->prepare($sql);

		$sth->execute();
		$info = $sth->fetch(\PDO::FETCH_LAZY);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	if(!$info) {
		set_errmsg(MSG_LEVEL_DEF, __function__, "无效的帐号。");
		return false;
	}

	return $info;
}

