<?php
namespace raas\apps\account;

define( 'RAASEYE', '/paraas/bin/raaseye');


function FormatResultlst(array $keys, array $values)
{
	$result = array();
	
	$cnt = count($keys);
	
	foreach($values as $volume)
	{
		$volume = explode(' ', $volume);
		$vc = count($volume);

		if($vc < $cnt) 
			continue;
		
		$count = array_push($result, array_combine($keys, $volume));
		$id = $count - 1;
		$result[$id]['cname'] =  iconv('GB2312', 'UTF-8', $result[$id]['cname']);
		$result[$id]['card'] =  iconv('GB2312', 'UTF-8', $result[$id]['card']);
		$result[$id]['phone'] =  iconv('GB2312', 'UTF-8', $result[$id]['phone']);
		$result[$id]['other'] =  iconv('GB2312', 'UTF-8', $result[$id]['other']);
	}

	return $result;
}

function logger($data)
{
	global $nidb;

	$values = array();
	$optional = array();
	// set order, limit, offset value
	format_list_arg($data, $optional);

	$where_str = '';

	// set custom options
	if(format_and_push($data, 'own_id', $optional, '', 'int', false))
		$where_str .= " ownid=" . $optional['own_id'];
	
	if(format_and_push($data, 'ent_id', $optional, '', 'int', false))
		$where_str .= " entid=" . $optional['ent_id'];

	if(format_and_push($data, 'acct_id', $optional, '', 'int', false))
		$where_str .= " acctid=" . $optional['acct_id'];
	
	if(format_and_push($data, 'group_id', $optional, '', 'int', false))
		$where_str .= " gid=" . $optional['group_id'];
	
	if(format_and_push($data, 'acct', $optional, '', 'string', false)) {
		if(preg_match("/^([a-zA-Z0-9-_@.]{2,})$/", $optional['acct'], $match) == false) {
			set_errmsg(MSG_LEVEL_DEF, __function__, '帐号格式不正确！格式：xx@xx.xx');
			return false;
		}
		$where_str .= " acct=" . $optional['acct'];
	}
		


	if(isset($data['search'])) {
		if(format_and_push($data['search'], 'value', $optional, 'search', 'string', false)) {
			$grep_str = 'grep -E "' . str_replace(
				array('&', '|', '\\', "`", "'", "#"), 
				array('', '',   '',  '', '', ''), 
				$optional['search']) . '"';
		}
	}

	$result = array(
		'total'	=> 0,
		'rows'	=> array()
	);

	try {

		if(isset($grep_str))
			$cmd = RAASEYE . " logger list $where_str | $grep_str";
		else
			$cmd = RAASEYE . " logger list $where_str";
		$cmd .= "| awk '{if(r++>=" . $optional['offset'] . "){if(c++<" . $optional['limit'] . ")print $0;}}END{print r - 1;}' ";

		exec($cmd, $rows, $retval);

		//	$result['cmd'] = $cmd;
		if($retval == 0 && is_array($rows) === true) {
			$result['total']= intval(array_pop($rows));
			$result['rows'] = $rows; // FormatResultlst($keys, $rows);
		}
		
		$result['cmd'] = $cmd;
		$result['err'] = $rows;
		$result['retval'] = $retval;
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}


	if(isset($data['draw'])) $result['draw'] = $data['draw'];

	return $result;
}

