<?php
namespace raas\apps\account;

// _acct_count_inc load
ni_app_load('group', '_lib');
ni_app_load('enterpise', '_lib');
ni_app_load('entowner', '_lib');
ni_app_load('counter', '_lib');
ni_app_load('enterpise', 'info');

function _remove($frmData, $where)
{
	global $nidb;

	try {
		if(update_data('cloud_account', $frmData, $where) === false) {
			$errmsg = implode(' ', $nidb->errorInfo());
			set_errmsg(MSG_LEVEL_DEF, __function__, $errmsg);
			return false;
		}
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}


	if(\raas\apps\group\_acct_count_inc($frmData['group_id'], -1) === false) {
		$nidb->rollBack();
		return false;
	}
	if(\raas\apps\enterpise\_acct_count_inc($where['ent_id'], -1) === false) {
		$nidb->rollBack();
		return false;
	}
	if(\raas\apps\entowner\_acct_count_inc($where['own_id'], -1) === false) {
		$nidb->rollBack();
		return false;
	}
	if(\raas\apps\counter\_acct_count_inc(COUNTER_RAAS_ID, -1) === false) {
		$nidb->rollBack();
		return false;
	}

	return true;
}

function remove($data)
{
	global $nidb;

	$filter = array(
		'acct_id'	=> new \FilterVarID(true),
		'ent_id'	=> new \FilterVarID(true),
		'own_id'	=> new \FilterVarID(true),
	);
	if(($where = filter_data($data, $filter, $errmsg)) === false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, $errmsg);
		return false;
	}


	// account is exist?
	$sql = "select `group_id`, `ent_id`, `account` from cloud_account where `own_id` = ? and `acct_id` = ? and `disabled` < " . TB_ROW_DEL_VALUE;
	try {
		$sth = $nidb->prepare($sql);

		$index = 1;
		$sth->bindParam($index++, $where['own_id'], \PDO::PARAM_INT);
//		$sth->bindParam($index++, $where['ent_id'], \PDO::PARAM_INT);
		$sth->bindParam($index++, $where['acct_id'], \PDO::PARAM_INT);

		$sth->execute();
		$rows = $sth->fetchAll(\PDO::FETCH_CLASS);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}
	if(count($rows) < 0) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '找不到此帐号。');
		return false;
	}
	$row = $rows[0];
	if(isset($where['ent_id']) && $where['ent_id'] != $row->ent_id) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '找不到此帐号，该帐号不在指定的项目中！');
		return false;
	}

	$frmData = array();
	$frmData['group_id'] = $row->group_id;
	$frmData['disabled'] = TB_ROW_DEL_VALUE;
	$frmData['update_time'] = time();

	$nidb->beginTransaction();
	
	if(_remove($frmData, $where) === false) {
		$nidb->rollBack();
		return false;
	}
	
	$nidb->commit();

//	synclog_push(RA_SYNC_ACCOUNT, $where['acct_id']);
	$ent = \raas\apps\enterpise\_info($row->ent_id);
	raaseye_acct_remove($row->account . '@' . $ent->domain);

	return true;
}

