<?php
namespace raas\apps\account_book;

// _group_count_inc load
ni_app_load('account', 'info');
ni_app_load('user', 'info');

function _create($frmData)
{
	global $nidb;
	
	$frmData['create_time'] = time();

	try {
		if(insert_data('cloud_account_book', $frmData) === false) {
			$errmsg = implode(' ', $nidb->errorInfo());
			set_errmsg(MSG_LEVEL_DEF, __function__, $errmsg);
			return false;
		}
		$frmData['book_id'] = $nidb->lastInsertId();
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	return $frmData;
}

function create($data)
{
	global $nidb;

	$filter = array(
		'own_id'	=> new \FilterVarID(true),
		'ent_id'	=> new \FilterVarID(true),
		'user_id'	=> new \FilterVarInt(),
		'acct_id'	=> new \FilterVarID(true),
//		'account'	=> new \FilterVarStr(true),
//		'username'	=> new \FilterVarStr(true),
		'expense'	=> new \FilterVarFloat(),
		'action'	=> new \FilterVarStr(true),
		'data'		=> new \FilterVarUkn(),
		'remark'	=> new \FilterVarStr()
	);

	if(($frmData = filter_data($data, $filter, $errmsg)) === false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, $errmsg);
		return false;
	}
	
	if(empty($frmData['action'])) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '动作不能为空！');
		return false;
	}

	// find account is exist
	$acct = \raas\apps\account\info(array('acct_id' => $frmData['acct_id'], 'own_id' => $frmData['own_id']));
	if($acct === false) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '无此帐号！');
		return false;
	}
	if(isset($frmData['user_id'])) {
		$user = \raas\apps\user\_info($frmData['user_id'], $frmData['own_id']);
		if($user === false) {
			set_errmsg(MSG_LEVEL_DEF, __function__, '无效的操作员帐号！');
			return false;
		}
		if($user->disabled != 0) {
			set_errmsg(MSG_LEVEL_DEF, __function__, '您的帐号已被冻结！无法完成此操作。');
			return false;
		}
		
		$frmData['username'] = $user->name;
	}

	$frmData['account'] = $acct->account;
	
	if(isset($data['data']) && is_array($data['data']))
		$frmData['data'] = json_encode($data['data']);
	else
		$frmData['data'] = '';

	if(($frmData = _create($frmData)) === false) 
		return false;

	return $frmData;
}

