<?php
namespace raas\apps\enterpise;

$appdir = dirname(dirname(__FILE__));
$appname = basename($appdir);
$appmethod = basename(__FILE__, '.php');

$token = $appname . '_' . $appmethod;


// 支持库装载 | load lib
// ni_library_load('nidb');

// 装载功能 | load function
ni_app_load('user', 'login');
ni_app_load($appname, 'info');


// 验证用户 | auth user
\raas\apps\user\_auth_json_exit($appname, 'list');


// 执行 | exec function
$ent = info($_REQUEST);


// 结果输出 | printf result
if($ent === false)
	json_error_exit(ERR_FAILURE, '操作失败！');

$data = array(
	'acctcnt'	=> $ent->acctcnt,
	'groupcnt'	=> $ent->groupcnt,
	'session'	=> 0,
	'expired'	=> 0,
	'atoexpire'	=> 0
);


$data = array(
	'start'			=> 0,
	'end'			=> 0,
	'today'			=> 0,
	'timeaxis'		=> array(),
	'count'			=> array(),
	'income'		=> array(),
	'expenditure'	=> array()
);
//匹配时间格式为2016-02-16或2016-02-16 23:59:59前面为0时可以不写
$patten = "/^\d{4}[\-](0?[1-9]|1[012])[\-](0?[1-9]|[12][0-9]|3[01])(\s+(0?[0-9]|1[0-9]|2[0-3])\:(0?[0-9]|[1-5][0-9])\:(0?[0-9]|[1-5][0-9]))?$/";
if(isset($_REQUEST['date'])) {
	if(preg_match($patten, $_REQUEST['date'])) {
		$month = substr($_REQUEST['date'], 0, 8) . '01';
		$start_month = new \DateTime(date($month . ' 00:00:00'));
		$end_month = new \DateTime(date($month . ' 00:00:00'));
		$end_month->modify( '+1 month');
	}
	else 
		json_error_exit(ERR_FAILURE, '日期格式不正确！');
} 
else {
	$start_month = new \DateTime(date('Y-m-01 00:00:00'));
	$end_month = new \DateTime(date('Y-m-01 00:00:00'));
	$end_month->modify( '+1 month');
}

$history = new \DateTime(date('Y-m-d 00:00:00'));
$history->modify( '-30 day');


$today = new \DateTime(date('Y-m-d 00:00:00'));
$data['start'] = $start_month->getTimestamp();
$data['end'] = $end_month->getTimestamp();
$data['today'] = $today->getTimestamp();

$currtm = $today->getTimestamp();
// find account is exist
$sql = "select * from cloud_account_book where `create_time` >= ? and `create_time` < ?";
$sql.= " and `ent_id` = ?";

try {
	$sth = $nidb->prepare($sql);

	$sth->bindParam(1, $data['start'], \PDO::PARAM_INT);
	$sth->bindParam(2, $data['end'], \PDO::PARAM_INT);
	$sth->bindParam(3, $ent->ent_id, \PDO::PARAM_INT);

	$sth->execute();
	$count = 0;
	while(($row = $sth->fetch(\PDO::FETCH_LAZY, \PDO::FETCH_ORI_NEXT))) {
		if($count > 0 && ($row->create_time >= $curdate && $row->create_time < $endate)) {
			if($row->action != 'refund')
				$data['income'][$count - 1] += $row->expense;
			else
				$data['expenditure'][$count - 1] += abs($row->expense);
			$data['count'][$count - 1]++;
		}
		else {
			$currtm = new \DateTime(date('Y-m-d 00:00:00', $row->create_time));
			$curdate = $currtm->getTimestamp();
			$endate = $curdate + 86400;

			array_push($data['timeaxis'], $curdate);
			array_push($data['count'], 1);

			if($row->action != 'refund') {
				array_push($data['income'], $row->expense);
				array_push($data['expenditure'], 0);
			}
			else {
				array_push($data['income'], 0);
				array_push($data['expenditure'], abs($row->expense));
			}
			$count++;
		}
	}
}
catch (\NiDBException $e) {
	set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
	json_error_exit(ERR_FAILURE, '操作失败！');
}

json_error_exit(ERR_OK, '', $data);
