<?php
namespace raas\apps\enterpise;

$appdir = dirname(dirname(__FILE__));
$appname = basename($appdir);
$appmethod = basename(__FILE__, '.php');

$token = $appname . '_' . $appmethod;


// 支持库装载 | load lib
// ni_library_load('nidb');

// 装载功能 | load function
ni_app_load('user', 'login');
ni_app_load($appname, 'info');


// 验证用户 | auth user
\raas\apps\user\_auth_json_exit($appname, 'list');


// 执行 | exec function
$ent = info($_REQUEST);


// 结果输出 | printf result
if($ent === false)
	json_error_exit(ERR_FAILURE, '操作失败！');

$data = array(
	'acctcnt'	=> $ent->acctcnt,
	'groupcnt'	=> $ent->groupcnt,
	'session'	=> 0,
	'expired'	=> 0,
	'atoexpire'	=> 0
);

// find account is exist
$sql = "select count(*) as `count` from cloud_account where `expire_time` <= ? and `disabled` < " . TB_ROW_DEL_VALUE;
$sql.= " and `ent_id` = ?";

try {
	$sth = $nidb->prepare($sql);

	$sth->bindParam(1, time(), \PDO::PARAM_INT);
	$sth->bindParam(2, $ent->ent_id, \PDO::PARAM_INT);

	$sth->execute();
	$row = $sth->fetch(\PDO::FETCH_LAZY);
}
catch (\NiDBException $e) {
	set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
	json_error_exit(ERR_FAILURE, '操作失败！');
}
if($row) {
	$data['expired'] = $row->count;
}

$today = new \DateTime(date('Y-m-d 00:00:00'));
$expire = new \DateTime(date('Y-m-d 00:00:00'));
$expire->add(new \DateInterval('P3D'));

// find account is exist
$sql = "select count(*) as `count` from cloud_account where `expire_time` > ? and `expire_time` < ?";
$sql.= " and `disabled` < " . TB_ROW_DEL_VALUE . " and `ent_id` = ?";

try {
	$sth = $nidb->prepare($sql);

	$sth->bindParam(1, $today->getTimestamp(), \PDO::PARAM_INT);
	$sth->bindParam(2, $expire->getTimestamp(), \PDO::PARAM_INT);
	$sth->bindParam(3, $ent->ent_id, \PDO::PARAM_INT);

	$sth->execute();
	$row = $sth->fetch(\PDO::FETCH_LAZY);
}
catch (\NiDBException $e) {
	set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
	json_error_exit(ERR_FAILURE, '操作失败！');
}
if($row) {
	$data['atoexpire'] = $row->count;
}

exec('/paraas/bin/raaseye session list entid=' . $ent->ent_id, $out);
if(is_array($out)) 
	$data['session'] = count($out) - 1;


json_error_exit(ERR_OK, '', $data);
