<?php
namespace raas\apps\enterpise;


function _finddomain($domain, $nodelete = 1)
{
	global $nidb;

	// set custom options
	$keys = '`ent_id`,
`own_id`,
`parent_id`,
`name`,
`domain`,
`disabled`,
`iwansvr`,
`groupcnt`,
`acctcnt`,
`usercnt`,
`account`,
`contact`,
`phone`,
`trafficon`,
`position_id`,
`province`,
`city`,
`district`,
`address`,
`remark`,
`update_time`,
`create_time`';


	$sql = "select $keys from cloud_enterpise where `domain` = ?";
	
	if($nodelete) $sql .= " and `disabled` < " . TB_ROW_DEL_VALUE;

	try {
		$sth = $nidb->prepare($sql);

		$index = 1;
		$sth->bindParam($index++, $domain, \PDO::PARAM_STR);

		$sth->execute();
		$rows = $sth->fetchAll(\PDO::FETCH_CLASS);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	if(count($rows) <= 0) {
		set_errmsg(MSG_LEVEL_DEF, __function__, "无效的项目。");
		return false;
	}
	
	return $rows[0];
}

function _find(string $name)
{
	global $nidb;

	// set custom options
	$keys = '`ent_id`,
`own_id`,
`parent_id`,
`name`,
`domain`,
`disabled`,
`iwansvr`,
`groupcnt`,
`acctcnt`,
`usercnt`,
`account`,
`contact`,
`phone`,
`position_id`,
`province`,
`city`,
`district`,
`address`,
`remark`,
`update_time`,
`create_time`';


	$sql = "select $keys from cloud_enterpise where `name` = ?";

	try {
		$sth = $nidb->prepare($sql);

		$index = 1;
		$sth->bindParam($index++, $name, \PDO::PARAM_STR);

		$sth->execute();
		$rows = $sth->fetchAll(\PDO::FETCH_CLASS);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	if(count($rows) <= 0) {
		set_errmsg(MSG_LEVEL_DEF, __function__, "无效的项目。");
		return false;
	}
	
	return $rows[0];
}

function find($data)
{
	global $nidb;

	$optional = array();

	$where_str = '';

	// set custom options
	if(format_and_push($data, 'name', $optional, '', 'string', false) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, 'err: name can\'t empty.');
		return false;
	}
	
	return _find($optional['name']);
}

