<?php
namespace raas\apps\enterpise;

// _ent_count_inc load
ni_app_load('counter', '_lib');
ni_app_load('entowner', '_lib');

function remove($data)
{
	global $nidb;

	$filter = array(
		'ent_id'	=> new \FilterVarID(true),
		'own_id'	=> new \FilterVarID(true),
	);
	if(($where = filter_data($data, $filter, $errmsg)) === false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, $errmsg);
		return false;
	}

	
	// is exist?
	$sql = "select `groupcnt`, `iwancnt`, `acctcnt`, `name` from cloud_enterpise where `ent_id` = ? and `disabled` < " . TB_ROW_DEL_VALUE;

	try {
		$sth = $nidb->prepare($sql);

		$index = 1;
		$sth->bindParam($index++, $where['ent_id'], \PDO::PARAM_INT);

		$sth->execute();
		$rows = $sth->fetchAll(\PDO::FETCH_CLASS);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}
	if(count($rows) <= 0) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '找不到此记录。');
		return false;
	}

	// have group or acctcnt ?
	$ent = $rows[0];
	if($ent->groupcnt != 0) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '请先将“' . $ent->name . '”中的用户组清空。');
		return false;
	}
	if($ent->iwancnt != 0) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '请先将“' . $ent->name . '”中的iWAN POP点清空。');
		return false;
	}
	if($ent->acctcnt != 0) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '请先将“' . $ent->name . '”中的用户清空。');
		return false;
	}
	
	$frmData['disabled'] = TB_ROW_DEL_VALUE;
	$frmData['update_time'] = time();

	$nidb->beginTransaction();
	try {
		if(update_data('cloud_enterpise', $frmData, $where) === false) {
			$errmsg = implode(' ', $nidb->errorInfo());
			set_errmsg(MSG_LEVEL_DEF, __function__, $errmsg);
			$nidb->rollBack();
			return false;
		}
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		$nidb->rollBack();
		return false;
	}
	
	if(\raas\apps\entowner\_ent_count_inc($where['own_id'], -1) === false) {
		$nidb->rollBack();
		return false;
	}
	if(\raas\apps\counter\_ent_count_inc(COUNTER_RAAS_ID, -1) === false) {
		$nidb->rollBack();
		return false;
	}

	// 更新操作员的计数器
	try {
		// 统计引用数
		// , count(*) as `cnt`
		$sql = "select group_concat(`user_id`) as `user_ids` from cloud_user_group_list where `ent_id` = ? group by `user_id`";
		$sth = $nidb->prepare($sql);
		$sth->bindParam(1, $where['ent_id'], \PDO::PARAM_INT);
		$sth->execute();
		$row = $sth->fetch(\PDO::FETCH_ASSOC);

		if($row && !empty($row['user_ids'])) {
			// 更新操作员的企业计数器
			$sql = 'update cloud_user set `entcnt` = `entcnt` - 1 where `user_id` in (' . $row['user_ids'] . ')';
			$sth = $nidb->prepare($sql);
			$sth->execute();
		}

		// 删除企业下的用户组关联
		$sql = 'delete from cloud_user_group_list where `ent_id` = ?';
		$sth = $nidb->prepare($sql);

		$sth->bindParam(1, $where['ent_id'], \PDO::PARAM_INT);
		$sth->execute();
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		$nidb->rollBack();
		return false;
	}

	$nidb->commit();
//	synclog_push(RA_SYNC_ENT, $where['ent_id']);
	raaseye_enterpise_remove($where['ent_id'], $where['own_id']);
	
	return true;
}

