<?php
namespace raas\apps\bindmac;

function remove($data)
{
	global $nidb;

	$filter = array(
		'own_id'	=> new \FilterVarID(true),
		'acct_id'	=> new \FilterVarID(true),
		'mac'		=> new \FilterVarStr(),
	);
	if(($where = filter_data($data, $filter, $errmsg)) === false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, $errmsg);
		return false;
	}
	
	if(preg_match("/^[A-Fa-f0-9]{1,2}\:[A-Fa-f0-9]{1,2}\:[A-Fa-f0-9]{1,2}\:[A-Fa-f0-9]{1,2}\:[A-Fa-f0-9]{1,2}\:[A-Fa-f0-9]{1,2}$/", $where['mac'], $match) == false
	&& preg_match("/^[A-Fa-f0-9]{1,2}\-[A-Fa-f0-9]{1,2}\-[A-Fa-f0-9]{1,2}\-[A-Fa-f0-9]{1,2}\-[A-Fa-f0-9]{1,2}\-[A-Fa-f0-9]{1,2}$/", $where['mac'], $match) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, 'MAC地址格式无效。');
		return false;
	}

	$nidb->beginTransaction();

	$frmData = array(
		'disabled' => TB_ROW_DEL_VALUE,
		'update_time' => time()
	);
	try {
		if(update_data('cloud_account_bindmac', $frmData, $where) === false) {
			$errmsg = implode(' ', $nidb->errorInfo());
			set_errmsg(MSG_LEVEL_DEF, __function__, $errmsg);
			return false;
		}
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}
	$nidb->commit();

	raaseye_acct_bindmac_reload(0);

	return true;
}

