<?php
namespace raas\apps\config\email;


function get()
{
	require_once(ROOT_DIR . "/conf/email.php");

	return array(
		'host'		=> NIMS_SMTP_HOST,
		'port'		=> NIMS_SMTP_PORT,
		'ssl'		=> (NIMS_SSL == 'ssl'?1:0),
		'user'		=> NIMS_SMTP_USER,
		'pass'		=> NIMS_SMTP_PASS
	);
}

function save($data)
{
	global $nidb;

	$filter = array(
		'host'		=> new \FilterVarStr(true),
		'port'		=> new \FilterVarInt(true),
		'ssl'		=> new \FilterVarInt(true),
		'user'		=> new \FilterVarEmail(true),
		'pass'		=> new \FilterVarStr(true)
	);

	if(($frmData = filter_data($data, $filter, $errmsg)) === false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, $errmsg);
		return false;
	}
	
	$ssl = ($frmData['ssl'] ? 'ssl' : '');
	
	$contents = "<?php
// ********************************************************
// email of config
// ********************************************************
define('NIMS_ON', true);
define('NIMS_MAIL_FROM', 'From Email');
define('NIMS_MAIL_FROM_NAME', 'From Name');
define('NIMS_MAILER', 'smtp'); // Possible values 'smtp', 'mail', or 'sendmail'
define('NIMS_SET_RETURN_PATH', 'false'); // Sets \$phpmailer->Sender if true
define('NIMS_SMTP_AUTH', true); // True turns on SMTP authentication, false turns it off

define('NIMS_SMTP_HOST', '{$frmData['host']}'); // The SMTP mail host
define('NIMS_SMTP_PORT', {$frmData['port']}); // The SMTP server port number
define('NIMS_SSL', '{$ssl}'); // Possible values '', 'ssl', 'tls' - note TLS is not STARTTLS
define('NIMS_SMTP_USER', '{$frmData['user']}'); // SMTP authentication username, only used if NIMS_SMTP_AUTH is true
define('NIMS_SMTP_PASS', '{$frmData['pass']}');
";
	$file = ROOT_DIR . "/conf/email.php";

	return file_put_contents($file, $contents);
}
