<?php
namespace raas\apps\counter;

/* 
 * 分组使用说明：
 * 1）分区是公司的一个子集
 * 2）分组是分区的一个子集
 * 3）帐号是分区、分组的一个具体成员
 * 4）在一个分区中，分组名称不能重名，必须是唯一的
 * 5）在一个分区中，帐号不能重名，必须是唯一的
 * 6）
 * 3）一个帐号只归属一个公司，即创建这个帐号的公司。
 * 4）一个帐号可以归属到不同的分区。
 * 5）在分区中，一个帐号只能归属一个分组。
 * 6）在公司中，
 *
 */


function _notif_count_inc($stat_id, $count)
{
	global $nidb;

	$sql = "update cloud_counter
			set `msgcnt` = `msgcnt` + ?
			where `stat_id` = ?";

	try {
		$sth = $nidb->prepare($sql);
		
		$index = 1;
		$sth->bindParam($index++, $count, \PDO::PARAM_INT);
		$sth->bindParam($index++, $stat_id, \PDO::PARAM_INT);
		
		$sth->execute();
		return $sth->rowCount();
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage()); 
	}
	
	return false;
}

function _iwacct_count_inc($stat_id, $count)
{
	global $nidb;

	$sql = "update cloud_counter
			set `iwacctcnt` = `iwacctcnt` + ?
			where `stat_id` = ?";

	try {
		$sth = $nidb->prepare($sql);
		
		$index = 1;
		$sth->bindParam($index++, $count, \PDO::PARAM_INT);
		$sth->bindParam($index++, $stat_id, \PDO::PARAM_INT);
		
		$sth->execute();
		return $sth->rowCount();
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage()); 
	}
	
	return false;
}

function _iwan_count_inc($stat_id, $count)
{
	global $nidb;

	$sql = "update cloud_counter
			set `iwancnt` = `iwancnt` + ?
			where `stat_id` = ?";

	try {
		$sth = $nidb->prepare($sql);
		
		$index = 1;
		$sth->bindParam($index++, $count, \PDO::PARAM_INT);
		$sth->bindParam($index++, $stat_id, \PDO::PARAM_INT);
		
		$sth->execute();
		return $sth->rowCount();
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage()); 
	}
	
	return false;
}

function _forgot_count_inc($stat_id, $count)
{
	global $nidb;

	$sql = "update cloud_counter
			set `forgotcnt` = `forgotcnt` + ?
			where `stat_id` = ?";

	try {
		$sth = $nidb->prepare($sql);
		
		$index = 1;
		$sth->bindParam($index++, $count, \PDO::PARAM_INT);
		$sth->bindParam($index++, $stat_id, \PDO::PARAM_INT);
		
		$sth->execute();
		return $sth->rowCount();
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage()); 
	}
	
	return false;
}

function _forgot2_count_inc($stat_id, $count)
{
	global $nidb;

	$sql = "update cloud_counter
			set `forgotcnt2` = `forgotcnt2` + ?
			where `stat_id` = ?";

	try {
		$sth = $nidb->prepare($sql);
		
		$index = 1;
		$sth->bindParam($index++, $count, \PDO::PARAM_INT);
		$sth->bindParam($index++, $stat_id, \PDO::PARAM_INT);
		
		$sth->execute();
		return $sth->rowCount();
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage()); 
	}
	
	return false;
}

function _register_count_inc($stat_id, $count)
{
	global $nidb;

	$sql = "update cloud_counter
			set `regcnt` = `regcnt` + ?
			where `stat_id` = ?";

	try {
		$sth = $nidb->prepare($sql);
		
		$index = 1;
		$sth->bindParam($index++, $count, \PDO::PARAM_INT);
		$sth->bindParam($index++, $stat_id, \PDO::PARAM_INT);
		
		$sth->execute();
		return $sth->rowCount();
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage()); 
	}
	
	return false;
}

function _regsuccess_count_inc($stat_id, $count)
{
	global $nidb;

	$sql = "update cloud_counter
			set `regsuccesscnt` = `regsuccesscnt` + ?
			where `stat_id` = ?";

	try {
		$sth = $nidb->prepare($sql);
		
		$index = 1;
		$sth->bindParam($index++, $count, \PDO::PARAM_INT);
		$sth->bindParam($index++, $stat_id, \PDO::PARAM_INT);
		
		$sth->execute();
		return $sth->rowCount();
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage()); 
	}
	
	return false;
}

function _entowner_count_inc($stat_id, $count)
{
	global $nidb;

	$sql = "update cloud_counter
			set `ownercnt` = `ownercnt` + ?
			where `stat_id` = ?";

	try {
		$sth = $nidb->prepare($sql);
		
		$index = 1;
		$sth->bindParam($index++, $count, \PDO::PARAM_INT);
		$sth->bindParam($index++, $stat_id, \PDO::PARAM_INT);
		
		$sth->execute();
		return $sth->rowCount();
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage()); 
	}
	
	return false;
}

function _ent_count_inc($stat_id, $count)
{
	global $nidb;

	$sql = "update cloud_counter
			set `entcnt` = `entcnt` + ?
			where `stat_id` = ?";

	try {
		$sth = $nidb->prepare($sql);
		
		$index = 1;
		$sth->bindParam($index++, $count, \PDO::PARAM_INT);
		$sth->bindParam($index++, $stat_id, \PDO::PARAM_INT);
		
		$sth->execute();
		return $sth->rowCount();
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage()); 
	}
	
	return false;
}

function _group_count_inc($stat_id, $count)
{
	global $nidb;

	$sql = "update cloud_counter
			set `groupcnt` = `groupcnt` + ?
			where `stat_id` = ?";

	try {
		$sth = $nidb->prepare($sql);
		
		$index = 1;
		$sth->bindParam($index++, $count, \PDO::PARAM_INT);
		$sth->bindParam($index++, $stat_id, \PDO::PARAM_INT);
		
		$sth->execute();
		return $sth->rowCount();
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage()); 
	}
	
	return false;
}


function _acct_count_inc($stat_id, $count)
{
	global $nidb;

	$sql = "update cloud_counter
			set `acctcnt` = `acctcnt` + ?
			where `stat_id` = ?";

	try {
		$sth = $nidb->prepare($sql);
		
		$index = 1;
		$sth->bindParam($index++, $count, \PDO::PARAM_INT);
		$sth->bindParam($index++, $stat_id, \PDO::PARAM_INT);
		
		$sth->execute();
		return $sth->rowCount();
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage()); 
	}
	
	return false;
}

function _user_count_inc($stat_id, $count)
{
	global $nidb;

	$sql = "update cloud_counter
			set `usercnt` = `usercnt` + ?
			where `stat_id` = ?";

	try {
		$sth = $nidb->prepare($sql);
		
		$index = 1;
		$sth->bindParam($index++, $count, \PDO::PARAM_INT);
		$sth->bindParam($index++, $stat_id, \PDO::PARAM_INT);
		
		$sth->execute();
		return $sth->rowCount();
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage()); 
	}
	
	return false;
}
