<?php
namespace raas\apps\enterpise;

function create($data)
{
	global $nidb;

	$filter = array(
		'org_id'	=> new \FilterVarInt(true),
		'name'		=> new \FilterVarStr(true),
		'secret'	=> new \FilterVarStr(),
		'disabled'	=> new \FilterVarInt(),
		'remark'	=> new \FilterVarStr(),
	);
	if(($frmData = filter_data($data, $filter, $errmsg)) === false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, $errmsg);
		return false;
	}
	if(empty($frmData['name'])) {
		set_errmsg(MSG_LEVEL_ARG, __function__, 'err: name can\'t empty.');
		return false;
	}

	$frmData['update_time'] = time();
	$frmData['create_time'] = $frmData['update_time'];

	try {

		if(insert_data('cloud_enterpise', $frmData) === false) {
			$errmsg = implode(' ', $nidb->errorInfo());
			set_errmsg(MSG_LEVEL_DEF, __function__, $errmsg);
			return false;
		}
		$frmData['dom_id'] = $nidb->lastInsertId();
	}
	catch (PDOException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	return $frmData;
}

