<?php
namespace raas\apps\enterpise;

function disable($data)
{
	global $nidb;

	$filter = array(
		'ent_id'	=> new \FilterVarInt(true),
		'org_id'	=> new \FilterVarInt(true),
	);
	if(($where = filter_data($data, $filter, $errmsg)) === false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, $errmsg);
		return false;
	}

	$frmData['disabled'] = 1;
	$frmData['update_time'] = time();

	try {
		if(update_data('cloud_enterpise', $frmData, $where) === false) {
			$errmsg = implode(' ', $nidb->errorInfo());
			set_errmsg(MSG_LEVEL_DEF, __function__, $errmsg);
			return false;
		}
	}
	catch (PDOException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	return true;
}

