<?php
namespace raas\apps\enterpise;

function save($data)
{
	global $nidb;

	$filter = array(
		'ent_id'	=> new \FilterVarInt(true),
		'org_id'	=> new \FilterVarInt(true),
		'name'		=> new \FilterVarStr(),
		'secret'	=> new \FilterVarStr(),
		'disabled'	=> new \FilterVarInt(),
		'remark'	=> new \FilterVarStr(),
	);
	if(($frmData = filter_data($data, $filter, $errmsg)) === false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, $errmsg);
		return false;
	}

	$frmData['update_time'] = time();
	
	$where = array(
		'ent_id'	=>	$frmData['ent_id'],
		'org_id'	=>	$frmData['org_id'],
	);
	unset($frmData['ent_id']);
	unset($frmData['org_id']);

	if(count($frmData) <= 0) {
		set_errmsg(MSG_LEVEL_DEF, __function__, "修改已放弃！无任何内容需要保存。");
		return false;
	}

	try {
		if(update_data('cloud_enterpise', $frmData, $where) === false) {
			$errmsg = implode(' ', $nidb->errorInfo());
			set_errmsg(MSG_LEVEL_DEF, __function__, $errmsg);
			return false;
		}
	}
	catch (PDOException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	return true;
}

