function dateFormatter(data, type, row, meta) {
	return $.myTime.UnixToStrDate(data, true);
}
function ipFormatter(data, type, row, meta) {
	return _int2iP(data);
}
function iprangeFormatter(data, type, row, meta) {
	var str = [];

	if(row.startip == '')
		str.push('0.0.0.0');
	else
		str.push(row.startip);

	if(row.startip == '')
		str.push('0.0.0.0');
	else
		str.push(row.endip);

	return str.join(' - ');
}
function clntepaFormatter(data, type, row, meta) {
	if(row.clntepa == 'reject')
		return '不允许登陆';

	if(row.clntepa == 'login')
		return '可登陆但不能上网';

	if(row.clntepa == 'pass')
		return '可登陆也可上网';

	return '';
}
$(document).ready(function(){
	App.init();

	$(".datetimepicker").datetimepicker(OPTIONS_CONSTANT.DATA_DATETIMEPICKER);
	
	var $table = $('#tablelist').DataTable($.extend(true,{},OPTIONS_CONSTANT.DATA_TABLES.DEFAULT_OPTION, {
		pageLength: 10,
		displayLength: 20,
		buttons: [
			{
				text: '创建',
				className: 'btn-primary',
				action: function ( e, dt, node, config ) {
					// window.location.href = 'index.php?r=enterpise@create';
					showAjaxModal('create_enterpise', {
						content:{
							ajax: {
								url: 'modal.php?r=enterpise@create',
							}
						},
						options:{
							data: {
								success: function(e, d, msg){
									$table.ajax.reload();
								}
							}
						}
					}, true, 'modal-bgcolor modal-effect-16');
				}
			}
		],
		columns: [
			{
				title: '索引',
				data: 'index_js_id',
				width: 30,
				searchable: false,
				orderable: false,
				render: function(data, type, row, meta) {
					return meta.row + 1;
				}
			},
			{
				title: '名称',
				data: "name",
				width: 100
			},
			{
				title: '联系人',
				data: "contact",
				width: 60
			},
			{
				title: '分组数',
				data: "groupcnt",
				width: 60,
			},
			{
				title: '用户数',
				data: "acctcnt",
				width: 60
			},
			{
				title: '操作员',
				data: "usercnt",
				width: 60
			},
			{
				title: '最后更新',
				data: "update_time",
				width: 120,
				render: dateFormatter
			},
			{
				title: '创建时间',
				data: "create_time",
				width: 120,
				render: dateFormatter
			},
			{
				title: "操作",
				orderable: false,
				data: null,
				width: 30,
				defaultContent: '<div class="row"><div class="icon-container icon-td col-md-6">\
									<div class="icon btn-edit"><span class="mdi mdi-edit"></span></div>\
								</div>\
								<div class="icon-container icon-td col-md-6">\
									<div class="icon btn-del"><span class="mdi mdi-delete"></span></div>\
								</div></div>'
			}],
		createdRow: function( row, data, dataIndex ) {
			var id = getURL_val('id');
			if ( data.enable == 0)
				$(row).addClass('row-disabled');
			if ( data.group_id == id)
				$(row).addClass('row-select');
		},
		fnDrawCallback: function (data) {
			$(":checkbox[name='cb-check-all']").prop('checked', false);
			//默认选中第一行
			$("tbody tr", $table).eq(0).click();

/*
			$('#tablelist tbody td.selectTd').editable('editable.php');
			$('#tablelist tbody td.inputTd').editable('api.php?r=account@list',
			{
				//data:{"10":"10","20":"20","30":"30"},
				data   : '{"E":"Letter E","F":"Letter F","G":"Letter G", "selected":"F"}',
				type: 'text',
				submit : '确定',
				submitdata: { _method: "post"},
				onblur    : "ignore",
				cancel    : '取消',
				cssclass : 'form-group',
				cancelcssclass : 'btn btn-space btn-danger',
				submitcssclass : 'btn btn-space btn-success',
				formid : 'abc-123',
				onedit : function() { console.log('If I return false edition will be canceled'); return true;},
				before : function() { console.log('Triggered before form appears')},
				callback : function(result, settings, submitdata) {
					console.log('Triggered after submit');
					console.log('Result: ' + result);
					console.log('Settings.width: ' + settings.width);
					console.log('Submitdata: ' + submitdata.pwet);
				},
			});
*/
		},
		footerCallback: function (row, data, start, end, display ) {
			var api = this.api(), data;
			// Remove the formatting to get integer data for summation
			var intVal = function ( i ) {
				return typeof i === 'string' ?
					i.replace(/[\$,]/g, '')*1 :
					typeof i === 'number' ?
						i : 0;
			};
 /*
			// Total over all pages
			total = api
				.column( 4 )
				.data()
				.reduce( function (a, b) {
					return intVal(a) + intVal(b);
				} );
 
			// Total over this page
			pageTotal = api
				.column( 4, { page: 'current'} )
				.data()
				.reduce( function (a, b) {
					return intVal(a) + intVal(b);
				}, 0 );
 
			// Update footer
			$( api.column( 4 ).footer() ).html(
				'$'+pageTotal +' ( $'+ total +' total)'
			);
*/
		},
		ajax: $.extend(true, {}, OPTIONS_CONSTANT.DATA_TABLES.AJAX, {
			url: 'api.php?r=enterpise@list',
			data: function (d) {
				var form_date = $.trim($('#form_date').val()), 
					to_date = $.trim($('#form_date').val()), 
					search = $.trim($('#search_val').val());
				
				if(search != '') d.search.value = search;
				if(form_date != '') d.form_date = form_date;
				if(to_date != '') d.to_date = to_date;

				return $.extend({}, d, {
					extra_search: $('#extra').val()
				});
			},
		})
	})).on('xhr.dt', function ( e, settings, json, xhr ) {
		// Note no return - manipulate the data directly in the JSON object.
	}).on("change", ":checkbox", function() {
        if($(this).is("[name='cb-check-all']")) {
            //全选
            $(":checkbox", $('#tablelist')).prop("checked",$(this).prop("checked"));
        }else{
            //一般复选
            var checkbox = $("tbody :checkbox", $('#tablelist'));
            $(":checkbox[name='cb-check-all']", $('#tablelist')).prop('checked', checkbox.length == checkbox.filter(':checked').length);
        }
    }).on("click", ".td-checkbox", function(event) {
        !$(event.target).is(":checkbox") && $(":checkbox",this).trigger("click");
    }).on("click", ".btn-edit", function() {
        $(this).closest('tr').addClass("active").siblings().removeClass("active");
        // window.location.href = 'index.php?r=enterpise@edit&id=' + item.group_id;
		showAjaxModal('edit_enterpise', {
			content:{
				ajax: {
					url: 'modal.php?r=enterpise@edit',
				}
			},
			options:{
				data: {
					data: function(e) {
						return $table.row($('#tablelist').find('tr.active')).data();
					},
					success: function(e, d, msg){
						$table.ajax.reload();
					}
				}
			}
		}, true, 'modal-bgcolor modal-effect-16');
    }).on("click", ".btn-del", function() {
        var item = $table.row($(this).closest('tr')).data();
        $(this).closest('tr').addClass("active").siblings().removeClass("active");
		showAjaxModal('itemdel', {
			content: {
				body: {
					content: [
						'<div class="text-center">',
						'<h3>用户组删除!</h3>',
						'<p>您是否要继续删除“<span style="color: #ea4335; font-weight: 700;">' + item.name + '</span>”用户组，确认后将无法找回！</p>',
						'<div class="mt-4">',
                            '<button type="button" data-dismiss="modal" class="btn btn-secondary btn-space modal-close btn-cancel">否</button>',
                            '<button type="button" data-dismiss="modal" class="btn btn-success btn-space modal-close btn-ok">是</button>',
						'</div>',
						'</div>'
					].join('')
				},
			},
			options: {
				data: item,
				buttons: [
				  {
					class: 'btn-ok',
					callback: function ( btn, modal, event ) {
					  //You can cancel the modal hide event by returning false
						var params = {ent_id: item.ent_id};
						ajaxgo({
							type: 'POST',
							url: 'api.php?r=enterpise@remove',
							data: params
						},
						function (d, msg){
							// success reload
							$table.ajax.reload();
						});
						return true;
					}
				  }
				]
			}
		});
    }).on("click", ".edit-btn", function() {
		var tds = $(this).parents("tr").children();
		$.each(tds, function(i,val){
			var jqob = $(val);
			if(i < 2 || jqob.has('button').length ){return true;}//跳过第1项 序号,按钮
			var txt=jqob.text();
			var put=$("<input type='text'>");
			put.val(txt);
			jqob.html(put);
		});
		$(this).html("保存");
		$(this).toggleClass("edit-btn");
		$(this).toggleClass("save-btn");
	});

	$('#search_btn').click(function(){
		$table.draw();
	});
/*
	var lastIdx = null;
	$('#tablelist').on( 'mouseover', 'td', function () {
		var colIdx = $('#tablelist').cell(this).index().column;
		if ( colIdx !== lastIdx ) {
			$( $('#tablelist').cells().nodes() ).removeClass( 'column-hover' );
			$( $('#tablelist').column( colIdx ).nodes() ).addClass( 'column-hover' );
		}
	}).on( 'mouseleave', function () {
		$( $('#tablelist').cells().nodes() ).removeClass( 'column-hover' );
	});
*/
});
