<?php
namespace raas\apps\enterpise;

// _ent_count_inc load
ni_app_load('counter', '_lib');

function create($data)
{
	global $nidb;

	$filter = array(
		'parent_id'	=> new \FilterVarID(),
		'name'		=> new \FilterVarStr(true),
		'secret'	=> new \FilterVarStr(),
		'disabled'	=> new \FilterVarInt(),
		'account'	=> new \FilterVarStr(true),
		'contact'	=> new \FilterVarStr(),
		'phone'		=> new \FilterVarStr(),
		'remark'	=> new \FilterVarStr(),
	);
	if(($frmData = filter_data($data, $filter, $errmsg)) === false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, $errmsg);
		return false;
	}
	if(empty($frmData['name'])) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '名称不能为空！');
		return false;
	}
	if(empty($frmData['account'])) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '管理帐号不能为空！');
		return false;
	}

	$frmData['update_time'] = time();
	$frmData['create_time'] = $frmData['update_time'];

	$nidb->beginTransaction();
	try {

		if(insert_data('cloud_enterpise', $frmData) === false) {
			$errmsg = implode(' ', $nidb->errorInfo());
			set_errmsg(MSG_LEVEL_DEF, __function__, $errmsg);
			$nidb->rollBack();
			return false;
		}
		$frmData['ent_id'] = $nidb->lastInsertId();
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		$nidb->rollBack();
		return false;
	}

	
	if(\raas\apps\counter\_ent_count_inc(COUNTER_RAAS_ID, 1) === false) {
		$nidb->rollBack();
		return false;
	}

	$nidb->commit();
//	synclog_push(RA_SYNC_ENT, $frmData['ent_id']);

	return $frmData;
}

