<?php
namespace raas\apps\enterpise;


function _info(int $ent_id)
{
	global $nidb;

	// `secret`, 
	$keys = '`ent_id`, `parent_id`, `name`, `disabled`,
`groupcnt`, `acctcnt`, `usercnt`, `account`, `contact`,
`phone`, `update_time`, `create_time`';

	$sql = "select $keys from cloud_enterpise where `ent_id` = ?";

	try {
		$sth = $nidb->prepare($sql);

		$index = 1;
		$sth->bindParam($index++, $ent_id, \PDO::PARAM_INT);
		
		$sth->execute();
		$rows = $sth->fetchAll(\PDO::FETCH_CLASS);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	if(count($rows) <= 0) {
		set_errmsg(MSG_LEVEL_DEF, __function__, "无效的记录。");
		return false;
	}
	
	return $rows[0];
}

function info($data)
{
	global $nidb;

	$optional = array();

	// set custom options
	if(format_and_push($data, 'ent_id', $optional, '', 'int', false) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, 'err: ent_id can\'t empty.');
		return false;
	}
	return _info($optional['ent_id']);
}

