/*!
 * jquery.jqDBSource v1
 * Copyright 2018 qin.chenglin 
 */

;(function($) {
  'use strict';

  var defaults = {
    closeSelector: '.md-close',
    contentSelector: '.md-content',
    classAddAfterOpen: 'md-show',
    classScrollbarMeasure: 'md-scrollbar-measure',
    classModalOpen: 'md-open',
    data: false,
    buttons: false,
    beforeOpen: false,
    afterOpen: false,
    beforeClose: false,
    afterClose: false
	oninit: false,
  };

  $.fn.jqDBSource = function(method) {

    var config = {
		limit: 20,
	};
	var qdraw = 0;
    var result = {
		draw: 0,
		rows: [],
		total: 0
	};

    var helpers = {
		removeModal: function( el ) {
			var mod = $( el );
			mod.removeClass( config.classAddAfterOpen );
			mod.css({'perspective':'1300px'});
			//Remove body open modal class
			body.removeClass(config.classModalOpen);
			//Reset body scrollbar padding
			helpers.resetScrollbar();
			mod.trigger('hide');
		},
		init: function(el) {
			
		},
		refresh: function(el) {
			var target = $(el);

			//After open event
			if( typeof config.afterOpen === 'function' ){
				config.afterOpen( modal );
			}

			setTimeout( function() {
				target.css({'perspective':'none'});
			}, 500 ); 

			//Close Event
			close.on( 'click', function( ev ) {
				var btn = $(this);
				modal.closeEl = close.get( 0 );

				//Before close event
				if( typeof config.beforeClose === 'function' ) {
					if( config.beforeClose(modal, ev) === false ) {
						return false;
					}
				}  

				//Buttons callback
				if( config.buttons && $.isArray( config.buttons ) ){
				var cancel = true;

				$.each(config.buttons, function( i, v){
				if( btn.hasClass( v.class ) && typeof v.callback === 'function' ){
				cancel = v.callback( btn.get( 0 ), modal, ev);
				}
				});

				if( cancel === false && typeof cancel !== undefined ){
				return false;
				}
				}  

				helpers.removeModal( el );
				close.off('click');

				//After close event
				if( typeof config.afterClose === 'function' ){
				config.afterClose( modal, ev);
				}

				ev.stopPropagation();
			});

			target.trigger('show');
		}

	};

    var methods = {
		init : function( options ) {
			return this.each(function() {
				config = $.extend({}, defaults, options);

				modal.dbEl = this;

				if( config.data !== false ) {
					modal.data = options.data;
				}
			
				// on init event
				if(typeof config.oninit === 'function') {
					if(config.oninit($(this)) === false){
						return;
					}
				}
				helpers.refresh(this);
			});
		},
		toggle: function(options) {
			return this.each(function() {
				config = $.extend({}, defaults, options);
				var modal = $(this);
				if(modal.hasClass(config.classAddAfterOpen)){
					helpers.removeModal(modal);
				}else{
					helpers.refresh(modal);
				}
			});
		},
		show: function(options) {
			config = $.extend({}, defaults, options);
			return this.each(function() {
				var mod = $( this );
				//refresh the modal
				helpers.refresh(mod);
			});
		},
      hide: function(options) {
        config = $.extend({}, defaults, options);
        return this.each(function() {
          helpers.removeModal($(this));  
        });            
      },
      setDefaults: function( options ) {
        defaults = $.extend({}, defaults, options);
      },
      getDefaults: function( ) {
        return defaults;
      }
    };

    if (methods[method]) {
        return methods[method].apply(this, Array.prototype.slice.call(arguments, 1));
    } else if (typeof method === 'object' || !method) {
        return methods.init.apply(this, arguments);
    } else {
        $.error( 'Method "' +  method + '" does not exist in jqDBSource plugin!');
    }

  };

})(jQuery);

/**
 * Self execute to support previous versions with 'md-trigger' class & data-modal attribute
 */

$('.md-trigger').on('click',function(){
  var modal = $(this).data('modal');
  $("#" + modal).niftyModal();
});