<?php
namespace raas\apps\enterpise;

// _ent_count_inc load
ni_app_load('counter', '_lib');
ni_app_load('entowner', '_lib');
ni_app_load('enterpise', 'find');


function _create($frmData)
{
	global $nidb;


	$frmData['update_time'] = time();
	$frmData['create_time'] = $frmData['update_time'];

	try {

		if(insert_data('cloud_enterpise', $frmData) === false) {
			$errmsg = implode(' ', $nidb->errorInfo());
			set_errmsg(MSG_LEVEL_DEF, __function__, $errmsg);
			return false;
		}
		$frmData['ent_id'] = $nidb->lastInsertId();
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	if(\raas\apps\entowner\_ent_count_inc($frmData['own_id'], 1) === false) 
		return false;

	if(\raas\apps\counter\_ent_count_inc(COUNTER_RAAS_ID, 1) === false)
		return false;

	return $frmData;
}

function create($data)
{
	global $nidb;

	$filter = array(
		'parent_id'	=> new \FilterVarID(),
		'own_id'	=> new \FilterVarID(true),
		'name'		=> new \FilterVarStr(true),
		'domain'	=> new \FilterVarStr(true),
		'secret'	=> new \FilterVarStr(true),
		'disabled'	=> new \FilterVarInt(),
		'trafficon'	=> new \FilterVarInt(),
		'admin'		=> new \FilterVarStr(), // 项目负责人
		'account'	=> new \FilterVarStr(),
		'contact'	=> new \FilterVarStr(),
		'phone'		=> new \FilterVarStr(),
		'position_id'=> new \FilterVarID(),
		'province'	=> new \FilterVarStr(),
		'city'		=> new \FilterVarStr(),
		'district'	=> new \FilterVarStr(),
		'address'	=> new \FilterVarStr(),
	);
	if(($frmData = filter_data($data, $filter, $errmsg)) === false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, $errmsg);
		return false;
	}
	if(empty($frmData['name'])) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '项目名称不能为空！');
		return false;
	}
	if(($ent = _find($frmData['name'])) !== false && $ent->disabled < TB_ROW_DEL_VALUE) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '“' . $frmData['name'] . '”项目名已存在，请更换！');
		return false;
	}

	if(empty($frmData['domain'])) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '项目域名不能为空！');
		return false;
	}
	if(preg_match("/^([a-zA-Z0-9-_.]{2,})$/", $frmData['domain'], $match) == false) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '项目域名格式不正确！格式应为：a-z，A-Z，0-9和“.”，“_”，至少2位字符组成。');
		return false;
	}

	if(($ent = _finddomain($frmData['domain'])) !== false && $ent->disabled < TB_ROW_DEL_VALUE) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '“' . $frmData['domain'] . '”域名已被使用，请更换！');
		return false;
	}
	set_errmsg(MSG_LEVEL_DEF, __function__, '');

	$nidb->beginTransaction();
	
	if(($frmData = _create($frmData)) === false) {
		$nidb->rollBack();
		return false;
	}

	$nidb->commit();
//	synclog_push(RA_SYNC_ENT, $frmData['ent_id']);
	raaseye_enterpise_add($frmData);

	return $frmData;
}

