<?php
namespace raas\apps\enterpise;

ni_app_load('group', 'create');
ni_app_load('group', 'list');
ni_app_load('group', 'info');
ni_app_load('enterpise', 'info');
ni_app_load('account', 'create');
ni_app_load('account', 'save');

// function
function _getpagid($pagid, $ent_id)
{
	global $nidb, $user;

	// set custom options
	$where_str = "where `disabled` < " . TB_ROW_DEL_VALUE . " and `pagid` = ?";
	$where_str .= " and `ent_id` = ? and `own_id` = ?";

	$sql = "select * from cloud_group $where_str";

	try {
		$sth = $nidb->prepare($sql);

		$index = 1;
		$own_id = $user->own_id;
		$sth->bindParam($index++, $pagid, \PDO::PARAM_INT);
		$sth->bindParam($index++, $ent_id, \PDO::PARAM_INT);
		$sth->bindParam($index++, $own_id, \PDO::PARAM_INT);

		$sth->execute();
		$rows = $sth->fetchAll(\PDO::FETCH_CLASS);
	}
	catch (NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	if(count($rows) <= 0) {
		set_errmsg(MSG_LEVEL_DEF, __function__, "无效的分组。");
		return false;
	}
	
	return $rows[0];
}

function _export_account_from_panabit($ent_id, $group_id, $charset)
{
	global $user, $nidb;
	
	$result = array(
		'groupcnt'	=> 0,
		'acctcnt'	=> 0,
		'acctmax'	=> 0,
		'error'		=> array(),
		'err'		=> '',
		'downlink'	=> '',
	);
	
	if(\raas\apps\enterpise\info(array('ent_id' => $ent_id, 'own_id' => $user->own_id)) === false) {
		array_push($result['error'], '找不到指定要导入的项目。');
		return $result;
	}

	$data = array();
	if($group_id > 0) {
		if(($grp = \raas\apps\group\info(array('ent_id' => $ent_id, 'group_id' => $group_id))) == false) {
			array_push($result['error'], '无效的用户组。');
			return $result;
		}
		if($grp->own_id != $user->own_id) {
			array_push($result['error'], '找不到该用户组。');
			return $result;
		}

		array_push($data, $grp);
	}
	else {
		$sql = "select * from cloud_group where `disabled` < " . TB_ROW_DEL_VALUE . " and `ent_id` = $ent_id";

		try {
			$sth = $nidb->prepare($sql);
			$sth->execute();
			$data = $sth->fetchAll(\PDO::FETCH_CLASS);
		}
		catch (\NiDBException $e) {
			set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
			return false;
		}

		if(count($data) <= 0) 
			return $result;
	}
	
	$result['groupcnt'] = count($data);
	if($result['groupcnt'] == 0) 
		return $result;

	$savefile = dirname(__DIR__) . '/panabit.conf';
	$fd = fopen($savefile . '.tmp', 'w');
	if(!$fd) {
		array_push($result['error'], '创建导出文件失败！');
		return $result;
	}
	$result['downlink'] = substr($savefile, strlen(ROOT_DIR) + 1);
	
	
	$pagidcurr = 1;
	$pagid = array();
	$gids = array();
	foreach($data as $grp) {
		$pagid[$grp->group_id] = $pagidcurr++;
		array_push($gids, $grp->group_id);

		if($charset == 'gb2312')
			$grp->name = iconv('UTF-8', 'GB2312', $grp->name);

		$line = 'g id=' . $pagid[$grp->group_id] . ' name=' . $grp->name;
		$line.= ' start=' . long2ip($grp->startip) ;
		$line.= ' end=' . long2ip($grp->endip) ;
		$line.= ' ratein=' . $grp->rate_in ;
		$line.= ' rateout=' . $grp->rate_out ;
		$line.= ' maxonlinetime=' . $grp->maxonlinetm ;
		$line.= ' ifname=' . $grp->ifname ;

		fwrite($fd, "$line\n");
	}

	$sql = "select * from cloud_account where `disabled` < " . TB_ROW_DEL_VALUE . " and `ent_id` = $ent_id and `group_id` in (" . implode(',', $gids) . ")";
	try {
		$sth = $nidb->prepare($sql, array(\PDO::ATTR_CURSOR => \PDO::CURSOR_SCROLL));

		$sth->execute();
		
		while ($row = $sth->fetch(\PDO::FETCH_ASSOC, \PDO::FETCH_ORI_NEXT)) {
			$row = (object)$row;
			if($charset == 'gb2312') {
				$row->account	= iconv('UTF-8', 'GB2312', $row->account);
				$row->pass		= iconv('UTF-8', 'GB2312', $row->pass);
				$row->name		= iconv('UTF-8', 'GB2312', $row->name);
				$row->idcard	= iconv('UTF-8', 'GB2312', $row->idcard);
				$row->phone		= iconv('UTF-8', 'GB2312', $row->phone);
				$row->remark	= iconv('UTF-8', 'GB2312', $row->remark);
			}

			$line = "u g=" . $pagid[$row->group_id] . " n=" . $row->account;
			$line.= " p=" . $row->pass . " b=" . $row->create_time;
			$line.= " s=" . date('Y-m-d', $row->start_time) . " e=" . date('Y-m-d', $row->expire_time);
			$line.= " ip=" . long2ip($row->bind_ipv4) . " mac=" . str_replace(':', '-', $row->bind_v4mac);
			$line.= " maxonline=" . $row->maxcnt . " outvlan=" . $row->bind_vlan;
			$line.= " m=0;" . $row->name;
			$line.= ";" . $row->idcard;
			$line.= ";" . $row->phone;
			$line.= ";" . $row->remark;

			fwrite($fd, "$line\n");

			$result['acctcnt']++;
			$result['acctmax']++;
		}
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		fclose($fd);
		return false;
	}
	fclose($fd);
	
	rename($savefile . '.tmp', $savefile);

	return $result;
}

function _export_account_from_csv($ent_id, $group_id, $charset)
{
	global $user, $nidb;
	
	$result = array(
		'groupcnt'	=> 0,
		'acctcnt'	=> 0,
		'acctmax'	=> 0,
		'error'		=> array(),
		'err'		=> '',
		'downlink'	=> '',
	);
	
	if(\raas\apps\enterpise\info(array('ent_id' => $ent_id, 'own_id' => $user->own_id)) === false) {
		array_push($result['error'], '找不到指定要导入的项目。');
		return $result;
	}

	$data = array();
	if($group_id > 0) {
		if(($grp = \raas\apps\group\info(array('ent_id' => $ent_id, 'group_id' => $group_id))) == false) {
			array_push($result['error'], '无效的用户组。');
			return $result;
		}
		if($grp->own_id != $user->own_id) {
			array_push($result['error'], '找不到该用户组。');
			return $result;
		}

		array_push($data, $grp);
	}
	else {
		$sql = "select * from cloud_group where `disabled` < " . TB_ROW_DEL_VALUE . " and `ent_id` = $ent_id";

		try {
			$sth = $nidb->prepare($sql);
			$sth->execute();
			$data = $sth->fetchAll(\PDO::FETCH_CLASS);
		}
		catch (\NiDBException $e) {
			set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
			return false;
		}

		if(count($data) <= 0) 
			return $result;
	}
	
	$result['groupcnt'] = count($data);
	if($result['groupcnt'] == 0) 
		return $result;

	$grps = array();
	$gids = array();

	foreach($data as $grp) {
		array_push($gids, $grp->group_id);
		if(isset($grps[$grp->group_id]) == false) 
			$grps[$grp->group_id] = $grp->name;
	}
	
	$savefile = dirname(__DIR__) . '/panabit.csv';
	$fd = fopen($savefile . '.tmp', 'w');
	if(!$fd) {
		array_push($result['error'], '创建导出文件失败！');
		return $result;
	}

	$result['downlink'] = substr($savefile, strlen(ROOT_DIR) + 1);
	
	$keys = " `account`, 
		`pass`,
		`create_time`, 
		`start_time`, 
		`expire_time`,
		`group_id`,
		`bind_ipv4`, 
		`bind_v4mac`,
		`bind_vlan`,
		`maxcnt`, 
		`pxyacct`,
		`pxypass`,
		`pxyvlan_in`,
		`pxyvlan_out`,
		`name`,
		`remark`,
		`idcard`,
		`phone`";
/*
	$expkey = array('#帐号', '密码', '创建时间', '开始时间', '到期时间', '用户组', '绑定IP', '绑定MAC', '绑定VLAN', '最大在线数', '代拨账号', '代拨密码', '代拨VLAN内', '代拨VLAN外', '姓名', '备注', '身份证', '联系电话');
	if($charset == 'gb2312') {
		foreach($expkey as $key => $val)
			$expkey[$key] = iconv('UTF-8', 'GB2312', $val);
	}
	// fwrite($fd, implode(',', $expkey));
	fputcsv($fd, $expkey);
*/
	$sql = "select {$keys} from cloud_account where `disabled` < " . TB_ROW_DEL_VALUE . " and `ent_id` = {$ent_id} and `group_id` in (" . implode(',', $gids) . ")";
	try {

		$sth = $nidb->prepare($sql, array(\PDO::ATTR_CURSOR => \PDO::CURSOR_SCROLL));

		$sth->execute();

		while ($row = $sth->fetch(\PDO::FETCH_ASSOC, \PDO::FETCH_ORI_NEXT)) {
			if(isset($grps[$row['group_id']])) {
				$row['group_id'] = $grps[$row['group_id']];
				
				$row['create_time'] = date('Y-m-d', $row['create_time']);
				$row['start_time'] = date('Y-m-d', $row['start_time']);
				$row['expire_time'] = date('Y-m-d', $row['expire_time']);

				if($charset == 'gb2312') {
					$row['group_id']= iconv('UTF-8', 'GB2312', $row['group_id']);
					$row['account'] = iconv('UTF-8', 'GB2312', $row['account']);
					$row['pass']	= iconv('UTF-8', 'GB2312', $row['pass']);
					$row['pxyacct'] = iconv('UTF-8', 'GB2312', $row['pxyacct']);
					$row['name']	= iconv('UTF-8', 'GB2312', $row['name']);
					$row['remark']	= iconv('UTF-8', 'GB2312', $row['remark']);
					$row['idcard']	= iconv('UTF-8', 'GB2312', $row['idcard']);
					$row['phone']	= iconv('UTF-8', 'GB2312', $row['phone']);
				}
				//fwrite($fd, implode(',', $row));
				fputcsv($fd, array_values($row));

				$result['acctcnt']++;
			}
			$result['acctmax']++;
		}

		$sth = $nidb->prepare($sql, array(\PDO::ATTR_CURSOR => \PDO::CURSOR_SCROLL));

		$sth->execute();
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		fclose($fd);
		return false;
	}
	fclose($fd);
	
	rename($savefile . '.tmp', $savefile);

	return $result;
}
