<?php
namespace raas\apps\enterpise;


function select($data)
{
	global $nidb;
	global $user;

	$values = array();
	$optional = array();
	// set order, limit, offset value
	format_list_arg($data, $optional);

	$where_str = '';
	if(format_and_push($data, 'disabled', $optional, '', 'int', false))
		$where_str .= "`disabled` = " . $optional['disabled'] . " and ";
	else
		$where_str .= "`disabled` < " . TB_ROW_DEL_VALUE . " and ";

	if(format_and_push($data, 'upstartm', $optional, '', 'int', false))
		$where_str .= "`update_time` >= " . $optional['upstartm'] . " and ";

	if(format_and_push($data, 'endtm', $optional, '', 'int', false)) 
		$where_str .= "`update_time` < " . $optional['upendtm']  . " and ";

	if(format_and_push($data, 'startm', $optional, '', 'int', false))
		$where_str .= "`create_time` >= " . $optional['startm'] . " and ";

	if(format_and_push($data, 'endtm', $optional, '', 'int', false))
		$where_str .= "`create_time` < " . $optional['endtm']  . " and ";

	// set custom options
	if(format_and_push($data, 'iwansvr', $optional, '', 'int', false))
		$where_str .= "`iwansvr` = " . $optional['iwansvr']  . " and ";
	
	if(format_and_push($data, 'ent_id', $optional, '', 'int', false))
		$where_str .= "`ent_id` = " . $optional['ent_id']  . " and ";

	if(format_and_push($data, 'ids', $optional, '', 'array', false)) {
		foreach($optional['ids'] as $key => $val)
			$optional['ids'][$key] = intval($val);
		if(($ids = implode(',', $optional['ids'])) != "");
			$where_str .= "`ent_id` in (" . $ids . ") and ";
	}
	
	if(format_and_push($data, 'own_id', $optional, '', 'int', false))
		$where_str .= "`own_id` = " . $optional['own_id']  . " and ";

	if(format_and_push($data, 'account', $optional, '', 'string', false)) {
		$where_str .= "`account` = ? and ";
		array_push($values, $optional['account']);
	}
	
	if(format_and_push($data, 'admin', $optional, '', 'string', false)) {
		$where_str .= "`admin` = ? and ";
		array_push($values, $optional['admin']);
	}
	
	if(format_and_push($data, 'phone', $optional, '', 'string', false)) {
		$where_str .= "`phone` = ? and ";
		array_push($values, "%" . $optional['phone'] . "%");
	}

	if(format_and_push($data, 'name', $optional, '', 'string', false)) {
		$where_str .= "`name` = ? and ";
		array_push($values, $optional['name']);
	}

	if(format_and_push($data, 'position_id', $optional, '', 'string', false)) {
		$where_str .= "`position_id` = ? and ";
		array_push($values, "%" . $optional['position_id'] . "%");
	}
	
	if(format_and_push($data, 'province', $optional, '', 'string', false)) {
		$where_str .= "`province` = ? and ";
		array_push($values, "%" . $optional['province'] . "%");
	}

	if(format_and_push($data, 'city', $optional, '', 'string', false)) {
		$where_str .= "`city` = ? and ";
		array_push($values, "%" . $optional['city'] . "%");
	}

	if(format_and_push($data, 'district', $optional, '', 'string', false)) {
		$where_str .= "`district` = ? and ";
		array_push($values, "%" . $optional['district'] . "%");
	}
	
	if(format_and_push($data, 'address', $optional, '', 'string', false)) {
		$where_str .= "`address` = ? and ";
		array_push($values, "%" . $optional['address'] . "%");
	}

	if(isset($data['search'])) {
		if(format_and_push($data['search'], 'value', $optional, 'search', 'string', false)) {
			$where_str .= "(`name` like ? or `domain` like ?) and ";
			array_push($values, "%" . $optional['search'] . "%");
			array_push($values, "%" . $optional['search'] . "%");
		}
	}

	$order_map = array(
		"ent_id",
		"name",
		"domain",
		"secret",
		"admin",
		"disabled",
		"iwancnt",
		"trafficon",
		"trafficnt",
		"iwacctcnt",
		"groupcnt",
		"acctcnt",
		"usercnt",
		"account",
		"contact",
		"phone",
		"province",
		"city",
		"district",
		"address",
		"update_time",
		"create_time"
	);

	$order = array();
	if(isset($optional['order'])) {
		foreach($optional['order'] as $op) {
			if(isset($op['column']) && isset($data['columns'][$op['column']]['data'])) {
				if(in_array($data['columns'][$op['column']]['data'], $order_map))
					array_push($order, "`" . $data['columns'][$op['column']]['data'] . "` " . $op['dir']);
			}
		}
	}

	if(count($order) > 0)
		$order_by = 'order by ' . implode(', ', $order);
	else
		$order_by = '';

	if(isset($data['__api__'])) {

		if(isset($data['serialno']) && empty($data['serialno']) == false) {
			
			// get trafficon != 0 ent_id
			$sql = "select group_concat(`ent_id`) as `white_id` from cloud_enterpise ";
			$sql.= "where `disabled` < " . TB_ROW_DEL_VALUE . " and `trafficon` <> 0";

			try {
				$sth = $nidb->prepare($sql);
				$sth->execute();
				$rows = $sth->fetchAll(\PDO::FETCH_CLASS);
			}
			catch (\NiDBException $e) {
				set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
				return false;
			}

			if(count($rows) > 0 && empty($rows[0]->white_id) === false) {

				$sql = "select group_concat(`ent_id`) as `white_id` from cloud_iwantraffic ";
				$sql.= "where `type` = 0 and `serialno` = ?";
				$sql.= ' and `ent_id` in (' . $rows[0]->white_id . ')';

				try {
					$sth = $nidb->prepare($sql);

					$sth->bindParam(1, $data['serialno'], \PDO::PARAM_STR);

					$sth->execute();
					$rows = $sth->fetchAll(\PDO::FETCH_CLASS);
				}
				catch (\NiDBException $e) {
					set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
					return false;
				}

				if(count($rows) > 0 && empty($rows[0]->white_id) === false)
					$where_str .= '(`trafficon` = 0 or `ent_id` in (' . $rows[0]->white_id . ')) and ';
				else
					$where_str .= '`trafficon` = 0 and ';

			}
			else
				$where_str .= '`trafficon` = 0 and ';
		}
		else 
			$where_str .= '`trafficon` = 0 and ';

	}
	
	// 限制设置了负责企业的操作员只能访问其负责的企业
	if(gettype($user) == 'object' && $user->entcnt > 0) {
		$sql = "select group_concat(`ent_id`) as `ids` from cloud_user_group_list where `user_id` = ? group by `ent_id`";
		try {
			$sth = $nidb->prepare($sql);
			$sth->bindParam(1, $user->user_id, \PDO::PARAM_INT);
			if($sth->execute())
				$row = $sth->fetch(\PDO::FETCH_ASSOC);
			else
				$row = false;
		}
		catch (\NiDBException $e) {
			set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
			return false;
		}

		if($row && empty($row['ids']) == false) {
			$where_str .= '(`ent_id` in (' . $row['ids'] . ') or `admin` = ?) and ';
			array_push($values, $user->account);
		}
	}

	if($where_str != '')
		$where_str = substr("where $where_str", 0, -5);

	$sql = "select count(*) as `total` from cloud_enterpise $where_str";
	try {
		$sth = $nidb->prepare($sql);

		$sth->execute($values);

		$rows = $sth->fetchAll(\PDO::FETCH_CLASS);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}
	
	if(count($rows) > 0) {
		$result = array(
			'total' => $rows[0]->total,
		);
	}
	else {
		$result = array(
			'total' => 0,
		);
	}

	if(isset($data['__api__'])) {
		$http = isset($_SERVER['REQUEST_SCHEME']) ? $_SERVER['REQUEST_SCHEME'] : 'http';
		$pos = strlen($_SERVER['DOCUMENT_ROOT']);
//		$imgurl	 = $http . "://raas.panabit.com" . $_SERVER['HTTP_HOST'] . substr(ROOT_DIR, $pos) . "/assets/user/enterpise/";
		$imgurl	 = $http . "://raas.panabit.com" . substr(ROOT_DIR, $pos) . "/assets/user/enterpise/";

		$keys = '`ent_id`,
`name`,
concat(\'' . $imgurl . '\', `logo_file`) as `img`,
`domain`,
`iwancnt`,
`iwacctcnt`,
`province`,
`city`,
`district`,
`address`,
`remark`';
	}
	else
	if(isset($data['__purchased__'])) {
		$keys = '`ent_id`,
`name`,
`domain`,
`iwancnt`,
`remark`';
	}
	else
		$keys = '`ent_id`,
`own_id`,
`parent_id`,
`name`,
`domain`,
`admin`,
`secret`,
`disabled`,
`iwansvr`,
`iwancnt`,
`iwacctcnt`,
`trafficon`,
`groupcnt`,
`acctcnt`,
`usercnt`,
`account`,
`contact`,
`phone`,
`position_id`,
`province`,
`city`,
`district`,
`address`,
`remark`,
`update_time`,
`create_time`';

	$sql = "select $keys from cloud_enterpise $where_str $order_by limit ? offset ? ";


	if(gettype($user) == 'object' && ($user->account == 'root' || $user->account == 'zhang.ruikang'))
		array_push($values, 500);
	else
		array_push($values, $optional['limit']);
	
	array_push($values, $optional['offset']);


	try {
		$sth = $nidb->prepare($sql);
		$sth->execute($values);
		$rows = $sth->fetchAll(\PDO::FETCH_CLASS);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	$result['rows'] = $rows;
//	$result['sql'] = $sql;
//	$result['values'] = $values;
// select `ent_id`, `name`, `domain`, `iwancnt`, `iwacctcnt`, `province`, `city`, `district`, `address`, `remark` from cloud_enterpise where `disabled` < 120 and `iwansvr` = 1 order by `acctcnt` desc limit 20 offset 0 

	if(isset($data['draw'])) $result['draw'] = $data['draw'];

	return $result;
}

