<?php
namespace raas\apps\enterpise;


ni_app_load('enterpise', 'find');
ni_app_load('enterpise', 'info');
ni_app_load('enterpise', 'status');
		
function save($data)
{
	global $nidb;

	$filter = array(
		'ent_id'	=> new \FilterVarID(true),
		'own_id'	=> new \FilterVarID(true),
	);
	if(($where = filter_data($data, $filter, $errmsg)) === false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, $errmsg);
		return false;
	}

	$filter = array(
//		'name'		=> new \FilterVarStr(),
		'domain'	=> new \FilterVarStr(),
		'secret'	=> new \FilterVarStr(),
		'disabled'	=> new \FilterVarInt(),
		'iwansvr'	=> new \FilterVarInt(),
		'trafficon'	=> new \FilterVarInt(),
		'admin'		=> new \FilterVarStr(), // 项目负责人
		'account'	=> new \FilterVarStr(),
		'contact'	=> new \FilterVarStr(),
		'phone'		=> new \FilterVarStr(),
		'position_id'=> new \FilterVarID(),
		'province'	=> new \FilterVarStr(),
		'city'		=> new \FilterVarStr(),
		'district'	=> new \FilterVarStr(),
		'address'	=> new \FilterVarStr(),
		'remark'	=> new \FilterVarStr(),
	);
	if(($frmData = filter_data($data, $filter, $errmsg)) === false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, $errmsg);
		return false;
	}

	if(count($frmData) <= 0) {
		set_errmsg(MSG_LEVEL_DEF, __function__, "修改已放弃！无任何内容需要保存。");
		return false;
	}

	if(isset($data['name'])) {
		$name = trim($data['name']);
		if(empty($name)) {
			set_errmsg(MSG_LEVEL_DEF, __function__, '项目名称不能为空！');
			return false;
		}
		
		if(($ent = _find($name)) !== false && $ent->disabled < TB_ROW_DEL_VALUE ) {
			if($ent->ent_id != $where['ent_id']) {
				set_errmsg(MSG_LEVEL_DEF, __function__, '“' . $name . '”项目名已存在，请更换！');
				return false;
			}

			ni_app_load('enterpise', 'info');
			if(($ent = _info($where['ent_id'], $where['own_id'])) === false) {
				set_errmsg(MSG_LEVEL_DEF, __function__, '该项目不存在！');
				return false;
			}
			if($name != $ent->name) $frmData['name'] = $name;
		}
		else
			$frmData['name'] = $name;

	}

	if(isset($frmData['domain'])) {
		if(empty($frmData['domain'])) {
			set_errmsg(MSG_LEVEL_DEF, __function__, '项目标识不能为空！');
			return false;
		}
		if(preg_match("/^([a-zA-Z0-9-_.]{2,})$/", $frmData['domain'], $match) == false) {
			set_errmsg(MSG_LEVEL_DEF, __function__, '项目域名格式不正确！格式应为：a-z，A-Z，0-9和“.”，“_”，至少2位字符组成。');
			return false;
		}

		if(($ent = _finddomain($frmData['domain'])) !== false 
		&& $ent->disabled < TB_ROW_DEL_VALUE 
		&& $ent->ent_id != $where['ent_id']) {
			set_errmsg(MSG_LEVEL_DEF, __function__, '“' . $frmData['domain'] . '”标识已被使用，请更换！');
			return false;
		}
	}

	set_errmsg(MSG_LEVEL_DEF, __function__, '');
	
	$frmData['update_time'] = time();

	$nidb->beginTransaction();

	try {
		if(update_data('cloud_enterpise', $frmData, $where) === false) {
			$errmsg = implode(' ', $nidb->errorInfo());
			set_errmsg(MSG_LEVEL_DEF, __function__, $errmsg);
			$nidb->rollBack();
			return false;
		}
		
		if(isset($frmData['name'])) {
			ni_app_load('group', 'save');
			\raas\apps\group\_save_entname($where['ent_id'], $frmData['name']);
		}
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		$nidb->rollBack();
		return false;
	}

	$nidb->commit();
//	synclog_push(RA_SYNC_ENT, $where['ent_id']);
	$info = _info($where['ent_id'], $where['own_id'], 1);
	raaseye_enterpise_add($info);
	
	if(isset($data['default_domain']) && intval($data['default_domain']))
		raaseye_enterpise_set_default_domain($info->domain);
	else {
		$status = status([]);
		if($status && isset($status['default_domain']) && $status['default_domain'] == $info->domain) {
			raaseye_enterpise_set_default_domain('');
		}
	}

	return true;
}

