<?php
namespace raas\apps\entowner;

// _ent_count_inc load
ni_app_load('counter', '_lib');


function _create($frmData)
{
	global $nidb;


	$frmData['update_time'] = time();
	$frmData['create_time'] = $frmData['update_time'];

	try {

		if(insert_data('cloud_entowner', $frmData) === false) {
			$errmsg = implode(' ', $nidb->errorInfo());
			set_errmsg(MSG_LEVEL_DEF, __function__, $errmsg);
			return false;
		}
		$frmData['own_id'] = $nidb->lastInsertId();
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	
	if(\raas\apps\counter\_ent_count_inc(COUNTER_RAAS_ID, 1) === false) {
		return false;
	}


	return $frmData;
}

function create($data)
{
	global $nidb;

	$filter = array(
		'name'		=> new \FilterVarStr(true),
		'disabled'	=> new \FilterVarInt(),
		'account'	=> new \FilterVarStr(true),
		'contact'	=> new \FilterVarStr(),
		'phone'		=> new \FilterVarStr(),
		'position_id'=> new \FilterVarID(),
		'province'	=> new \FilterVarStr(),
		'city'		=> new \FilterVarStr(),
		'district'	=> new \FilterVarStr(),
		'address'	=> new \FilterVarStr(),
	);
	if(($frmData = filter_data($data, $filter, $errmsg)) === false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, $errmsg);
		return false;
	}
	if(empty($frmData['name'])) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '项目名称不能为空！');
		return false;
	}
	if(empty($frmData['account'])) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '管理帐号不能为空！');
		return false;
	}

	$nidb->beginTransaction();
	
	if(_create($frmData) === false) {
		$nidb->rollBack();
		return false;
	}
	
	$nidb->commit();
//	synclog_push(RA_SYNC_ENT, $frmData['own_id']);

	return $frmData;
}

