<?php
namespace raas\apps\entowner;

// _ent_count_inc load
ni_app_load('counter', '_lib');

function remove($data)
{
	global $nidb;

	$filter = array(
		'own_id'	=> new \FilterVarID(true),
	);
	if(($where = filter_data($data, $filter, $errmsg)) === false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, $errmsg);
		return false;
	}

	
	// is exist?
	$sql = "select `entcnt`, `groupcnt`, `acctcnt`, `name` from cloud_entowner where `own_id` = ? and `disabled` < " . TB_ROW_DEL_VALUE;

	try {
		$sth = $nidb->prepare($sql);

		$index = 1;
		$sth->bindParam($index++, $where['own_id'], \PDO::PARAM_INT);

		$sth->execute();
		$rows = $sth->fetchAll(\PDO::FETCH_CLASS);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}
	if(count($rows) <= 0) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '找不到该项目。');
		return false;
	}

	// have group or acctcnt ?
	$ent = $rows[0];
	if($ent->groupcnt != 0 || $ent->acctcnt != 0 || $ent->entcnt != 0) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '请先将“' . $ent->name . '”中的项目清空或转移。');
		return false;
	}

	
	$frmData['disabled'] = TB_ROW_DEL_VALUE;
	$frmData['update_time'] = time();

	$nidb->beginTransaction();
	try {
		if(update_data('cloud_entowner', $frmData, $where) === false) {
			$errmsg = implode(' ', $nidb->errorInfo());
			set_errmsg(MSG_LEVEL_DEF, __function__, $errmsg);
			$nidb->rollBack();
			return false;
		}
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		$nidb->rollBack();
		return false;
	}

	if(\raas\apps\counter\_entown_count_inc(COUNTER_RAAS_ID, -1) === false) {
		$nidb->rollBack();
		return false;
	}

	$nidb->commit();
	
	return true;
}

