<?php
namespace raas\apps\forgot;

// load lib
ni_library_load('email');

// _user_count_inc load
ni_app_load('account', 'save');
ni_app_load('account', 'find');
ni_app_load('enterpise', 'find');

function _create($frmData)
{
	global $nidb;

	$frmData['pass'] = substr(md5(time()), 0, 8);
	$frmData['code'] = rand(100000, 999999);
	$frmData['ipaddr'] = get_real_ip();
	$frmData['create_time'] = time();

	try {
		if(insert_data('cloud_forgot', $frmData) === false) {
			$errmsg = implode(' ', $nidb->errorInfo());
			set_errmsg(MSG_LEVEL_DEF, __function__, $errmsg);
			return false;
		}
		$frmData['fgt_id'] = $nidb->lastInsertId();
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}
	
	return $frmData;
}

function create($data)
{
	global $nidb;

	$filter = array(
		'account'	=> new \FilterVarStr(true),
		'email'		=> new \FilterVarStr(true),
	);

	if(($frmData = filter_data($data, $filter, $errmsg)) === false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, $errmsg);
		return false;
	}
	if(isset($data['domain']) == false || empty(($domain = trim($data['domain'])))) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '域名不能为空！');
		return false;
	}
	if(empty($frmData['account'])) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '帐号不能为空！');
		return false;
	}
	if(empty($frmData['email'])) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '邮箱不能为空！');
		return false;
	}
	if(($ent = \raas\apps\enterpise\_finddomain($domain)) === false) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '无效的项目域名！');
		return false;
	}

	if(($forgotuser = \raas\apps\account\_find($frmData['account'], $ent->ent_id, $ent->own_id)) === false) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '帐号或邮箱不正确！');
		return false;
	}
	
	if($forgotuser->email == "") {
		set_errmsg(MSG_LEVEL_DEF, __function__, '该帐号未设置找回邮箱！请联系管理员。');
		return false;
	}
	
	if($forgotuser->email != $frmData['email']) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '帐号或邮箱不正确！');
		return false;
	}
	
	// 0：操作员找回密码；1：认证帐号找回密码。
	$frmData['type'] = 1;
	$frmData['own_id'] = $forgotuser->own_id;
	$frmData['ent_id'] = $forgotuser->ent_id;
	$frmData['user_id'] = $forgotuser->acct_id;

	$nidb->beginTransaction();
	
	if(($frmData = _create($frmData)) === false) {
		$nidb->rollBack();
		return false;
	}

	$http = isset($_SERVER['REQUEST_SCHEME']) ? $_SERVER['REQUEST_SCHEME'] : 'http';
	$pos = strlen($_SERVER['DOCUMENT_ROOT']);
	$regurl	 = $http . "://" . $_SERVER['HTTP_HOST'] . substr(ROOT_DIR, $pos) . "/index.php?r=forgot@agree&key=" . $frmData['fgt_id'] . "&code=" . $frmData['code'];
	$subject = "【帐号密码重置】";
	$to		 = $forgotuser->name . ' <' . $forgotuser->email . '>';
	$sign	 = "-- 北京派网软件有限公司
<a herf=\"https://www.panabit.com\" rel=\"noopener\" target=\"_blank\">https://www.panabit.com</a>";
	if(file_exists('/usr/paraas/etc/email_sign.conf')) {
		$sign = file_get_contents('/usr/paraas/etc/email_sign.conf');
	}
	
	$body	 = "尊敬的 <span style=\"color: #b51a00\">" . $forgotuser->name . "</span> 您好！
	
您申请的操作将会重置“<span style=\"color: #b51a00;font-weight: bold;\">" . $forgotuser->account . "</span>”帐号的密码为：<span style=\"color: #b51a00;font-weight: bold;\">" . $frmData['pass'] . "</span>


如确认操作无误，请复制下面链接至浏览器地址栏打开完成密码重置！

<a style=\"color: #0d5bdd\" herf=\"$regurl\">$regurl</a>

<span style=\"color: #b51a00\">注意：以上链接仅在30分钟内有效，请务必及时完成验证。</span> 


{$sign}
";

	\email_add_logger($subject, $body, $to);

	$nidb->commit();	

	if(file_exists('/usr/paraas/etc/email_pass_retrieve_noauth')) {
		\raas\apps\account\save(array(
			'acct_id' => $forgotuser->acct_id,
			'account' => $forgotuser->account,
			'ent_id' => $forgotuser->ent_id,
			'own_id' => $forgotuser->own_id,
			'pass' => $frmData['pass'],
		));
	}
	
	set_errmsg(MSG_LEVEL_DEF, __function__,
	'重置密码邮件稍后发送至您的邮箱“' . $forgotuser->email . '”，请注意查收并完成注册！若未1分钟后未收到，可重新发送重置请求。');

	return $frmData['fgt_id'];
}
