<?php
namespace raas\apps\forgot;


function _info($fgt_id, $own_id = 0)
{
	global $nidb;


	$sql = "select * from cloud_forgot where `fgt_id` = ?";

	try {
		if($own_id > 0) {
			$sql.= " and `own_id` = ?";
			$sth = $nidb->prepare($sql);

			$index = 1;
			$sth->bindParam($index++, $fgt_id, \PDO::PARAM_INT);
			$sth->bindParam($index++, $own_id, \PDO::PARAM_INT);
		}
		else {
			$sth = $nidb->prepare($sql);

			$index = 1;
			$sth->bindParam($index++, $fgt_id, \PDO::PARAM_INT);
		}

		$sth->execute();
		$rows = $sth->fetchAll(\PDO::FETCH_CLASS);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	if(count($rows) <= 0) {
		set_errmsg(MSG_LEVEL_DEF, __function__, "无效的信息。");
		return false;
	}
	
	return $rows[0];
}

function info($data)
{
	global $nidb;

	$optional = array();

	$where_str = '';

	// set custom options
	if(format_and_push($data, 'fgt_id', $optional, '', 'int', false) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, 'err: fgt_id can\'t empty.');
		return false;
	}
	$where_str .= "`fgt_id` = " . $optional['fgt_id']  . " and ";


	if($where_str != '')
		$where_str = substr("where $where_str", 0, -5);


	$sql = "select * from cloud_forgot $where_str";

	try {
		$sth = $nidb->prepare($sql);

		$sth->execute();
		$rows = $sth->fetchAll(\PDO::FETCH_CLASS);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	if(count($rows) <= 0) {
		set_errmsg(MSG_LEVEL_DEF, __function__, "无效的信息。");
		return false;
	}
	
	return $rows[0];
}

