<?php
namespace raas\apps\group;


function find($data)
{
	global $nidb;

	$optional = array();

	$where_str = '';

	// set custom options
	if(format_and_push($data, 'name', $optional, '', 'string', false) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, 'err: name can\'t empty.');
		return false;
	}
	$where_str .= "`disabled` < " . TB_ROW_DEL_VALUE . " and `name` = ? and ";

	if(format_and_push($data, 'ent_id', $optional, '', 'int', false) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, 'err: ent_id can\'t empty.');
		return false;
	}
	$where_str .= "`ent_id` = " . $optional['ent_id']  . " and ";

	if(format_and_push($data, 'own_id', $optional, '', 'int', false))
		$where_str .= "`own_id` = " . $optional['own_id']  . " and ";


	if($where_str != '')
		$where_str = substr("where $where_str", 0, -5);

	$sql = "select * from cloud_group $where_str";

	try {
		$sth = $nidb->prepare($sql);

		$index = 1;
		$sth->bindParam($index++, $optional['name'], \PDO::PARAM_STR);
		
		$sth->execute();
		$rows = $sth->fetchAll(\PDO::FETCH_CLASS);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	if(count($rows) <= 0) {
		set_errmsg(MSG_LEVEL_DEF, __function__, "找不到此用户组。");
		return false;
	}
	
	return $rows[0];
}

