<?php
namespace raas\apps\group;

include_once(dirname(dirname(__DIR__)).'/user/lib/include/group.php');

// _group_count_inc load
ni_app_load('counter', '_lib');
ni_app_load('entowner', '_lib');
ni_app_load('enterpise', '_lib');

function remove($data)
{
	global $nidb, $user;

	$filter = array(
		'group_id'	=> new \FilterVarID(true),
		'ent_id'	=> new \FilterVarID(),
		'own_id'	=> new \FilterVarID(true),
	);
	if(($where = filter_data($data, $filter, $errmsg)) === false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, $errmsg);
		return false;
	}

	// is empty ?
	$sql = "select `ent_id`, `acctcnt`,`name` from cloud_group where `group_id` = ? and `own_id` = ? and `disabled` < " . TB_ROW_DEL_VALUE;
	try {
		$sth = $nidb->prepare($sql);

		$index = 1;
		$sth->bindParam($index++, $where['group_id'], \PDO::PARAM_INT);
		$sth->bindParam($index++, $where['own_id'], \PDO::PARAM_INT);

		$sth->execute();
		$rows = $sth->fetchAll(\PDO::FETCH_CLASS);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}
	if(count($rows) <= 0) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '找不到此用户组。');
		return false;
	}

	$row = $rows[0];
	
	// ent_id is eq ?
	if(isset($where['ent_id']) && $where['ent_id'] != $row->ent_id) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '找不到此用户组。');
		return false;
	}
	
	// have group or acctcnt ?
	if($row->acctcnt != 0) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '请先将“' . $row->name . '”用户组中的用户清空。');
		return false;
	}


	$frmData['disabled'] = TB_ROW_DEL_VALUE;
	$frmData['update_time'] = time();

	$nidb->beginTransaction();
	try {
		if(update_data('cloud_group', $frmData, $where) === false) {
			$errmsg = implode(' ', $nidb->errorInfo());
			set_errmsg(MSG_LEVEL_DEF, __function__, $errmsg);
			$nidb->rollBack();
			return false;
		}
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		$nidb->rollBack();
		return false;
	}


	if(\raas\apps\enterpise\_group_count_inc($row->ent_id, -1) === false){
		$nidb->rollBack();
		return false;
	}
	if(\raas\apps\entowner\_group_count_inc($where['own_id'], -1) === false){
		$nidb->rollBack();
		return false;
	}
	if(\raas\apps\counter\_group_count_inc(COUNTER_RAAS_ID, -1) === false) {
		$nidb->rollBack();
		return false;
	}

	$nidb->commit();
	\raas\apps\user\group\set_option(array(
		"own_id" => $where['own_id'],
		"user_id" => $user->user_id,
		"checked" => 0,
		"ids" => $where['group_id']));
	set_errmsg(MSG_LEVEL_DEF, __function__, '');

//	synclog_push(RA_SYNC_GROUP, $where['group_id']);
	raaseye_group_remove($where['group_id'], $row->ent_id);
	
	return true;
}

