<?php
namespace raas\apps\group;


ni_app_load('group', 'info');

function _save_entname($ent_id, $name)
{
	global $nidb;

	$sql = "update cloud_group
			set `ent` = ?
			where `ent_id` = ?";
	try {
		$sth = $nidb->prepare($sql);

		$index = 1;
		$sth->bindParam($index++, $name, \PDO::PARAM_STR);
		$sth->bindParam($index++, $ent_id, \PDO::PARAM_INT);

		$sth->execute();
		return $sth->rowCount();
	}
	catch (PDOException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	return 0;
}

function save($data)
{
	global $nidb;

	$filter = array (
		'group_id'	=> new \FilterVarID(true),
		'ent_id'	=> new \FilterVarID(true),
		'own_id'	=> new \FilterVarID(true),
	);
	if(($where = filter_data($data, $filter, $errmsg)) === false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, $errmsg);
		return false;
	}

	$filter = array (
//		'name'		=> new \FilterVarStr(),
		'disabled'	=> new \FilterVarInt(),
		'startip'	=> new \FilterVarInt(),
		'endip'		=> new \FilterVarInt(),
		'service'	=> new \FilterVarInt(),
		'dns0'		=> new \FilterVarInt(),
		'dns1'		=> new \FilterVarInt(),
		'rate_out'	=> new \FilterVarKBit(),
		'rate_in'	=> new \FilterVarKBit(),
		'maxonlinetm'=> new \FilterVarInt(),
		'clntepa'	=> new \FilterVarInt(),
		'ifname'	=> new \FilterVarStr(),
		'vlan_in'	=> new \FilterVarInt(),
		'vlan_out'	=> new \FilterVarInt(),
		'remark'	=> new \FilterVarStr(),
	);
	if(($frmData = filter_data($data, $filter, $errmsg)) === false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, $errmsg);
		return false;
	}

	if(count($frmData) <= 0) {
		set_errmsg(MSG_LEVEL_DEF, __function__, "修改已放弃！无任何内容需要保存。");
		return false;
	}

	$frmData['update_time'] = time();
	
	// is change name?
	if(isset($data['name'])) {
		// name is empty ?
		$name = trim($data['name']);
		if(empty($name)) {
			set_errmsg(MSG_LEVEL_DEF, __function__, '用户组名称不能为空！');
			return false;
		}

		// find group name
		$sql = "select `ent_id`, `group_id` from cloud_group where `disabled` < " . TB_ROW_DEL_VALUE;
		$sql .=" and `own_id` = ? and `ent_id` = ? and `name` = ?";
		try {
			$sth = $nidb->prepare($sql);

			$index = 1;
			$sth->bindParam($index++, $where['own_id'], \PDO::PARAM_INT);
			$sth->bindParam($index++, $where['ent_id'], \PDO::PARAM_INT);
			$sth->bindParam($index++, $name, \PDO::PARAM_STR);

			$sth->execute();
			$rows = $sth->fetchAll(\PDO::FETCH_CLASS);
		}
		catch (PDOException $e) {
			set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
			return false;
		}
		if(count($rows) > 0) {
			$row = $rows[0];
			if($row->group_id != $where['group_id']) {
				set_errmsg(MSG_LEVEL_DEF, __function__, '“' . $name . '”用户组已存在');
				return false;
			}

			if($row->name != $name) $frmData['name'] = $name;
		}
		else
			$frmData['name'] = $name;
	}

	try {
		if(update_data('cloud_group', $frmData, $where) === false) {
			$errmsg = implode(' ', $nidb->errorInfo());
			set_errmsg(MSG_LEVEL_DEF, __function__, $errmsg);
			return false;
		}

		if(isset($frmData['name'])) {
			ni_app_load('account', 'save');
			\raas\apps\account\_save_groupname($where['group_id'], $frmData['name']);
		}
	}
	catch (PDOException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}
	
//	synclog_push(RA_SYNC_GROUP, $where['group_id']);
	$info = info($where);
	raaseye_group_add($info);

	return true;
}

