function dateFormatter(data, type, row, meta) {
	return $.myTime.UnixToStrDate(data, true);
}

function ipFormatter(data, type, row, meta) {
	return _int2iP(data);
}

function ISPFormatter(data, type, row, meta) {
	var isp = ['多线', '电信', '联通', '移动', '教育网'];
	if (data >= 0 && data < isp.length) return isp[data];
	return '未知';
}

function iprangeFormatter(data, type, row, meta) {
	var str = [];

	str.push(_int2iP(row.startip));
	str.push(_int2iP(row.endip));

	return str.join(' - ');
}

function clntepaFormatter(data, type, row, meta) {
	if (row.clntepa == 'reject')
		return '不允许登陆';

	if (row.clntepa == 'login')
		return '可登陆但不能上网';

	if (row.clntepa == 'pass')
		return '可登陆也可上网';

	return '';
}

function popContentFormatter(data, type, row, meta) {
	return '<div class="row"><div class="icon-container icon-td col-md-4">\
									<div class="icon btn-eye"><span class="mdi mdi-eye' +
		(row.disabled ? '-off' : '') +
		'"></span></div>\
								</div>\
								<div class="icon-container icon-td col-md-4">\
									<div class="icon btn-edit"><span class="mdi mdi-edit"></span></div>\
								</div>\
								<div class="icon-container icon-td col-md-4">\
									<div class="icon btn-del"><span class="mdi mdi-delete"></span></div>\
								</div></div>'
}

function optionFormatter(data, type, row, meta) {
	var str =
		'<div class="row"><div class="icon-container icon-td col-md-6">\
									<div class="icon btn-logger"><span class="mdi mdi-calendar-note"></span></div>\
								</div>\
								<div class="icon-container icon-td col-md-6">\
									<div class="icon btn-session"><span class="mdi mdi-face"></span></div>\
								</div></div>';

	return str;
}

var $tblist = {
	home: null,
	group: null,
	account: null,
	online: null,
	session: null,
	iwan: null,
	iwacct: null
};

var myChart = null;

function set_budget_bar(data) {
	var i, tm, time, curtm, timeaxis = [],
		income = [],
		expenditure = [];

	curtm = data.start;
	for (i = 0; i < data.timeaxis.length; i++) {
		if ((tm = (data.timeaxis[i] - curtm)) > 0) {
			do {
				time = new Date(curtm * 1000);
				timeaxis.push(time.format('dd') + '日 [0]');
				income.push(0);
				expenditure.push(0);
				curtm += 86400;
			} while ((tm -= 86400) >= 0);
		}

		time = new Date(data.timeaxis[i] * 1000);
		timeaxis.push(time.format('dd') + '日 [' + data.count[i] + ']');
		income.push(data.income[i]);
		expenditure.push(data.expenditure[i]);
		curtm = data.timeaxis[i] + 86400;
	}

	for (; curtm < data.end; curtm += 86400) {
		time = new Date(curtm * 1000);
		timeaxis.push(time.format('dd') + '日 [0]');
		income.push(0);
		expenditure.push(0);
	}

	time = new Date(data.start * 1000);
	var option = {
		title: {
			x: 'left',
			y: 'top{200}',
			text: time.format('yyyy 年 MM 月') + '      历史图表>>',
			textStyle: {
				fontSize: 14
			}
		},
		xAxis: [{
			data: timeaxis.reverse()
		}],
		series: [{
				data: income.reverse()
			},
			{
				data: expenditure.reverse()
			}
		]
	};
	myChart.setOption(option);
}

// 20210204 jqw start--
function set_user_bar() {
	var chartDom = document.getElementById('user_bar');
	var myChart = echarts.init(chartDom);
	var option;
	option = {
		xAxis: {
			type: 'category',
			data: ['2天前', '1天前', '今天']
		},
		yAxis: {
			type: 'value'
		},
		series: [{
			data: [820, 932, 901],
			type: 'line',
			itemStyle: {
				normal: {
					color: '#3b6291', //折点颜色
					lineStyle: {
						color: '#95a2ff' //折线颜色
					}
				}
			},
			areaStyle: {
				color: '#63b2ee'
			}
		}]
	};
	option && myChart.setOption(option);
}

function set_flow_bar() {
	var chartDom = document.getElementById('flow_bar');
	var myChart = echarts.init(chartDom);
	var option;
	option = {
		xAxis: {
			type: 'category',
			data: ['2天前', '1天前', '今天']
		},
		yAxis: {
			type: 'value'
		},
		series: [{
			data: [100, 150, 90],
			type: 'line',
			smooth: true,
			itemStyle: {
				normal: {
					color: '#3b6291', //折点颜色
					lineStyle: {
						color: '#ce2626' //折线颜色
					}
				}
			},
			// areaStyle: {
			// 	color: '#7898e1'
			// }
		}]
	};
	option && myChart.setOption(option);
}
// --end

function load_budget_bar() {
	var ent = getentitem();

	$.ajax({
		type: 'POST',
		url: 'api.php?r=enterpise@budget_bar',
		data: {
			ent_id: ent.ent_id
		},
		success: function(d) {
			if (d.ret != 0) return;
			set_budget_bar(d.data);
		}
	});
}


var g_curdate;

function selectdate() {
	var ent = getentitem();
	showAjaxModal('selecr_date', {
		content: {
			ajax: {
				url: 'modal.php?r=home@selectdate',
				data: {
					ent_id: ent.ent_id
				},
			}
		},
		options: {
			data: {
				data: {
					ent_id: ent.ent_id,
					date: g_curdate
				},
				success: function(e, d, msg) {
					set_budget_bar(d);
				}
			}
		}
	}, true, 'modal-bgcolor modal-effect-16');
}



function home_init() {
	set_user_bar();
	set_flow_bar();
	$tblist.home = [];

	var ent = getentitem();

	$.ajax({
		type: 'POST',
		url: 'api.php?r=enterpise@status',
		data: {
			ent_id: ent.ent_id
		},
		success: function(d) {
			if (d.ret != 0) return;
			$('.usr-grp-num').text(d.data.groupcnt);
			$('.usr-num').text(d.data.acctcnt);
			$('.usr-session-num').text(d.data.session);
			$('.usr-expired-num').text(d.data.expired);
			$('.usr-alive-num').text(d.data.acctcnt - d.data.expired);
			$('.usr-about-to-expire').text(d.data.atoexpire);
		}
	});

	$('#budget_bar').width($('.main-content').width());
	if ($('#budget_bar > canvas').length > 0) {
		load_budget_bar();
		return;
	}

	myChart = echarts.init(document.getElementById('budget_bar'));
	var app = {},
		option = null;

	var posList = [
		'left', 'right', 'top', 'bottom',
		'inside',
		'insideTop', 'insideLeft', 'insideRight', 'insideBottom',
		'insideTopLeft', 'insideTopRight', 'insideBottomLeft', 'insideBottomRight'
	];

	app.configParameters = {
		rotate: {
			min: -90,
			max: 90
		},
		align: {
			options: {
				left: 'left',
				center: 'center',
				right: 'right'
			}
		},
		verticalAlign: {
			options: {
				left: 'left',
				top: 'top',
				middle: 'middle',
				bottom: 'bottom'
			}
		},
		position: {
			options: echarts.util.reduce(posList, function(map, pos) {
				map[pos] = pos;
				return map;
			}, {})
		},
		distance: {
			min: 0,
			max: 100
		}
	};

	app.config = {
		rotate: 90,
		align: 'left',
		verticalAlign: 'middle',
		position: 'insideBottom',
		distance: 15,
		onChange: function() {
			var labelOption = {
				normal: {
					rotate: app.config.rotate,
					align: app.config.align,
					verticalAlign: app.config.verticalAlign,
					position: app.config.position,
					distance: app.config.distance
				}
			};

			myChart.setOption({
				series: [{
					label: labelOption
				}, {
					label: labelOption
				}, {
					label: labelOption
				}, {
					label: labelOption
				}]
			});
		}
	};


	var labelOption = {
		normal: {
			show: true,
			position: app.config.position,
			distance: app.config.distance,
			align: app.config.align,
			verticalAlign: app.config.verticalAlign,
			rotate: app.config.rotate,
			formatter: '{c}  {name|{a}}',
			fontSize: 16,
			rich: {
				name: {
					textBorderColor: '#fff'
				}
			}
		}
	};

	option = {
		series: [{
				name: '收入',
				type: 'bar',
				label: labelOption,
				data: []
			},
			{
				name: '支出',
				type: 'bar',
				label: labelOption,
				data: []
			}
		]
	};

	option = {
		title: {
			text: '收支报表',
			subtext: '',
			link: "javascript: selectdate()",
			target: "self"
		},
		color: ['#2cc6c8', '#d8797f'],
		tooltip: {
			trigger: 'axis'
		},
		legend: {
			data: ['收入', '支出']
		},
		toolbox: {
			show: true,
			feature: {
				dataView: {
					show: true,
					readOnly: false
				},
				magicType: {
					show: true,
					type: ['line', 'bar']
				},
				restore: {
					show: true
				},
				saveAsImage: {
					show: true
				}
			}
		},
		calculable: true,
		xAxis: [{
			type: 'category',
			data: []
		}],
		yAxis: [{
			type: 'value',
			name: 'RMB（元）'
		}],
		series: [{
				name: '收入',
				type: 'bar',
				data: [],
				markPoint: {
					data: [{
							type: 'max',
							name: '最大收入'
						},
						{
							type: 'min',
							name: '最小收入'
						}
					]
				},
				markLine: {
					data: [{
						type: 'average',
						name: '平均收入'
					}]
				}
			},
			{
				name: '支出',
				type: 'bar',
				data: [],
				markPoint: {
					data: [{
							type: 'max',
							name: '最大支出'
						},
						{
							type: 'min',
							name: '最小支出'
						}
					]
				},
				markLine: {
					data: [{
						type: 'average',
						name: '平均支出'
					}]
				}
			}
		]
	};

	myChart.setOption(option);
	load_budget_bar();
}

function group_init() {
	$tblist.group = $('.ent-group table').DataTable($.extend(true, {}, OPTIONS_CONSTANT.DATA_TABLES.DEFAULT_OPTION, {
		pageLength: 50,
		displayLength: 20,
		dom: "<'row'><'row be-datatable-body'<'table-responsive'tr>><'row be-datatable-footer'<'col-sm-5'i><'col-sm-7'p>>",
		columns: [{
				title: '索引',
				data: 'index_js_id',
				width: 30,
				searchable: false,
				orderable: false,
				render: function(data, type, row, meta) {
					return meta.row + 1;
				}
			},
			{
				title: '名称',
				data: "name",
				width: 100
			},
			{
				title: '用户数',
				data: "acctcnt",
				width: 60,
			},
			{
				title: '归属项目',
				data: "ent",
				width: 120,
			},
			{
				title: '地址范围',
				data: "iprange",
				width: 150,
				orderable: false,
				render: iprangeFormatter
			},
			{
				title: '上行(bps)',
				data: "rate_out",
				width: 80,
				render: function(data, type, row, meta) {
					return formatbps(data).replace('bps', '');
				}
			},
			{
				title: '下行(bps)',
				data: "rate_in",
				width: 80,
				render: function(data, type, row, meta) {
					return formatbps(data).replace('bps', '');
				}
			},
			{
				title: '在线时间(时)',
				data: "maxonlinetm",
				width: 70
			},
			{
				title: '过期用户',
				data: "clntepa",
				width: 90,
				render: clntepaFormatter
			},
			{
				title: '更新日期',
				data: "update_time",
				width: 90,
				render: dateFormatter
			},
			{
				title: "操作",
				orderable: false,
				data: null,
				width: 68,
				defaultContent: '<div class="row"><div class="icon-container icon-td col-md-6">\
									<div class="icon btn-edit"><span class="mdi mdi-edit"></span></div>\
								</div>\
								<div class="icon-container icon-td col-md-6">\
									<div class="icon btn-del"><span class="mdi mdi-delete"></span></div>\
								</div></div>'
			}
		],
		createdRow: function(row, data, dataIndex) {
			var id = getURL_val('id');
			if (data.enable == 0)
				$(row).addClass('row-disabled');
			if (data.group_id == id)
				$(row).addClass('row-select');
		},
		fnDrawCallback: function(data) {
			$(":checkbox[name='cb-check-all']").prop('checked', false);
			//默认选中第一行
			$("tbody tr", $tblist.group).eq(0).click();
		},
		footerCallback: function(row, data, start, end, display) {
			var api = this.api(),
				data;
			// Remove the formatting to get integer data for summation
			var intVal = function(i) {
				return typeof i === 'string' ?
					i.replace(/[\$,]/g, '') * 1 :
					typeof i === 'number' ?
					i : 0;
			};
		},
		ajax: $.extend(true, {}, OPTIONS_CONSTANT.DATA_TABLES.AJAX, {
			url: 'api.php?r=group@list',
			data: function(d) {
				var ent = getentitem(),
					search = $.trim($('#group .search_val').val());

				if (ent != undefined && strToInt(ent.ent_id) > 0) d.ent_id = ent.ent_id;
				if (search != '') d.search.value = search;

				return $.extend({}, d, {
					extra_search: $('#group .extra').val()
				});
			}
		})
	})).on('xhr.dt', function(e, settings, json, xhr) {
		// Note no return - manipulate the data directly in the JSON object.
	}).on("change", ":checkbox", function() {
		if ($(this).is("[name='cb-check-all']")) {
			//全选
			$(":checkbox", $('.ent-group table')).prop("checked", $(this).prop("checked"));
		} else {
			//一般复选
			var checkbox = $("tbody :checkbox", $('.ent-group table'));
			$(":checkbox[name='cb-check-all']", $('.ent-group table')).prop('checked', checkbox.length == checkbox.filter(
				':checked').length);
		}
	}).on("click", ".td-checkbox", function(event) {
		!$(event.target).is(":checkbox") && $(":checkbox", this).trigger("click");
	}).on("click", ".btn-edit", function() {
		$(this).closest('tr').addClass("active").siblings().removeClass("active");
		// window.location.href = 'index.php?r=group@edit&id=' + item.group_id;
		showAjaxModal('edit_group', {
			content: {
				ajax: {
					url: 'modal.php?r=group@edit',
				}
			},
			options: {
				data: {
					data: function(e) {
						return $tblist.group.row($('.ent-group table').find('tr.active')).data();
					},
					success: function(e, d, msg) {
						$tblist.group.ajax.reload();
					}
				}
			}
		}, true, 'modal-bgcolor modal-effect-16');
	}).on("click", ".btn-del", function() {
		var item = $tblist.group.row($(this).closest('tr')).data();
		$(this).closest('tr').addClass("active").siblings().removeClass("active");
		showAjaxModal('itemdel_group', {
			content: {
				body: {
					content: [
						'<div class="text-center">',
						'<h3>用户组删除!</h3>',
						'<p>您是否要继续删除“<span style="color: #ea4335; font-weight: 700;">' + item.name + '</span>”用户组，确认后将无法找回！</p>',
						'<div class="mt-4">',
						'<button type="button" data-dismiss="modal" class="btn btn-secondary btn-space modal-close btn-cancel">否</button>',
						'<button type="button" data-dismiss="modal" class="btn btn-success btn-space modal-close btn-ok">是</button>',
						'</div>',
						'</div>'
					].join('')
				},
			},
			options: {
				data: item,
				buttons: [{
					class: 'btn-ok',
					callback: function(btn, modal, event) {
						//You can cancel the modal hide event by returning false
						var params = {
							group_id: item.group_id
						};
						ajaxgo({
								type: 'POST',
								url: 'api.php?r=group@remove',
								data: params
							},
							function(d, msg) {
								// success reload
								$tblist.group.ajax.reload();
							});
						return true;
					}
				}]
			}
		});
	}).on("click", ".edit-btn", function() {
		var tds = $(this).parents("tr").children();
		$.each(tds, function(i, val) {
			var jqob = $(val);
			if (i < 2 || jqob.has('button').length) {
				return true;
			} //跳过第1项 序号,按钮
			var txt = jqob.text();
			var put = $("<input type='text'>");
			put.val(txt);
			jqob.html(put);
		});
		$(this).html("保存");
		$(this).toggleClass("edit-btn");
		$(this).toggleClass("save-btn");
	});

	$('#group .search_btn').click(function() {
		$tblist.group.draw();
	});
}

function account_init() {
	$tblist.account = $('.ent-account table').DataTable($.extend(true, {}, OPTIONS_CONSTANT.DATA_TABLES.DEFAULT_OPTION, {
		pageLength: 50,
		displayLength: 20,
		dom: "<'row'><'row be-datatable-body'<'table-responsive'tr>><'row be-datatable-footer'<'col-sm-5'i><'col-sm-7'p>>",
		columns: [

			$.extend(true, {}, OPTIONS_CONSTANT.DATA_TABLES.COLUMN.CHECKBOX, {
				title: '<input type="checkbox" name="cb-check-all">'
			}),

			{
				title: '索引',
				data: 'index_js_id',
				width: 30,
				searchable: false,
				orderable: false,
				render: function(data, type, row, meta) {
					return meta.row + 1;
				}
			},
			{
				title: '帐号',
				data: "account",
				width: 90
			},
			{
				title: '姓名',
				data: "name",
				width: 90
			},
			{
				title: '用户组',
				data: "group",
				width: 70
			},
			{
				title: '开户时间',
				data: "create_time",
				width: 60,
				render: dateFormatter
			},
			{
				title: '到期时间',
				data: "expire_time",
				width: 60,
				render: function(data, type, row, meta) {
					return $.myTime.UnixToStrDate(data, true);
					return '<a href="javascript:;" class="charge">' + $.myTime.UnixToStrDate(data, true) + '</a>';
				}
			},
			{
				title: '最大用户数',
				data: "maxcnt",
				width: 66
			},
			{
				title: '绑定IP',
				data: "bind_ipv4",
				width: 60,
				render: ipFormatter
			},
			{
				title: '代拨帐号',
				data: "pxyacct",
				width: 90,
			},
			{
				title: '备注',
				orderable: false,
				data: "remark",
				fnCreatedCell: function(nTd, sData, oData, iRow, iCol) {
					$(nTd).addClass('inputTd').attr('id', 'td_' + sData + '_' + oData.account);
				}
			},
			{
				title: "操作",
				orderable: false,
				data: null,
				width: 126,
				defaultContent: '<div class="row">\
								<div class="icon-container icon-td col-md-3">\
									<div class="icon btn-logger"><span class="mdi mdi-calendar-note"></span></div>\
								</div>\
								<div class="icon-container icon-td col-md-3">\
									<div class="icon btn-charge"><span class="mdi mdi-local-atm"></span></div>\
								</div>\
								<div class="icon-container icon-td col-md-3">\
									<div class="icon btn-edit"><span class="mdi mdi-edit"></span></div>\
								</div>\
								<div class="icon-container icon-td col-md-3">\
									<div class="icon btn-del"><span class="mdi mdi-delete"></span></div>\
								</div></div>'
			}
		],
		fnDrawCallback: function(data) {
			$(":checkbox[name='cb-check-all']").prop('checked', false);
			//默认选中第一行
			$("tbody tr", $tblist.account).eq(0).click();
		},
		footerCallback: function(row, data, start, end, display) {
			var api = this.api(),
				data;
			// Remove the formatting to get integer data for summation
			var intVal = function(i) {
				return typeof i === 'string' ?
					i.replace(/[\$,]/g, '') * 1 :
					typeof i === 'number' ?
					i : 0;
			};
		},
		ajax: $.extend(true, {}, OPTIONS_CONSTANT.DATA_TABLES.AJAX, {
			url: 'api.php?r=account@list',
			data: function(d) {
				var ent = getentitem(),
					search = $.trim($('#account .search_val').val()),
					group_id = strToInt($("#account .group_id").val());

				if (ent != undefined && strToInt(ent.ent_id) > 0) d.ent_id = ent.ent_id;
				if (search != '') d.search.value = search;
				if (group_id > 0) d.group_id = group_id;

				return $.extend({}, d, {
					extra_search: $('.ent-account .extra').val()
				});
			},
		})
	})).on('xhr.dt', function(e, settings, json, xhr) {
		// Note no return - manipulate the data directly in the JSON object.
	}).on("change", ":checkbox", function() {
		if ($(this).is("[name='cb-check-all']")) {
			//全选
			$(":checkbox", $('.ent-account table')).prop("checked", $(this).prop("checked"));
		} else {
			//一般复选
			var checkbox = $("tbody :checkbox", $('.ent-account table'));
			$(":checkbox[name='cb-check-all']", $('.ent-account table')).prop('checked', checkbox.length == checkbox.filter(
				':checked').length);
		}
	}).on("click", ".td-checkbox", function(event) {
		!$(event.target).is(":checkbox") && $(":checkbox", this).trigger("click");
	}).on("click", ".btn-logger", function() {
		var item = $tblist.account.row($(this).closest('tr')).data();
		$(this).closest('tr').addClass("active").siblings().removeClass("active");
		// window.location.href = 'index.php?r=group@edit&id=' + item.group_id;
		var params = {
			acct_id: item.acct_id,
			ent_id: item.ent_id
		};

		showAjaxModal('user_logger', {
			content: {
				ajax: {
					url: 'modal.php?r=account@logger',
					data: params,
				}
			},
			options: {
				data: {
					data: item,
					success: function(e, d, msg) {
						$tblist.account.ajax.reload();
					}
				}
			}
		}, true, 'modal-bgcolor modal-effect-16');
	}).on("click", ".btn-edit", function() {
		var item = $tblist.account.row($(this).closest('tr')).data();
		$(this).closest('tr').addClass("active").siblings().removeClass("active");
		// window.location.href = 'index.php?r=group@edit&id=' + item.group_id;
		showAjaxModal('edit_account', {
			content: {
				ajax: {
					url: 'modal.php?r=account@edit',
				}
			},
			options: {
				data: {
					data: item,
					success: function(e, d, msg) {
						$tblist.account.ajax.reload();
					}
				}
			}
		}, true, 'modal-bgcolor modal-effect-16');
	}).on("click", ".btn-charge", function() {
		var item = $tblist.account.row($(this).closest('tr')).data();
		$(this).closest('tr').addClass("active").siblings().removeClass("active");
		// window.location.href = 'index.php?r=group@edit&id=' + item.group_id;
		showAjaxModal('addtm_account', {
			content: {
				ajax: {
					url: 'modal.php?r=account@charge',
				}
			},
			options: {
				data: {
					data: item,
					success: function(e, d, msg) {
						$tblist.account.ajax.reload();
					}
				}
			}
		}, true, 'modal-bgcolor modal-effect-16');
	}).on("click", ".btn-del", function() {
		var item = $tblist.account.row($(this).closest('tr')).data();
		$(this).closest('tr').addClass("active").siblings().removeClass("active");
		showAjaxModal('itemdel_account', {
			content: {
				body: {
					content: [
						'<div class="text-center">',
						'<h3>用户删除!</h3>',
						'<p>您是否要继续删除“<span style="color: #ea4335; font-weight: 700;">' + item.name + '</span>”用户，确认后将无法找回！</p>',
						'<div class="mt-4">',
						'<button type="button" data-dismiss="modal" class="btn btn-secondary btn-space modal-close btn-cancel">否</button>',
						'<button type="button" data-dismiss="modal" class="btn btn-success btn-space modal-close btn-ok">是</button>',
						'</div>',
						'</div>'
					].join('')
				},
			},
			options: {
				data: item,
				buttons: [{
					class: 'btn-ok',
					callback: function(btn, modal, event) {
						//You can cancel the modal hide event by returning false
						var params = {
							acct_id: item.acct_id,
							ent_id: item.ent_id
						};
						ajaxgo({
								type: 'POST',
								url: 'api.php?r=account@remove',
								data: params
							},
							function(d, msg) {
								// success reload
								$tblist.account.ajax.reload();
							});
						return true;
					}
				}]
			}
		});
	}).on("click", ".edit-btn", function() {
		var tds = $(this).parents("tr").children();
		$.each(tds, function(i, val) {
			var jqob = $(val);
			if (i < 2 || jqob.has('button').length) {
				return true;
			} //跳过第1项 序号,按钮
			var txt = jqob.text();
			var put = $("<input type='text'>");
			put.val(txt);
			jqob.html(put);
		});
		$(this).html("保存");
		$(this).toggleClass("edit-btn");
		$(this).toggleClass("save-btn");
	});

	$('#account .search_btn').click(function() {
		$tblist.account.draw();
	});

	$("#account .group_id").select2({
		ajax: {
			url: 'api.php?r=group@list&limit=20',
			delay: 600, // wait 600 milliseconds before triggering the request
			processResults: function(data, params) {
				if (ajax_resultCallBack(data) === false) return false;
				params.page = params.page || 1;
				var i, results = {},
					ret = $.map(data.data.rows, function(dr) {
						dr.id = dr.group_id;
						dr.text = dr.name || dr.text;
						dr.ent = dr.ent || dr.name;
						dr.text += ' [' + dr.acctcnt + ']';
						return dr;
					});
				for (i = ret.length - 1; i >= 0; i--) {
					if (results[ret[i].ent] == undefined)
						results[ret[i].ent] = [];
					results[ret[i].ent].push(ret[i]);
				}
				var children;
				if (params.page > 1)
					ret = [];
				else
					ret = [{
						id: 0,
						text: '请选择'
					}];
				for (i in results) {
					results[i].sort(function(a, b) {
						return a.name - b.name
					});
					children = [{
						id: -1 * results[i][0].ent_id,
						text: '显示所有'
					}].concat(results[i]);
					ret.push({
						text: results[i][0].ent,
						children: children
					});
				}
				results = ret.sort(function(a, b) {
					if (a.name > b.name) return 1;
					else if (a.name < b.name) return -1;
					else return 0;
				});
				return {
					results: results,
					pagination: {
						more: (params.page * 10) < data.data.total
					}
				};
			},
			data: function(params) {
				var ent = getentitem(),
					query = {
						search: {
							value: params.term,
							regex: false
						},
						page: params.page || 1
					};
				if (ent != undefined && strToInt(ent.ent_id) > 0) query.ent_id = ent.ent_id;
				// Query parameters will be ?search=[term]&page=[page]
				return query;
			},
		},
		// minimumInputLength: 1,
		escapeMarkup: function(markup) {
			return markup;
		}
	}).on("change", function(e) {
		// $('#select2-group_id-container').text(e.ent + ' -> ' + e.name + ' [' + e.acctcnt + ']');
		$tblist.account.ajax.reload();
	});
}

function online_init() {
	$tblist.online = $('.ent-online table').DataTable($.extend(true, {}, OPTIONS_CONSTANT.DATA_TABLES.DEFAULT_OPTION, {
		pageLength: 50,
		displayLength: 20,
		dom: "<'row'><'row be-datatable-body'<'table-responsive'tr>><'row be-datatable-footer'<'col-sm-5'i><'col-sm-7'p>>",
		columns: [{
				title: '索引',
				data: 'index_js_id',
				width: 30,
				searchable: false,
				orderable: false,
				render: function(data, type, row, meta) {
					return meta.row + 1;
				}
			},
			{
				title: '帐号',
				data: "acct",
				width: 90
			},
			{
				title: '姓名',
				data: "cname",
				width: 90
			},
			{
				title: '开始时间',
				data: "starttm",
				width: 60,
			},
			{
				title: '到期时间',
				data: "expiretm",
				width: 60,
			},
			{
				title: '会话数',
				data: "count",
				width: 60,
			},
			{
				title: '最大在线数',
				data: "maxonline",
				width: 66
			},
			{
				title: 'IP',
				data: "bindip",
				width: 60,
			},
			{
				title: 'MAC',
				data: "bindmac",
				width: 90,
			},
			{
				title: "操作",
				orderable: false,
				data: null,
				width: 68,
				render: optionFormatter
			}
		],
		fnDrawCallback: function(data) {
			$(":checkbox[name='cb-check-all']").prop('checked', false);
			//默认选中第一行
			$("tbody tr", $tblist.online).eq(0).click();
		},
		footerCallback: function(row, data, start, end, display) {
			var api = this.api(),
				data;
			// Remove the formatting to get integer data for summation
			var intVal = function(i) {
				return typeof i === 'string' ?
					i.replace(/[\$,]/g, '') * 1 :
					typeof i === 'number' ?
					i : 0;
			};
		},
		ajax: $.extend(true, {}, OPTIONS_CONSTANT.DATA_TABLES.AJAX, {
			url: 'api.php?r=account@online',
			data: function(d) {
				var ent = getentitem(),
					search = $.trim($('#online .search_val').val());
				group_id = strToInt($("#online .group_id").val());

				if (ent != undefined && strToInt(ent.ent_id) > 0) d.ent_id = ent.ent_id;
				if (search != '') d.search.value = search;
				if (group_id > 0) d.group_id = group_id;

				return $.extend({}, d, {
					extra_search: $('.ent-online .extra').val()
				});
			},
		})
	})).on('xhr.dt', function(e, settings, json, xhr) {
		// Note no return - manipulate the data directly in the JSON object.
	}).on("change", ":checkbox", function() {
		if ($(this).is("[name='cb-check-all']")) {
			// 全选
			$(":checkbox", $('.ent-online table')).prop("checked", $(this).prop("checked"));
		} else {
			// 一般复选
			var checkbox = $("tbody :checkbox", $('.ent-online table'));
			$(":checkbox[name='cb-check-all']", $('.ent-online table')).prop('checked', checkbox.length == checkbox.filter(
				':checked').length);
		}
	}).on("click", ".td-checkbox", function(event) {
		!$(event.target).is(":checkbox") && $(":checkbox", this).trigger("click");
	}).on("click", ".btn-logger", function() {
		var item = $tblist.online.row($(this).closest('tr')).data();
		$(this).closest('tr').addClass("active").siblings().removeClass("active");
		// window.location.href = 'index.php?r=group@edit&id=' + item.group_id;
		var params = {
			acct: item.acct,
			ent_id: item.ent_id
		};

		item.acct_id = 0;
		showAjaxModal('user_logger', {
			content: {
				ajax: {
					url: 'modal.php?r=account@logger',
					data: params,
				}
			},
			options: {
				data: {
					data: item,
					success: function(e, d, msg) {
						$tblist.online.ajax.reload();
					}
				}
			}
		}, true, 'modal-bgcolor modal-effect-16');
	}).on("click", ".btn-session", function() {
		var item = $tblist.online.row($(this).closest('tr')).data();
		$('#session .search_val').val(item.acct);
		$('.nav-tabs a[href="#session"]').click();
		if ($tblist.session != null)
			$tblist.session.ajax.reload();
	}).on("click", ".btn-edit", function() {
		var item = $tblist.online.row($(this).closest('tr')).data();
		$(this).closest('tr').addClass("active").siblings().removeClass("active");
		// window.location.href = 'index.php?r=group@edit&id=' + item.group_id;
		showAjaxModal('edit_account', {
			content: {
				ajax: {
					url: 'modal.php?r=account@edit',
				}
			},
			options: {
				data: {
					data: item,
					success: function(e, d, msg) {
						$tblist.online.ajax.reload();
					}
				}
			}
		}, true, 'modal-bgcolor modal-effect-16');
	}).on("click", ".btn-del", function() {
		var item = $tblist.online.row($(this).closest('tr')).data();
		$(this).closest('tr').addClass("active").siblings().removeClass("active");
		showAjaxModal('itemdel_account', {
			content: {
				body: {
					content: [
						'<div class="text-center">',
						'<h3>用户删除!</h3>',
						'<p>您是否要继续删除“<span style="color: #ea4335; font-weight: 700;">' + item.name + '</span>”用户，确认后将无法找回！</p>',
						'<div class="mt-4">',
						'<button type="button" data-dismiss="modal" class="btn btn-secondary btn-space modal-close btn-cancel">否</button>',
						'<button type="button" data-dismiss="modal" class="btn btn-success btn-space modal-close btn-ok">是</button>',
						'</div>',
						'</div>'
					].join('')
				},
			},
			options: {
				data: item,
				buttons: [{
					class: 'btn-ok',
					callback: function(btn, modal, event) {
						//You can cancel the modal hide event by returning false
						var params = {
							acct_id: item.acct_id,
							ent_id: item.ent_id
						};
						ajaxgo({
								type: 'POST',
								url: 'api.php?r=account@remove',
								data: params
							},
							function(d, msg) {
								// success reload
								$tblist.online.ajax.reload();
							});
						return true;
					}
				}]
			}
		});
	}).on("click", ".edit-btn", function() {
		var tds = $(this).parents("tr").children();
		$.each(tds, function(i, val) {
			var jqob = $(val);
			if (i < 2 || jqob.has('button').length) {
				return true;
			} //跳过第1项 序号,按钮
			var txt = jqob.text();
			var put = $("<input type='text'>");
			put.val(txt);
			jqob.html(put);
		});
		$(this).html("保存");
		$(this).toggleClass("edit-btn");
		$(this).toggleClass("save-btn");
	});

	$('#online .search_btn').click(function() {
		$tblist.online.draw();
	});

	$("#online .group_id").select2({
		ajax: {
			url: 'api.php?r=group@list&limit=20',
			delay: 600, // wait 600 milliseconds before triggering the request
			processResults: function(data, params) {
				if (ajax_resultCallBack(data) === false) return false;
				params.page = params.page || 1;
				var i, results = {},
					ret = $.map(data.data.rows, function(dr) {
						dr.id = dr.group_id;
						dr.text = dr.name || dr.text;
						dr.ent = dr.ent || dr.name;
						dr.text += ' [' + dr.acctcnt + ']';
						return dr;
					});
				for (i = ret.length - 1; i >= 0; i--) {
					if (results[ret[i].ent] == undefined)
						results[ret[i].ent] = [];
					results[ret[i].ent].push(ret[i]);
				}
				if (params.page > 1)
					ret = [];
				else
					ret = [{
						id: 0,
						text: '请选择'
					}];
				var children;
				for (i in results) {
					results[i].sort(function(a, b) {
						return a.name - b.name
					});
					children = [{
						id: -1 * results[i][0].ent_id,
						text: '显示所有'
					}].concat(results[i]);
					ret.push({
						text: results[i][0].ent,
						children: children
					});
				}
				results = ret.sort(function(a, b) {
					if (a.name > b.name) return 1;
					else if (a.name < b.name) return -1;
					else return 0;
				});
				return {
					results: results,
					pagination: {
						more: (params.page * 10) < data.data.total
					}
				};
			},
			data: function(params) {
				var ent = getentitem(),
					query = {
						search: {
							value: params.term,
							regex: false
						},
						page: params.page || 1
					};
				if (ent != undefined && strToInt(ent.ent_id) > 0) query.ent_id = ent.ent_id;
				// Query parameters will be ?search=[term]&page=[page]
				return query;
			},
		},
		// minimumInputLength: 1,
		escapeMarkup: function(markup) {
			return markup;
		}
	}).on("change", function(e) {
		// $('#select2-group_id-container').text(e.ent + ' -> ' + e.name + ' [' + e.acctcnt + ']');
		$tblist.online.ajax.reload();
	});
}

function session_init() {
	$tblist.session = $('.ent-session table').DataTable($.extend(true, {}, OPTIONS_CONSTANT.DATA_TABLES.DEFAULT_OPTION, {
		pageLength: 50,
		displayLength: 20,
		dom: "<'row'><'row be-datatable-body'<'table-responsive'tr>><'row be-datatable-footer'<'col-sm-5'i><'col-sm-7'p>>",
		columns: [{
				title: '索引',
				data: 'index_js_id',
				width: 30,
				searchable: false,
				orderable: false,
				render: function(data, type, row, meta) {
					return meta.row + 1;
				}
			},
			{
				title: '帐号',
				data: "acct",
				width: 90
			},
			{
				title: '会话ID',
				data: "session",
				width: 60,
			},
			{
				title: '事件时间',
				data: "enent_time",
				width: 60,
			},
			{
				title: 'TTL',
				data: "ttl",
				width: 50,
			},
			{
				title: '会话时长',
				data: "session_tmlong",
				width: 60,
			},
			{
				title: 'IP',
				data: "ipaddr",
				width: 90,
			},
			{
				title: 'MAC',
				data: "mac",
				width: 90,
			},
			{
				title: '上行流量',
				data: "in_octets",
				width: 60,
			},
			{
				title: '下行流量',
				data: "out_octets",
				width: 60,
			},
			{
				title: "操作",
				orderable: false,
				data: null,
				width: 68,
				defaultContent: '<div class="row"><div class="icon-container icon-td col-md-6">\
									<div class="icon btn-logger"><span class="mdi mdi-calendar-note"></span></div>\
								</div>\
								<div class="icon-container icon-td col-md-6">\
									<div class="icon btn-del"><span class="mdi mdi-delete"></span></div>\
								</div></div>'
			}
		],
		fnDrawCallback: function(data) {
			$(":checkbox[name='cb-check-all']").prop('checked', false);
			//默认选中第一行
			$("tbody tr", $tblist.session).eq(0).click();
		},
		footerCallback: function(row, data, start, end, display) {
			var api = this.api(),
				data;
			// Remove the formatting to get integer data for summation
			var intVal = function(i) {
				return typeof i === 'string' ?
					i.replace(/[\$,]/g, '') * 1 :
					typeof i === 'number' ?
					i : 0;
			};
		},
		ajax: $.extend(true, {}, OPTIONS_CONSTANT.DATA_TABLES.AJAX, {
			url: 'api.php?r=account@session',
			data: function(d) {
				var ent = getentitem(),
					search = $.trim($('#session .search_val').val());

				if (ent != undefined && strToInt(ent.ent_id) > 0) d.ent_id = ent.ent_id;
				if (search != '') d.search.value = search;

				return $.extend({}, d, {
					extra_search: $('#session .extra').val()
				});
			},
		})
	})).on('xhr.dt', function(e, settings, json, xhr) {
		// Note no return - manipulate the data directly in the JSON object.
	}).on("change", ":checkbox", function() {
		if ($(this).is("[name='cb-check-all']")) {
			//全选
			$(":checkbox", $('.ent-session table')).prop("checked", $(this).prop("checked"));
		} else {
			//一般复选
			var checkbox = $("tbody :checkbox", $('.ent-session table'));
			$(":checkbox[name='cb-check-all']", $('.ent-session table')).prop('checked', checkbox.length == checkbox.filter(
				':checked').length);
		}
	}).on("click", ".td-checkbox", function(event) {
		!$(event.target).is(":checkbox") && $(":checkbox", this).trigger("click");
	}).on("click", ".btn-logger", function() {
		var item = $tblist.session.row($(this).closest('tr')).data();
		$(this).closest('tr').addClass("active").siblings().removeClass("active");
		// window.location.href = 'index.php?r=group@edit&id=' + item.group_id;
		var params = {
			acct: item.acct,
			ent_id: item.ent_id
		};

		item.acct_id = 0;
		showAjaxModal('user_logger', {
			content: {
				ajax: {
					url: 'modal.php?r=account@logger',
					data: params,
				}
			},
			options: {
				data: {
					data: item,
					success: function(e, d, msg) {
						$tblist.session.ajax.reload();
					}
				}
			}
		}, true, 'modal-bgcolor modal-effect-16');
	}).on("click", ".btn-edit", function() {
		var item = $tblist.session.row($(this).closest('tr')).data();
		$(this).closest('tr').addClass("active").siblings().removeClass("active");
		// window.location.href = 'index.php?r=group@edit&id=' + item.group_id;
		showAjaxModal('edit_group', {
			content: {
				ajax: {
					url: 'modal.php?r=account@edit',
				}
			},
			options: {
				data: {
					data: item,
					success: function(e, d, msg) {
						$tblist.session.ajax.reload();
					}
				}
			}
		}, true, 'modal-bgcolor modal-effect-16');
	}).on("click", ".btn-del", function() {
		var item = $tblist.session.row($(this).closest('tr')).data();
		$(this).closest('tr').addClass("active").siblings().removeClass("active");
		showAjaxModal('itemdel_session', {
			content: {
				body: {
					content: [
						'<div class="text-center">',
						'<h3>下线用户!</h3>',
						'<p>是否要继续让用户会话“<span style="color: #ea4335; font-weight: 700;">' + item.session + '</span>”下线？</p>',
						'<div class="mt-4">',
						'<button type="button" data-dismiss="modal" class="btn btn-secondary btn-space modal-close btn-cancel">否</button>',
						'<button type="button" data-dismiss="modal" class="btn btn-success btn-space modal-close btn-ok">是</button>',
						'</div>',
						'</div>'
					].join('')
				},
			},
			options: {
				data: item,
				buttons: [{
					class: 'btn-ok',
					callback: function(btn, modal, event) {
						//You can cancel the modal hide event by returning false
						var params = {
							acct: item.acct,
							session: item.session
						};
						ajaxgo({
								type: 'POST',
								url: 'api.php?r=account@kick',
								data: params
							},
							function(d, msg) {
								// success reload
								$tblist.session.ajax.reload();
							});
						return true;
					}
				}]
			}
		});
	}).on("click", ".edit-btn", function() {
		var tds = $(this).parents("tr").children();
		$.each(tds, function(i, val) {
			var jqob = $(val);
			if (i < 2 || jqob.has('button').length) {
				return true;
			} //跳过第1项 序号,按钮
			var txt = jqob.text();
			var put = $("<input type='text'>");
			put.val(txt);
			jqob.html(put);
		});
		$(this).html("保存");
		$(this).toggleClass("edit-btn");
		$(this).toggleClass("save-btn");
	});

	$('#session .search_btn').click(function() {
		$tblist.session.draw();
	});
}

function iwan_init() {
	$tblist.iwan = $('.ent-iwan table').DataTable($.extend(true, {}, OPTIONS_CONSTANT.DATA_TABLES.DEFAULT_OPTION, {
		pageLength: 50,
		displayLength: 20,
		dom: "<'row'><'row be-datatable-body'<'table-responsive'tr>><'row be-datatable-footer'<'col-sm-5'i><'col-sm-7'p>>",
		columns: [{
				title: '索引',
				data: 'index_js_id',
				width: 30,
				searchable: false,
				orderable: false,
				render: function(data, type, row, meta) {
					return meta.row + 1;
				}
			},
			{
				title: '名称',
				data: "name",
				width: 100
			},
			{
				title: '运营商',
				data: "isp",
				width: 60,
				render: ISPFormatter
			},
			{
				title: 'IP地址',
				data: "ipaddr",
				width: 150,
				orderable: false,
				render: ipFormatter
			},
			{
				title: '端口',
				data: "port",
				width: 80
			},
			{
				title: '当前帐号数',
				data: "count",
				width: 70
			},
			{
				title: '最大帐号数',
				data: "max",
				width: 70
			},
			{
				title: '备注',
				data: "remark",
			},
			{
				title: '更新日期',
				data: "update_time",
				width: 120,
				render: dateFormatter
			},
			{
				title: "操作",
				orderable: false,
				data: null,
				width: 96,
				render: popContentFormatter
			}
		],
		createdRow: function(row, data, dataIndex) {
			var id = getURL_val('id');
			if (data.enable == 0)
				$(row).addClass('row-disabled');
			if (data.group_id == id)
				$(row).addClass('row-select');
		},
		fnDrawCallback: function(data) {
			$(":checkbox[name='cb-check-all']").prop('checked', false);
			//默认选中第一行
			$("tbody tr", $tblist.iwan).eq(0).click();
		},
		footerCallback: function(row, data, start, end, display) {
			var api = this.api(),
				data;
			// Remove the formatting to get integer data for summation
			var intVal = function(i) {
				return typeof i === 'string' ?
					i.replace(/[\$,]/g, '') * 1 :
					typeof i === 'number' ?
					i : 0;
			};
		},
		ajax: $.extend(true, {}, OPTIONS_CONSTANT.DATA_TABLES.AJAX, {
			url: 'api.php?r=iwanpop@list',
			data: function(d) {
				var ent = getentitem(),
					search = $.trim($('#iwan .search_val').val());

				if (ent != undefined && strToInt(ent.ent_id) > 0) d.ent_id = ent.ent_id;
				if (search != '') d.search.value = search;

				return $.extend({}, d, {
					extra_search: $('#iwan .extra').val()
				});
			}
		})
	})).on('xhr.dt', function(e, settings, json, xhr) {
		// Note no return - manipulate the data directly in the JSON object.
	}).on("change", ":checkbox", function() {
		if ($(this).is("[name='cb-check-all']")) {
			//全选
			$(":checkbox", $('.ent-iwan table')).prop("checked", $(this).prop("checked"));
		} else {
			//一般复选
			var checkbox = $("tbody :checkbox", $('.ent-iwan table'));
			$(":checkbox[name='cb-check-all']", $('.ent-iwan table')).prop('checked', checkbox.length == checkbox.filter(
				':checked').length);
		}
	}).on("click", ".td-checkbox", function(event) {
		!$(event.target).is(":checkbox") && $(":checkbox", this).trigger("click");
	}).on("click", ".btn-eye", function() {
		var item = $tblist.iwan.row($(this).closest('tr')).data();
		$(this).closest('tr').addClass("active").siblings().removeClass("active");
		showAjaxModal('itemsale_iwanpop', {
			content: {
				body: {
					content: [
						'<div class="text-center">',
						'<h3>POP点发布管理!</h3>',
						'<p>您是否要' + (item.disabled ? '发布' : '关闭') + '“<span style="color: #ea4335; font-weight: 700;">' + item.name +
						' - ' + ISPFormatter(item.isp) + '</span>”POP点' + (item.disabled ? '！若发布，用户则可在客户端选用此POP点服务。' :
							'的发布！若关闭，用户将无法在客户端选用此POP点，但不会影响已在使用的用户。') + '</p>',
						'<div class="mt-4">',
						'<button type="button" data-dismiss="modal" class="btn btn-secondary btn-space modal-close btn-cancel">否</button>',
						'<button type="button" data-dismiss="modal" class="btn btn-success btn-space modal-close btn-ok">是</button>',
						'</div>',
						'</div>'
					].join('')
				},
			},
			options: {
				data: item,
				buttons: [{
					class: 'btn-ok',
					callback: function(btn, modal, event) {
						//You can cancel the modal hide event by returning false
						var params = {
							iwan_id: item.iwan_id
						};
						ajaxgo({
								type: 'POST',
								url: 'api.php?r=iwanpop@' + (item.disabled ? 'enable' : 'disable'),
								data: params
							},
							function(d, msg) {
								// success reload
								$tblist.iwan.ajax.reload();
							});
						return true;
					}
				}]
			}
		});
	}).on("click", ".btn-edit", function() {
		$(this).closest('tr').addClass("active").siblings().removeClass("active");
		// window.location.href = 'index.php?r=group@edit&id=' + item.group_id;
		showAjaxModal('edit_iwanpop', {
			content: {
				ajax: {
					url: 'modal.php?r=iwanpop@edit',
				}
			},
			options: {
				data: {
					data: function(e) {
						return $tblist.iwan.row($('.ent-iwan table').find('tr.active')).data();
					},
					success: function(e, d, msg) {
						$tblist.iwan.ajax.reload();
					}
				}
			}
		}, true, 'modal-bgcolor modal-effect-16');
	}).on("click", ".btn-del", function() {
		var item = $tblist.iwan.row($(this).closest('tr')).data();
		$(this).closest('tr').addClass("active").siblings().removeClass("active");
		showAjaxModal('itemdel_iwanpop', {
			content: {
				body: {
					content: [
						'<div class="text-center">',
						'<h3>iWAN POP点删除!</h3>',
						'<p>您是否要继续删除“<span style="color: #ea4335; font-weight: 700;">' + item.name + ' - ' + ISPFormatter(item.isp) +
						'</span>”POP点，确认后将无法找回！</p>',
						'<div class="mt-4">',
						'<button type="button" data-dismiss="modal" class="btn btn-secondary btn-space modal-close btn-cancel">否</button>',
						'<button type="button" data-dismiss="modal" class="btn btn-success btn-space modal-close btn-ok">是</button>',
						'</div>',
						'</div>'
					].join('')
				},
			},
			options: {
				data: item,
				buttons: [{
					class: 'btn-ok',
					callback: function(btn, modal, event) {
						//You can cancel the modal hide event by returning false
						var params = {
							iwan_id: item.iwan_id
						};
						ajaxgo({
								type: 'POST',
								url: 'api.php?r=iwanpop@remove',
								data: params
							},
							function(d, msg) {
								// success reload
								$tblist.iwan.ajax.reload();
							});
						return true;
					}
				}]
			}
		});
	}).on("click", ".edit-btn", function() {
		var tds = $(this).parents("tr").children();
		$.each(tds, function(i, val) {
			var jqob = $(val);
			if (i < 2 || jqob.has('button').length) {
				return true;
			} //跳过第1项 序号,按钮
			var txt = jqob.text();
			var put = $("<input type='text'>");
			put.val(txt);
			jqob.html(put);
		});
		$(this).html("保存");
		$(this).toggleClass("edit-btn");
		$(this).toggleClass("save-btn");
	});

	$('#iwan .search_btn').click(function() {
		$tblist.iwan.draw();
	});
}


function iwacct_init() {
	$tblist.iwacct = $('.ent-iwacct table').DataTable($.extend(true, {}, OPTIONS_CONSTANT.DATA_TABLES.DEFAULT_OPTION, {
		pageLength: 50,
		displayLength: 20,
		dom: "<'row'><'row be-datatable-body'<'table-responsive'tr>><'row be-datatable-footer'<'col-sm-5'i><'col-sm-7'p>>",
		columns: [{
				title: '索引',
				data: 'index_js_id',
				width: 30,
				searchable: false,
				orderable: false,
				render: function(data, type, row, meta) {
					return meta.row + 1;
				}
			},
			{
				title: '编号',
				data: "serialno",
				width: 100
			},
			{
				title: '认证帐号',
				data: "account",
				width: 100,
				fnCreatedCell: function(nTd, sData, oData, iRow, iCol) {
					$(nTd).html('<a href="javascript:void(0);" class="auth-account">' + sData + '</a>');
				}
			},
			{
				title: '申请人',
				data: "name",
				width: 120
			},
			{
				title: '联系电话',
				data: "phone",
				width: 100
			},
			{
				title: 'QQ',
				data: "qq",
				width: 100
			},
			{
				title: 'Email',
				data: "email",
			},
			{
				title: '创建日期',
				data: "create_time",
				width: 120,
				render: dateFormatter
			},
			{
				title: "操作",
				orderable: false,
				data: null,
				width: 68,
				defaultContent: '<div class="row"><div class="icon-container icon-td col-md-6">\
									<div class="icon btn-edit"><span class="mdi mdi-edit"></span></div>\
								</div>\
								<div class="icon-container icon-td col-md-6">\
									<div class="icon btn-del"><span class="mdi mdi-delete"></span></div>\
								</div></div>'
			}
		],
		createdRow: function(row, data, dataIndex) {
			var id = getURL_val('id');
			if (data.enable == 0)
				$(row).addClass('row-disabled');
			if (data.group_id == id)
				$(row).addClass('row-select');
		},
		fnDrawCallback: function(data) {
			$(":checkbox[name='cb-check-all']").prop('checked', false);
			//默认选中第一行
			$("tbody tr", $tblist.iwacct).eq(0).click();
		},
		footerCallback: function(row, data, start, end, display) {
			var api = this.api(),
				data;
			// Remove the formatting to get integer data for summation
			var intVal = function(i) {
				return typeof i === 'string' ?
					i.replace(/[\$,]/g, '') * 1 :
					typeof i === 'number' ?
					i : 0;
			};
		},
		ajax: $.extend(true, {}, OPTIONS_CONSTANT.DATA_TABLES.AJAX, {
			url: 'api.php?r=iwaccount@list',
			data: function(d) {
				var ent = getentitem(),
					search = $.trim($('#iwacct .search_val').val());

				if (ent != undefined && strToInt(ent.ent_id) > 0) d.ent_id = ent.ent_id;
				if (search != '') d.search.value = search;

				return $.extend({}, d, {
					extra_search: $('#iwacct .extra').val()
				});
			}
		})
	})).on('xhr.dt', function(e, settings, json, xhr) {
		// Note no return - manipulate the data directly in the JSON object.
	}).on("change", ":checkbox", function() {
		if ($(this).is("[name='cb-check-all']")) {
			//全选
			$(":checkbox", $('.ent-iwacct table')).prop("checked", $(this).prop("checked"));
		} else {
			//一般复选
			var checkbox = $("tbody :checkbox", $('.ent-iwacct table'));
			$(":checkbox[name='cb-check-all']", $('.ent-iwacct table')).prop('checked', checkbox.length == checkbox.filter(
				':checked').length);
		}
	}).on("click", ".td-checkbox", function(event) {
		!$(event.target).is(":checkbox") && $(":checkbox", this).trigger("click");
	}).on("click", ".auth-account", function() {
		var item = $tblist.iwacct.row($(this).closest('tr')).data();
		$(this).closest('tr').addClass("active").siblings().removeClass("active");

		ajaxgo({
				type: 'POST',
				url: 'api.php?r=account@info',
				data: {
					acct_id: item.acct_id
				}
			},
			function(d, msg) {
				showAjaxModal('edit_account', {
					content: {
						ajax: {
							url: 'modal.php?r=account@edit',
						}
					},
					options: {
						data: {
							data: d,
							success: function(e, d, msg) {
								// $tblist.account.ajax.reload();
							}
						}
					}
				}, true, 'modal-bgcolor modal-effect-16');
			});
	}).on("click", ".btn-edit", function() {
		$(this).closest('tr').addClass("active").siblings().removeClass("active");
		// window.location.href = 'index.php?r=group@edit&id=' + item.group_id;
		showAjaxModal('edit_iwacct', {
			content: {
				ajax: {
					url: 'modal.php?r=iwaccount@edit',
				}
			},
			options: {
				data: {
					data: function(e) {
						return $tblist.iwacct.row($('.ent-iwacct table').find('tr.active')).data();
					},
					success: function(e, d, msg) {
						$tblist.iwacct.ajax.reload();
					}
				}
			}
		}, true, 'modal-bgcolor modal-effect-16');
	}).on("click", ".btn-del", function() {
		var item = $tblist.iwacct.row($(this).closest('tr')).data();
		$(this).closest('tr').addClass("active").siblings().removeClass("active");
		showAjaxModal('itemdel_iwacct', {
			content: {
				body: {
					content: [
						'<div class="text-center">',
						'<h3>快线帐号删除!</h3>',
						'<p>您是否要继续删除“<span style="color: #ea4335; font-weight: 700;">' + item.serialno + '.' + item.account +
						'</span>帐号”，确认后将无法找回！</p>',
						'<div class="mt-4">',
						'<button type="button" data-dismiss="modal" class="btn btn-secondary btn-space modal-close btn-cancel">否</button>',
						'<button type="button" data-dismiss="modal" class="btn btn-success btn-space modal-close btn-ok">是</button>',
						'</div>',
						'</div>'
					].join('')
				},
			},
			options: {
				data: item,
				buttons: [{
					class: 'btn-ok',
					callback: function(btn, modal, event) {
						//You can cancel the modal hide event by returning false
						var params = {
							iwacct_id: item.iwacct_id
						};
						ajaxgo({
								type: 'POST',
								url: 'api.php?r=iwaccount@remove',
								data: params
							},
							function(d, msg) {
								// success reload
								$tblist.iwacct.ajax.reload();
							});
						return true;
					}
				}]
			}
		});
	}).on("click", ".edit-btn", function() {
		var tds = $(this).parents("tr").children();
		$.each(tds, function(i, val) {
			var jqob = $(val);
			if (i < 2 || jqob.has('button').length) {
				return true;
			} //跳过第1项 序号,按钮
			var txt = jqob.text();
			var put = $("<input type='text'>");
			put.val(txt);
			jqob.html(put);
		});
		$(this).html("保存");
		$(this).toggleClass("edit-btn");
		$(this).toggleClass("save-btn");
	});

	$('#iwacct .search_btn').click(function() {
		$tblist.iwacct.draw();
	});
}

var entdata = {
	total: 0,
	rows: []
};

function getentitem() {
	var id = $(".aside-box .nav>.active").index();

	return entdata.rows[id];
}

function tabselect(id, reload) {
	$('.ent-item').removeClass('show');
	$('.home-content-box').removeClass('show-survey');
	if (typeof $tblist[id] != "object") return;

	if ($tblist[id] == null) {
		if (id == 'group') group_init();
		if (id == 'account') account_init();
		if (id == 'online') online_init();
		if (id == 'session') session_init();
		if (id == 'iwan') iwan_init();
		if (id == 'iwacct') iwacct_init();
		if (id == 'home') home_init();
	} else
	if (id == 'home') {
		home_init();
	} else
	if (reload) $tblist[id].ajax.reload();

	$('.ent-' + id).addClass('show');
}

function set_default_domain(domain) {
	var rows = entdata.rows;

	for (var i = 0; i < rows.length; i++) {
		if (rows[i].domain == domain) {
			$(".aside-box .nav li").removeClass('default-domain').eq(i).addClass('default-domain');
			break;
		}
	}
}

$(document).ready(function() {
	App.init();

	var time = new Date(g_today_timestamp * 1000);
	g_curdate = time.format('yyyy-MM');

	$('.nav-tabs a').on('click', function() {
		tabselect($(this).attr('href').substr(1), true);
	});

	function aside_reload() {
		var param = {};
		var search = $.trim($('.aside-box .search_val').val());
		if (search != '') {
			param.search = {
				value: search,
				regex: false
			};
		}
		ajaxgo({
				url: 'api.php?r=enterpise@list',
				data: param,
			},
			function(d, msg) {
				var i;
				var e, nav = $(".aside-box .nav");
				var ent = getentitem();
				var ent_id = 0;
				nav.children().remove();

				if (ent != undefined) ent_id = ent.ent_id;
				for (i = 0; i < d.rows.length; i++) {
					e = $('<li><a href="javascript:void(0);">' + d.rows[i].name + '</a></li>');
					e.appendTo(nav);

					if (ent_id == d.rows[i].ent_id) e.addClass('active');
				}

				$(".aside-box .nav").off('click').on('click', 'li', function() {
					var e = $(this);
					var id = e.index();

					$(".aside-box .nav li").removeClass('active');
					e.addClass('active');
					$('.home-content-box .tab-title').text(entdata.rows[id].name);

					id = $('.home-content-box .nav-link.active').attr('href');
					tabselect(id.substr(1), true);

				});
				entdata = d;
				if (getentitem() == undefined)
					$('.home-content-box').removeClass('show-survey').addClass('show-survey');

				$.ajax({
					url: 'api.php?r=enterpise@default-domain',
					success: function(d) {
						if (d.ret == 0)
							set_default_domain(d.data);
					}
				});
			});
	}

	$(".aside-box .search_btn").click(function() {
		aside_reload();
	});

	$(".aside-box .new_btn").click(function() {
		showAjaxModal('create_enterpise', {
			content: {
				ajax: {
					url: 'modal.php?r=enterpise@create',
				}
			},
			options: {
				data: {
					success: function(e, d, msg) {
						aside_reload();
					}
				}
			}
		}, true, 'modal-bgcolor modal-effect-16');
	});
	aside_reload();

	$(".reg-iwanconf").click(function() {
		showAjaxModal('create_iwansvr', {
			content: {
				ajax: {
					url: 'modal.php?r=enterpise@iwansvr',
				}
			},
			options: {
				data: {
					data: function(e) {
						var item = getentitem();
						return item;
					},
					success: function(e, d, msg) {
						aside_reload();
					}
				}
			}
		}, true, 'modal-bgcolor modal-effect-16');
	});
	$(".set-traffic").click(function() {
		showAjaxModal('set_traffic', {
			content: {
				ajax: {
					url: 'modal.php?r=iwantraffic@list',
				}
			},
			options: {
				data: {
					data: function(e) {
						var item = getentitem();
						return item;
					},
					success: function(e, d, msg) {
						aside_reload();
					}
				}
			}
		}, true, 'modal-bgcolor modal-effect-16');
	});

	$(".reg-entdel").click(function() {
		var item = getentitem();
		showAjaxModal('itemdel_iwanpop', {
			content: {
				body: {
					content: [
						'<div class="text-center">',
						'<h3>项目删除!</h3>',
						'<p>您是否要继续删除“<span style="color: #ea4335; font-weight: 700;">' + item.name + '</span>”项目，确认后将无法找回！</p>',
						'<div class="mt-4">',
						'<button type="button" data-dismiss="modal" class="btn btn-secondary btn-space modal-close btn-cancel">否</button>',
						'<button type="button" data-dismiss="modal" class="btn btn-success btn-space modal-close btn-ok">是</button>',
						'</div>',
						'</div>'
					].join('')
				},
			},
			options: {
				data: item,
				buttons: [{
					class: 'btn-ok',
					callback: function(btn, modal, event) {
						//You can cancel the modal hide event by returning false
						var params = {
							ent_id: item.ent_id
						};
						ajaxgo({
								type: 'POST',
								url: 'api.php?r=enterpise@remove',
								data: params
							},
							function(d, msg) {
								// success reload
								aside_reload();
							});
						return true;
					}
				}]
			}
		});
	});

	$(".reg-entedit").click(function() {
		showAjaxModal('edit_enterpise', {
			content: {
				ajax: {
					url: 'modal.php?r=enterpise@edit',
				}
			},
			options: {
				data: {
					data: function(e) {
						var item = getentitem();
						return item;
					},
					success: function(e, d, msg) {
						aside_reload();
					}
				}
			}
		}, true, 'modal-bgcolor modal-effect-16');
	});

	$(".reg-importacct").click(function() {
		showAjaxModal('enterpise_importacct', {
			content: {
				ajax: {
					url: 'modal.php?r=enterpise@importacct',
				}
			},
			options: {
				data: {
					data: function(e) {
						var item = getentitem();
						return item;
					},
					success: function(e, d, msg) {
						aside_reload();
					}
				}
			}
		}, true, 'modal-bgcolor modal-effect-16');
	});

	$(".reg-exportacct").click(function() {
		showAjaxModal('enterpise_exportacct', {
			content: {
				ajax: {
					url: 'modal.php?r=enterpise@exportacct',
				}
			},
			options: {
				data: {
					data: function(e) {
						var item = getentitem();
						return item;
					},
					success: function(e, d, msg) {
						aside_reload();
					}
				}
			}
		}, true, 'modal-bgcolor modal-effect-16');
	});

	$(".reg-account").click(function() {
		showAjaxModal('create_account', {
			content: {
				ajax: {
					url: 'modal.php?r=account@create',
				}
			},
			options: {
				data: {
					success: function(e, d, msg) {
						$tblist.account.ajax.reload();
					}
				}
			}
		}, true, 'modal-bgcolor modal-effect-16');
	});

	$(".reg-group").click(function() {
		var ent = getentitem();
		showAjaxModal('create_group', {
			content: {
				ajax: {
					url: 'modal.php?r=group@create',
				}
			},
			options: {
				data: {
					data: {
						ent_id: ent.ent_id
					},
					success: function(e, d, msg) {
						$tblist.account.ajax.reload();
					}
				}
			}
		}, true, 'modal-bgcolor modal-effect-16');
	});

	$(".reg-iwan").click(function() {
		var ent = getentitem();
		showAjaxModal('create_iwanpop', {
			content: {
				ajax: {
					url: 'modal.php?r=iwanpop@create',
				}
			},
			options: {
				data: {
					data: {
						ent_id: ent.ent_id
					},
					success: function(e, d, msg) {
						$tblist.iwan.ajax.reload();
					}
				}
			}
		}, true, 'modal-bgcolor modal-effect-16');
	});

	$(".reg-iwacct").click(function() {
		var ent = getentitem();
		showAjaxModal('create_iwacct', {
			content: {
				ajax: {
					url: 'modal.php?r=iwaccount@create',
				}
			},
			options: {
				data: {
					data: {
						ent_id: ent.ent_id
					},
					success: function(e, d, msg) {
						$tblist.iwacct.ajax.reload();
					}
				}
			}
		}, true, 'modal-bgcolor modal-effect-16');
	});

	$(".del-selected").click(function() {

		var selectitem = $(":checkbox[name!='cb-check-all']:checked", $('.ent-account table'));

		if (selectitem.length <= 0) return;

		showAjaxModal('account_delete', {
			content: {
				body: {
					content: [
						'<div class="text-center">',
						'<h3>删除当前选中用户!</h3>',
						'<p>是否要继续删除当前选中的“<span style="color: #ea4335; font-weight: 700;">' + selectitem.length +
						'</span>”个用户？确认后将无法找回！</p>',
						'<div class="mt-4">',
						'<button type="button" data-dismiss="modal" class="btn btn-secondary btn-space modal-close btn-cancel">否</button>',
						'<button type="button" data-dismiss="modal" class="btn btn-success btn-space modal-close btn-ok">是</button>',
						'</div>',
						'</div>'
					].join('')
				},
			},
			options: {
				buttons: [{
					class: 'btn-ok',
					callback: function(btn, modal, event) {
						//You can cancel the modal hide event by returning false
						var i, item, count = 0,
							success = 0;
						for (i = 0; i < selectitem.length; i++) {
							item = $tblist.account.row(selectitem.eq(i).closest('tr')).data();
							ajaxgo({
									type: 'POST',
									url: 'api.php?r=account@remove',
									data: {
										acct_id: item.acct_id,
										ent_id: item.ent_id
									}
								},
								function(d, msg) {},
								function(d) {
									success++;
									if (++count == selectitem.length) {
										$tblist.account.ajax.reload();
										if (selectitem.length - count == 0) {
											$.gritter.add({
												title: "操作完毕",
												text: "共计删除“" + success + "”个用户！",
												class_name: "color success"
											});
										} else {
											$.gritter.add({
												title: "错误",
												text: "有“" + (selectitem.length - success) + "”个用户未删除成功！",
												class_name: "color danger"
											});
										}
									}

									return false;
								});
						}
						return true;
					}
				}]
			}
		});
	});

});
