function dateFormatter(data, type, row, meta) {
	return $.myTime.UnixToStrDate(data, true);
}

function ipFormatter(data, type, row, meta) {
	return _int2iP(data);
}

function editroletoken(role_id, name)
{
	showAjaxModal('edit_token', {
		content:{
			ajax: {
				url: 'modal.php?r=role@token',
			}
		},
		options:{
			data: {
				data: {
					role_id: role_id,
					name: name
				},
				success: function(e, d, msg){
					$tblist.role_mgd.ajax.reload();
				}
			}
		}
	}, true, 'modal-bgcolor modal-effect-16');
}

function refresh_package(db)
{
	var i, d = [];
//	db = $tblist.package.data();

	for(var i = 0; i < db.length; i++) {
		d.push(db[i].user_id);
	}

	$.ajax({
		url: 'api.php?r=package@getrole',
		data: {uids: d},
		success: function (data){
			if(data.ret != 0) return;

			var i, key, tb = {};
			for (i = 0; i < data.data.length; i++) {
				key = 'op' + data.data[i].user_id;
				if(typeof(tb[key]) != "object") tb[key] = {id: data.data[i].user_id, list:[]};
				tb[key].list.push('<a href=\'javascript:editroletoken('+data.data[i].role_id+', "'+data.data[i].name+'");\'>' + data.data[i].name + '</a>');
			}

			$('.card-package table td>span').html('');
			for (key in tb) {
				$(tb[key].list.join('，')).appendTo($('.card-package table .user_role_table_' + tb[key].id));
			}
		}
	});
}

var $tblist = {
	package: null,
	presale_card: null,
	presale_item: null,
	presale_logger: null
};

function package_init()
{
	$tblist.package = $('.card-package table').DataTable($.extend(true,{},OPTIONS_CONSTANT.DATA_TABLES.DEFAULT_OPTION, {
		pageLength: 50,
		displayLength: 20,
		dom: "<'row'><'row be-datatable-body'<'table-responsive'tr>><'row be-datatable-footer'<'col-sm-5'i><'col-sm-7'p>>",
		columns: [
			{
				title: '索引',
				data: 'index_js_id',
				width: 30,
				searchable: false,
				orderable: false,
				render: function(data, type, row, meta) {
					return meta.row + 1;
				}
			},
			{
				title: '名称',
				data: "name",
				width: 120
			},
			{
				title: '费用',
				data: "expense",
				width: 140,
				render: function (data, type, row, meta) {
					var tmtype = ['', '分', '时', '天', '月', '年'];
					if(row.tmtype)
						return data + '￥ / ' + row.tmlong + tmtype[row.tmtype];
					return data + '￥';
				}
			},
			{
				title: '应用数',
				data: "count",
			},
			{
				title: '创建时间',
				data: "create_time",
				width: 120,
				render: dateFormatter
			},
			{
				title: "操作",
				orderable: false,
				data: null,
				width: 96,
				defaultContent: '<div class="row"><div class="icon-container icon-td col-md-4">\
									<div class="icon btn-option"><span class="mdi mdi-settings"></span></div>\
								</div>\
								<div class="icon-container icon-td col-md-4">\
									<div class="icon btn-edit"><span class="mdi mdi-edit"></span></div>\
								</div>\
								<div class="icon-container icon-td col-md-4">\
									<div class="icon btn-del"><span class="mdi mdi-delete"></span></div>\
								</div></div>'
		}],
		createdRow: function( row, data, dataIndex ) {
			var id = getURL_val('id');
			if ( data.enable == 0)
				$(row).addClass('row-disabled');
		},
		fnDrawCallback: function (data) {
			$(":checkbox[name='cb-check-all']").prop('checked', false);
			// 默认选中第一行
			$("tbody tr", $tblist.package).eq(0).click();
			
			//if(data.json.ret == 0 && data.json.data.length > 0)
			//	refresh_package(data.json.data);
		},
		footerCallback: function (row, data, start, end, display ) {
			var api = this.api(), data;
			// Remove the formatting to get integer data for summation
			var intVal = function ( i ) {
				return typeof i === 'string' ?
					i.replace(/[\$,]/g, '')*1 :
					typeof i === 'number' ?
						i : 0;
			};
		},
		ajax: $.extend(true, {}, OPTIONS_CONSTANT.DATA_TABLES.AJAX, {
			url: 'api.php?r=package@list',
			data: function (d) {
				var search = $.trim($('#package .search_val').val());

				if(search != '') d.search.value = search;

				return $.extend({}, d, {
					extra_search: $('#package .extra').val()
				});
			}
		})
	})).on('xhr.dt', function ( e, settings, json, xhr ) {
		// Note no return - manipulate the data directly in the JSON object.
	}).on("change", ":checkbox", function() {
        if($(this).is("[name='cb-check-all']")) {
            //全选
            $(":checkbox", $('.card-package table')).prop("checked",$(this).prop("checked"));
        } else {
            //一般复选
            var checkbox = $("tbody :checkbox", $('.card-package table'));
            $(":checkbox[name='cb-check-all']", $('.card-package table')).prop('checked', checkbox.length == checkbox.filter(':checked').length);
        }
    }).on("click", ".td-checkbox", function(event) {
        !$(event.target).is(":checkbox") && $(":checkbox",this).trigger("click");
    }).on("click", ".btn-option", function() {
        $(this).closest('tr').addClass("active").siblings().removeClass("active");
        // window.location.href = 'index.php?r=group@edit&id=' + item.group_id;
		showAjaxModal('package_option', {
			content:{
				ajax: {
					url: 'modal.php?r=package@option',
				}
			},
			options:{
				data: {
					data: function(e) {
						return $tblist.package.row($('.card-package table').find('tr.active')).data();
					},
					success: function(e, d, msg) {
						$tblist.package.ajax.reload();
					}
				},
				afterClose: function () {
					//var db = $tblist.package.data();
					$tblist.package.ajax.reload();
					//if(db.length > 0) refresh_package(db)
				}
			}
		}, true, 'modal-bgcolor modal-effect-16');
    }).on("click", ".btn-edit", function() {
        $(this).closest('tr').addClass("active").siblings().removeClass("active");
        // window.location.href = 'index.php?r=group@edit&id=' + item.group_id;
		showAjaxModal('edit_package', {
			content:{
				ajax: {
					url: 'modal.php?r=package@edit',
				}
			},
			options:{
				data: {
					data: function(e) {
						return $tblist.package.row($('.card-package table').find('tr.active')).data();
					},
					success: function(e, d, msg){
						$tblist.package.ajax.reload();
					}
				}
			}
		}, true, 'modal-bgcolor modal-effect-16');
    }).on("click", ".btn-del", function() {
        var item = $tblist.package.row($(this).closest('tr')).data();
        $(this).closest('tr').addClass("active").siblings().removeClass("active");
		showAjaxModal('delele_package', {
			content: {
				body: {
					content: [
						'<div class="text-center">',
						'<h3>套餐删除!</h3>',
						'<p>您是否要继续删除“<span style="color: #ea4335; font-weight: 700;">' + item.name + '</span>”套餐，确认后将无法找回！</p>',
						'<div class="mt-4">',
                            '<button type="button" data-dismiss="modal" class="btn btn-secondary btn-space modal-close btn-cancel">否</button>',
                            '<button type="button" data-dismiss="modal" class="btn btn-success btn-space modal-close btn-ok">是</button>',
						'</div>',
						'</div>'
					].join('')
				},
			},
			options: {
				data: item,
				buttons: [
				  {
					class: 'btn-ok',
					callback: function ( btn, modal, event ) {
					  //You can cancel the modal hide event by returning false
						var params = {package_id: item.package_id};
						ajaxgo({
							type: 'POST',
							url: 'api.php?r=package@remove',
							data: params
						},
						function (d, msg){
							// success reload
							$tblist.package.ajax.reload();
						});
						return true;
					}
				  }
				]
			}
		});
    }).on("click", ".edit-btn", function() {
		var tds = $(this).parents("tr").children();
		$.each(tds, function(i, val){
			var jqob = $(val);
			if(i < 2 || jqob.has('button').length ){return true;} //跳过第1项 序号,按钮
			var txt=jqob.text();
			var put=$("<input type='text'>");
			put.val(txt);
			jqob.html(put);
		});
		$(this).html("保存");
		$(this).toggleClass("edit-btn");
		$(this).toggleClass("save-btn");
	});

	$('.card-package .search_btn').click(function(){
		$tblist.package.draw();
	});
}

function presale_card_init()
{
	$tblist.presale_card = $('.card-presale_card table').DataTable($.extend(true,{},OPTIONS_CONSTANT.DATA_TABLES.DEFAULT_OPTION, {
		pageLength: 50,
		displayLength: 20,
		dom: "<'row'><'row be-datatable-body'<'table-responsive'tr>><'row be-datatable-footer'<'col-sm-5'i><'col-sm-7'p>>",
		columns: [
			{
				title: '索引',
				data: 'index_js_id',
				width: 30,
				searchable: false,
				orderable: false,
				render: function (data, type, row, meta) {
					return meta.row + 1;
				}
			},
			{
				title: '名称',
				data: "name",
				width: 100
			},
			{
				title: '绑定项目',
				data: "ent_id",
				width: 100,
				render: function (data, type, row, meta) {
					if(parseInt(data) == 0) return '';
					return '<span data-row-entid="' + data + '"></span>';
				}
			},
			{
				title: '可用时长',
				data: "tmlong",
				width: 120,
				render: function (data, type, row, meta) {
					var tmtype = ['', '分', '时', '天', '月', '年'];
					if(row.tmtype)
						return data + ' ' + tmtype[row.tmtype];
					return data;
				}
			},
			{
				title: '上行带宽',
				data: "rate_out",
				width: 120,
				render: function (data, type, row, meta) {
					return formatbps(data).replace('bps', '');
				}
			},
			{
				title: '下行带宽',
				data: "rate_in",
				width: 120,
				render: function (data, type, row, meta) {
					return formatbps(data).replace('bps', '');
				}
			},
			{
				title: '费用',
				data: "expense",
				width: 140,
				render: function (data, type, row, meta) {
					return data + '￥';
				}
			},
			{
				title: '已使用数',
				data: "usedcnt",
			},
			{
				title: '已删除数',
				data: "rmvcnt",
			},
			{
				title: '总发行数',
				data: "count",
			},
			{
				title: '创建时间',
				data: "create_time",
				width: 120,
				render: dateFormatter
			},
			{
				title: "操作",
				orderable: false,
				data: null,
				width: 128,
				defaultContent: '<div class="row"><div class="icon-container icon-td col-md-3">\
									<div class="icon btn-card"><span class="mdi mdi-card"></span></div>\
								</div>\
								<div class="icon-container icon-td col-md-3">\
									<div class="icon btn-carddown"><span class="mdi mdi-square-down"></span></div>\
								</div>\
								<div class="icon-container icon-td col-md-3">\
									<div class="icon btn-edit"><span class="mdi mdi-edit"></span></div>\
								</div>\
								<div class="icon-container icon-td col-md-3">\
									<div class="icon btn-del"><span class="mdi mdi-delete"></span></div>\
								</div></div>'
		}],
		createdRow: function( row, data, dataIndex ) {
			var id = getURL_val('id');
			if ( data.enable == 0)
				$(row).addClass('row-disabled');
		},
		fnDrawCallback: function (data) {
			$(":checkbox[name='cb-check-all']").prop('checked', false);
			// 默认选中第一行
			$("tbody tr", $tblist.presale_card).eq(0).click();
			//if(data.json.ret == 0 && data.json.data.length > 0)
			//	refresh_package(data.json.data);
			var entid = [];
			$('.card-presale_card [data-row-entid]').each(function(i, e){
				var id = parseInt(e.getAttribute('data-row-entid'));
				if(id) entid.push(id);
			});
			if(entid.length == 0) return;
			$.ajax({
				url: 'api.php?r=presale_card@list-sm',
				data: {ids: entid},
				success: function(d){
					if(d.ret) return;
					var i, data =  d.data.rows;

					for(i = 0; i < data.length; i++)
						$('.card-presale_card [data-row-entid="' + data[i].ent_id + '"]').text(data[i].name);

				}
			});
		},
		footerCallback: function (row, data, start, end, display ) {
			var api = this.api(), data;
			// Remove the formatting to get integer data for summation
			var intVal = function ( i ) {
				return typeof i === 'string' ?
					i.replace(/[\$,]/g, '')*1 :
					typeof i === 'number' ?
						i : 0;
			};
		},
		ajax: $.extend(true, {}, OPTIONS_CONSTANT.DATA_TABLES.AJAX, {
			url: 'api.php?r=presale_card@list',
			data: function (d) {
				var search = $.trim($('#presale_card .search_val').val());

				if(search != '') d.search.value = search;

				return $.extend({}, d, {
					extra_search: $('#presale_card .extra').val()
				});
			}
		})
	})).on('xhr.dt', function ( e, settings, json, xhr ) {
		// Note no return - manipulate the data directly in the JSON object.
	}).on("change", ":checkbox", function() {
        if($(this).is("[name='cb-check-all']")) {
            //全选
            $(":checkbox", $('.card-presale_card table')).prop("checked",$(this).prop("checked"));
        } else {
            //一般复选
            var checkbox = $("tbody :checkbox", $('.card-presale_card table'));
            $(":checkbox[name='cb-check-all']", $('.card-presale_card table')).prop('checked', checkbox.length == checkbox.filter(':checked').length);
        }
    }).on("click", ".td-checkbox", function(event) {
        !$(event.target).is(":checkbox") && $(":checkbox",this).trigger("click");
    }).on("click", ".btn-card", function() {
        $(this).closest('tr').addClass("active").siblings().removeClass("active");
        // window.location.href = 'index.php?r=group@edit&id=' + item.group_id;
		showAjaxModal('presale_card_option', {
			content:{
				ajax: {
					url: 'modal.php?r=presale_card@card-batbuild',
				}
			},
			options:{
				data: {
					data: function(e) {
						return $tblist.presale_card.row($('.card-presale_card table').find('tr.active')).data();
					},
					success: function(e, d, msg) {
						$tblist.presale_card.ajax.reload();
					}
				},
				afterClose: function () {
					//var db = $tblist.presale_card.data();
					$tblist.presale_card.ajax.reload();
					//if(db.length > 0) refresh_package(db)
				}
			}
		}, true, 'modal-bgcolor modal-effect-16');
    }).on("click", ".btn-carddown", function() {
        $(this).closest('tr').addClass("active").siblings().removeClass("active");
        // window.location.href = 'index.php?r=group@edit&id=' + item.group_id;
		showAjaxModal('presale_carddown_option', {
			content:{
				ajax: {
					url: 'modal.php?r=presale_card@card-down',
				}
			},
			options:{
				data: {
					data: function(e) {
						return $tblist.presale_card.row($('.card-presale_card table').find('tr.active')).data();
					},
					success: function(e, d, msg) {
						//$tblist.presale_card.ajax.reload();
					}
				},
				afterClose: function () {
					//var db = $tblist.presale_card.data();
					//$tblist.presale_card.ajax.reload();
					//if(db.length > 0) refresh_package(db)
				}
			}
		}, true, 'modal-bgcolor modal-effect-16');
    }).on("click", ".btn-edit", function() {
        $(this).closest('tr').addClass("active").siblings().removeClass("active");
        // window.location.href = 'index.php?r=group@edit&id=' + item.group_id;
		showAjaxModal('edit_presale_card', {
			content:{
				ajax: {
					url: 'modal.php?r=presale_card@edit',
				}
			},
			options:{
				data: {
					data: function(e) {
						return $tblist.presale_card.row($('.card-presale_card table').find('tr.active')).data();
					},
					success: function(e, d, msg){
						$tblist.presale_card.ajax.reload();
					}
				}
			}
		}, true, 'modal-bgcolor modal-effect-16');
    }).on("click", ".btn-del", function() {
        var item = $tblist.presale_card.row($(this).closest('tr')).data();
        $(this).closest('tr').addClass("active").siblings().removeClass("active");
		showAjaxModal('delele_presale_card', {
			content: {
				body: {
					content: [
						'<div class="text-center">',
						'<h3>充值卡删除!</h3>',
						'<p>您是否要继续删除“<span style="color: #ea4335; font-weight: 700;">' + item.name + '</span>”充值卡，确认后将无法找回！</p>',
						'<div class="mt-4">',
                            '<button type="button" data-dismiss="modal" class="btn btn-secondary btn-space modal-close btn-cancel">否</button>',
                            '<button type="button" data-dismiss="modal" class="btn btn-success btn-space modal-close btn-ok">是</button>',
						'</div>',
						'</div>'
					].join('')
				},
			},
			options: {
				data: item,
				buttons: [
				  {
					class: 'btn-ok',
					callback: function ( btn, modal, event ) {
					  //You can cancel the modal hide event by returning false
						var params = {psc_id: item.psc_id};
						ajaxgo({
							type: 'POST',
							url: 'api.php?r=presale_card@remove',
							data: params
						},
						function (d, msg){
							// success reload
							$tblist.presale_card.ajax.reload();
						});
						return true;
					}
				  }
				]
			}
		});
    }).on("click", ".edit-btn", function() {
		var tds = $(this).parents("tr").children();
		$.each(tds, function(i, val){
			var jqob = $(val);
			if(i < 2 || jqob.has('button').length ){return true;} //跳过第1项 序号,按钮
			var txt=jqob.text();
			var put=$("<input type='text'>");
			put.val(txt);
			jqob.html(put);
		});
		$(this).html("保存");
		$(this).toggleClass("edit-btn");
		$(this).toggleClass("save-btn");
	});

}

function presale_item_init()
{
	$tblist.presale_item = $('.card-presale_item table').DataTable($.extend(true,{},OPTIONS_CONSTANT.DATA_TABLES.DEFAULT_OPTION, {
		pageLength: 50,
		displayLength: 20,
		order: [[7, 'desc']],
		dom: "<'row'><'row be-datatable-body'<'table-responsive'tr>><'row be-datatable-footer'<'col-sm-5'i><'col-sm-7'p>>",
		columns: [
			{
				title: '索引',
				data: 'index_js_id',
				width: 30,
				searchable: false,
				orderable: false,
				render: function (data, type, row, meta) {
					return meta.row + 1;
				}
			},
			{
				title: '名称',
				data: "name",
				width: 100
			},
			{
				title: '可用时长',
				data: "tmlong",
				width: 64,
				render: function (data, type, row, meta) {
					var tmtype = ['', '分', '时', '天', '月', '年'];
					if(row.tmtype)
						return data + ' ' + tmtype[row.tmtype];
					return data;
				}
			},
			{
				title: '上行带宽',
				data: "rate_out",
				width: 64,
				render: function (data, type, row, meta) {
					return formatbps(data).replace('bps', '');
				}
			},
			{
				title: '下行带宽',
				data: "rate_in",
				width: 64,
				render: function (data, type, row, meta) {
					return formatbps(data).replace('bps', '');
				}
			},
			{
				title: '面值',
				data: "expense",
				width: 64,
				render: function (data, type, row, meta) {
					return data + '￥';
				}
			},
			{
				title: '绑定项目',
				data: "ent_id",
				width: 120,
				render: function (data, type, row, meta) {
					if(parseInt(data) == 0) return '';
					return '<span data-row-entid="' + data + '"></span>';
				}
			},
			{
				title: '创建时间',
				data: "create_time",
				width: 120,
				render: dateFormatter
			},
			{
				title: '卡有效期',
				data: "expire_time",
				width: 240,
				render: function (data, type, row, meta) {
					var str = '不限';
					
					if(data) {
						str = $.myTime.UnixToStrDate(row.start_time, true) + ' - ' + $.myTime.UnixToStrDate(data, true);
						if(g_today_timestamp < row.start_time || g_today_timestamp > row.expire_time) 
							return '<span style="color: rgb(234, 67, 53);">' + str + '</span>';
					}
					return '<span style="color: rgb(52, 168, 83);">' + str + '</span>';
				}
			},
			{
				title: '卡号',
				data: "psi_code",
				width: 100
			},
			{
				title: "操作",
				orderable: false,
				data: null,
				width: 96,
				defaultContent: '<div class="row"><div class="icon-container icon-td col-md-4">\
									<div class="icon btn-del"><span class="mdi mdi-delete"></span></div>\
								</div></div>'
		}],
		createdRow: function( row, data, dataIndex ) {
			var id = getURL_val('id');
			if ( data.enable == 0)
				$(row).addClass('row-disabled');
		},
		fnDrawCallback: function (data) {
			$(".card-presale_item :checkbox[name='cb-check-all']").prop('checked', false);
			// 默认选中第一行
			$(".card-presale_item tbody tr", $tblist.presale_item).eq(0).click();
			//if(data.json.ret == 0 && data.json.data.length > 0)
			//	refresh_package(data.json.data);
			var entid = [];
			$('.card-presale_item [data-row-entid]').each(function(i, e){
				var id = parseInt(e.getAttribute('data-row-entid'));
				if(id) entid.push(id);
			});
			if(entid.length == 0) return;
			$.ajax({
				url: 'api.php?r=presale_card@list-sm',
				data: {ids: entid},
				success: function(d){
					if(d.ret) return;
					var i, data =  d.data.rows;

					for(i = 0; i < data.length; i++)
						$('.card-presale_item [data-row-entid="' + data[i].ent_id + '"]').text(data[i].name);

				}
			});
		},
		footerCallback: function (row, data, start, end, display ) {
			var api = this.api(), data;
			// Remove the formatting to get integer data for summation
			var intVal = function ( i ) {
				return typeof i === 'string' ?
					i.replace(/[\$,]/g, '')*1 :
					typeof i === 'number' ?
						i : 0;
			};
		},
		ajax: $.extend(true, {}, OPTIONS_CONSTANT.DATA_TABLES.AJAX, {
			url: 'api.php?r=presale_card@card-list',
			data: function (d) {
				var search = $.trim($('#presale_item .search_val').val());

				if(search != '') d.search.value = search;

				return $.extend({}, d, {
					extra_search: $('#presale_item .extra').val()
				});
			}
		})
	})).on('xhr.dt', function ( e, settings, json, xhr ) {
		// Note no return - manipulate the data directly in the JSON object.
	}).on("change", ":checkbox", function() {
        if($(this).is("[name='cb-check-all']")) {
            //全选
            $(":checkbox", $('.card-presale_item table')).prop("checked",$(this).prop("checked"));
        } else {
            //一般复选
            var checkbox = $("tbody :checkbox", $('.card-presale_item table'));
            $(":checkbox[name='cb-check-all']", $('.card-presale_item table')).prop('checked', checkbox.length == checkbox.filter(':checked').length);
        }
    }).on("click", ".td-checkbox", function(event) {
        !$(event.target).is(":checkbox") && $(":checkbox",this).trigger("click");
    }).on("click", ".btn-del", function() {
        var item = $tblist.presale_item.row($(this).closest('tr')).data();
        $(this).closest('tr').addClass("active").siblings().removeClass("active");
		showAjaxModal('delele_presale_item', {
			content: {
				body: {
					content: [
						'<div class="text-center">',
						'<h3>已发卡删除!</h3>',
						'<p>您是否要继续删除该“<span style="color: #ea4335; font-weight: 700;">' + item.name + '</span>”卡，确认后将无法找回！</p>',
						'<div class="mt-4">',
                            '<button type="button" data-dismiss="modal" class="btn btn-secondary btn-space modal-close btn-cancel">否</button>',
                            '<button type="button" data-dismiss="modal" class="btn btn-success btn-space modal-close btn-ok">是</button>',
						'</div>',
						'</div>'
					].join('')
				},
			},
			options: {
				data: item,
				buttons: [
				  {
					class: 'btn-ok',
					callback: function ( btn, modal, event ) {
					  //You can cancel the modal hide event by returning false
						var params = {psi_code: item.psi_code, psc_id: item.psc_id};
						ajaxgo({
							type: 'POST',
							url: 'api.php?r=presale_card@card-remove',
							data: params
						},
						function (d, msg){
							// success reload
							$tblist.presale_item.ajax.reload();
						});
						return true;
					}
				  }
				]
			}
		});
    }).on("click", ".edit-btn", function() {
		var tds = $(this).parents("tr").children();
		$.each(tds, function(i, val){
			var jqob = $(val);
			if(i < 2 || jqob.has('button').length ){return true;} //跳过第1项 序号,按钮
			var txt=jqob.text();
			var put=$("<input type='text'>");
			put.val(txt);
			jqob.html(put);
		});
		$(this).html("保存");
		$(this).toggleClass("edit-btn");
		$(this).toggleClass("save-btn");
	});

}

function presale_logger_init()
{
	$tblist.presale_logger = $('.card-presale_logger table').DataTable($.extend(true,{},OPTIONS_CONSTANT.DATA_TABLES.DEFAULT_OPTION, {
		pageLength: 50,
		displayLength: 20,
		order: [[9, 'desc']],
		dom: "<'row'><'row be-datatable-body'<'table-responsive'tr>><'row be-datatable-footer'<'col-sm-5'i><'col-sm-7'p>>",
		columns: [
			{
				title: '索引',
				data: 'index_js_id',
				width: 30,
				searchable: false,
				orderable: false,
				render: function (data, type, row, meta) {
					return meta.row + 1;
				}
			},
			{
				title: '名称',
				data: "name",
				width: 100
			},
			{
				title: '可用时长',
				data: "tmlong",
				width: 64,
				render: function (data, type, row, meta) {
					var tmtype = ['', '分', '时', '天', '月', '年'];
					if(row.tmtype)
						return data + ' ' + tmtype[row.tmtype];
					return data;
				}
			},
			{
				title: '上行带宽',
				data: "rate_out",
				width: 64,
				render: function (data, type, row, meta) {
					return formatbps(data).replace('bps', '');
				}
			},
			{
				title: '下行带宽',
				data: "rate_in",
				width: 64,
				render: function (data, type, row, meta) {
					return formatbps(data).replace('bps', '');
				}
			},
			{
				title: '面值',
				data: "expense",
				width: 60,
				render: function (data, type, row, meta) {
					return data + '￥';
				}
			},
			{
				title: '绑定项目',
				data: "ent_id",
				width: 100,
				render: function (data, type, row, meta) {
					if(parseInt(data) == 0) return '';
					return '<span data-row-entid="' + data + '"></span>';
				}
			},
			{
				title: '创建时间',
				data: "create_time",
				width: 120,
				render: dateFormatter
			},
			{
				title: '卡有效期',
				data: "expire_time",
				width: 240,
				render: function (data, type, row, meta) {
					var str = '不限';
					
					if(data) {
						str = $.myTime.UnixToStrDate(row.start_time, true) + ' - ' + $.myTime.UnixToStrDate(data, true);
						if(row.curr_time < row.start_time || row.curr_time > row.expire_time) 
							return '<span style="color: rgb(234, 67, 53);">' + str + '</span>';
					}
					return '<span style="color: rgb(52, 168, 83);">' + str + '</span>';
				}
			},
			{
				title: '使用时间',
				data: "update_time",
				width: 120,
				render: function (data, type, row, meta) {
					if(row.operation == 2)
						return $.myTime.UnixToStrDate(data, true);
					else
						return '';
				}
			},
			{
				title: '卡号/帐号/订单号|说明',
				data: "psi_code",
				width: 130,
				render: function (data, type, row, meta) {
					var str, ope = parseInt(row.operation);
					if(ope == 0)
						str = '<span style="color: rgb(234, 67, 53);">' + data + '：删除</span>';
					else
					if(ope == 1)
						str = '<span style="color: rgb(234, 67, 53);">' + data + '：过期</span>';
					else
					if(ope == 2)
						str = '<span style="color: rgb(52, 168, 83);">' + data + '：' + row.account + (row.ordernum?'/'+row.ordernum:'') + '</span>';
					else
						str = data;
					return str;
				}
			}
		],
		createdRow: function( row, data, dataIndex ) {
			var id = getURL_val('id');
			if ( data.enable == 0)
				$(row).addClass('row-disabled');
		},
		fnDrawCallback: function (data) {
			$(".card-presale_logger :checkbox[name='cb-check-all']").prop('checked', false);
			// 默认选中第一行
			$("tbody tr", $tblist.presale_logger).eq(0).click();
			//if(data.json.ret == 0 && data.json.data.length > 0)
			//	refresh_package(data.json.data);
			var entid = [];
			$('.card-presale_logger [data-row-entid]').each(function(i, e){
				var id = parseInt(e.getAttribute('data-row-entid'));
				if(id) entid.push(id);
			});
			if(entid.length == 0) return;
			$.ajax({
				url: 'api.php?r=presale_card@list-sm',
				data: {ids: entid},
				success: function(d){
					if(d.ret) return;
					var i, data =  d.data.rows;

					for(i = 0; i < data.length; i++)
						$('.card-presale_logger [data-row-entid="' + data[i].ent_id + '"]').text(data[i].name);

				}
			});
		},
		footerCallback: function (row, data, start, end, display ) {
			var api = this.api(), data;
			// Remove the formatting to get integer data for summation
			var intVal = function ( i ) {
				return typeof i === 'string' ?
					i.replace(/[\$,]/g, '')*1 :
					typeof i === 'number' ?
						i : 0;
			};
		},
		ajax: $.extend(true, {}, OPTIONS_CONSTANT.DATA_TABLES.AJAX, {
			url: 'api.php?r=presale_card@logger-list',
			data: function (d) {
				var search = $.trim($('#presale_logger .search_val').val());

				if(search != '') d.search.value = search;

				return $.extend({}, d, {
					extra_search: $('#presale_logger .extra').val()
				});
			}
		})
	})).on('xhr.dt', function ( e, settings, json, xhr ) {
		// Note no return - manipulate the data directly in the JSON object.
	}).on("change", ":checkbox", function() {
        if($(this).is("[name='cb-check-all']")) {
            //全选
            $(":checkbox", $('.card-presale_logger table')).prop("checked",$(this).prop("checked"));
        } else {
            //一般复选
            var checkbox = $("tbody :checkbox", $('.card-presale_logger table'));
            $(":checkbox[name='cb-check-all']", $('.card-presale_logger table')).prop('checked', checkbox.length == checkbox.filter(':checked').length);
        }
    }).on("click", ".td-checkbox", function(event) {
        !$(event.target).is(":checkbox") && $(":checkbox",this).trigger("click");
    }).on("click", ".edit-btn", function() {
		var tds = $(this).parents("tr").children();
		$.each(tds, function(i, val){
			var jqob = $(val);
			if(i < 2 || jqob.has('button').length ){return true;} //跳过第1项 序号,按钮
			var txt=jqob.text();
			var put=$("<input type='text'>");
			put.val(txt);
			jqob.html(put);
		});
		$(this).html("保存");
		$(this).toggleClass("edit-btn");
		$(this).toggleClass("save-btn");
	});

}

function tabselect(id, reload)
{
	if(typeof $tblist[id] != "object") return;
	$('.tab-card-item .card-table').removeClass('show');

	if($tblist[id] == null) {
		if(id == 'package') package_init();
		if(id == 'presale_card') presale_card_init();
		if(id == 'presale_item') presale_item_init();
		if(id == 'presale_logger') presale_logger_init();
	}
	else
	if (reload) $tblist[id].ajax.reload();

	$('.tab-card-item.card-' + id + ' .card-table').addClass('show');
}

$(document).ready(function(){
	App.init();

	$(".datetimepicker").datetimepicker(OPTIONS_CONSTANT.DATA_DATETIMEPICKER);

	$('.nav-tabs a').on('click', function(){
		tabselect($(this).attr('href').substr(1), true);
	});

	if($('.mgd-tab').length > 0)
		tabselect($('.mgd-tab').eq(0).attr('id'), true);
	else
		tabselect('package', true);

	$(".reg-btn").click(function(){
		var e = $(this).parents('.tab-pane');
		var id = e.attr('id');
		showAjaxModal('create_' + id, {
			content:{
				ajax: {
					url: 'modal.php?r='+id+'@create',
				}
			},
			options:{
				data: {
					success: function(e, d, msg) {
						$tblist[id].ajax.reload();
					}
				}
			}
		}, true, 'modal-bgcolor modal-effect-16');
	});

	$('.search_btn').click(function(){
		var e = $(this).parents('.tab-pane');
		var id = e.attr('id');
		$tblist[id].draw();
	});

});
