function dateFormatter(data, type, row, meta) {
	return $.myTime.UnixToStrDate(data);
}

function ipFormatter(data, type, row, meta) {
	return _int2iP(data);
}

function editroletoken(role_id, name)
{
	showAjaxModal('edit_token', {
		content:{
			ajax: {
				url: 'modal.php?r=role@token',
			}
		},
		options:{
			data: {
				data: {
					role_id: role_id,
					name: name
				},
				success: function(e, d, msg){
					$tblist.role_mgd.ajax.reload();
				}
			}
		}
	}, true, 'modal-bgcolor modal-effect-16');
}

function refresh_role(db)
{
	var i, d = [];
//	db = $tblist.user_mgd.data();

	for(var i = 0; i < db.length; i++) {
		d.push(db[i].user_id);
	}

	$.ajax({
		url: 'api.php?r=role@getrole',
		data: {uids: d},
		success: function (data){
			if(data.ret != 0) return;

			var i, key, tb = {};
			for (i = 0; i < data.data.length; i++) {
				key = 'op' + data.data[i].user_id;
				if(typeof(tb[key]) != "object") tb[key] = {id: data.data[i].user_id, list:[]};
				tb[key].list.push('<a href=\'javascript:editroletoken('+data.data[i].role_id+', "'+data.data[i].name+'");\'>' + data.data[i].name + '</a>');
			}

			$('#user_mgd table td>span').html('');
			for (key in tb) {
				$(tb[key].list.join('，')).appendTo($('#user_mgd table .user_role_table_' + tb[key].id));
			}
		}
	});
}

var $tblist = {
	user_mgd: null, 
	role_mgd: null
};

function user_init()
{
	$tblist.user_mgd = $('#user_mgd table').DataTable($.extend(true,{},OPTIONS_CONSTANT.DATA_TABLES.DEFAULT_OPTION, {
		pageLength: 50,
		displayLength: 20,
		dom: "<'row'><'row be-datatable-body'<'table-responsive'tr>><'row be-datatable-footer'<'col-sm-5'i><'col-sm-7'p>>",
		columns: [
			{
				title: '索引',
				data: 'index_js_id',
				width: 30,
				searchable: false,
				orderable: false,
				render: function(data, type, row, meta) {
					return meta.row + 1;
				}
			},
			{
				title: '帐号',
				data: "account",
				width: 100
			},
			{
				title: '姓名',
				data: "name",
				width: 120
			},
			{
				title: '联系电话',
				data: "phone",
				width: 90,
			},
			{
				title: 'E-mail',
				data: "email",
				width: 140,
			},
			{
				title: '负责项目',
				data: "entcnt",
				width: 80,
				render: function(data, type, row, meta) {
					return '<a href="javascript:void(0);" class="btn-modify-ent">' + data + '</a>';
				}
			},
			{
				title: '角色',
				orderable: false,
				data: null,
				render: function(data, type, row, meta) {
					return '<span class="user_role_table_' + row.user_id + '"></span><div class="icon-container icon-td role-token">\
										<div class="icon btn-modify-role">\
											<span class="mdi mdi-edit"></span>\
										</div>\
									</div>';
				}
			},
			{
				title: '创建时间',
				data: "create_time",
				width: 90,
				render: dateFormatter
			},
			{
				title: "操作",
				orderable: false,
				data: null,
				width: 126,
				defaultContent: '<div class="row"><div class="icon-container icon-td col-md-3">\
									<div class="icon btn-modify-ent"><span class="mdi mdi-settings"></span></div>\
								</div>\
								<div class="icon-container icon-td col-md-3">\
									<div class="icon btn-modify-role"><span class="mdi mdi-account-box"></span></div>\
								</div>\
								<div class="icon-container icon-td col-md-3">\
									<div class="icon btn-edit"><span class="mdi mdi-edit"></span></div>\
								</div>\
								<div class="icon-container icon-td col-md-3">\
									<div class="icon btn-del"><span class="mdi mdi-delete"></span></div>\
								</div></div>'
		}],
		createdRow: function( row, data, dataIndex ) {
			var id = getURL_val('id');
			if ( data.enable == 0)
				$(row).addClass('row-disabled');
			if ( data.group_id == id)
				$(row).addClass('row-select');
		},
		fnDrawCallback: function (data) {
			$(":checkbox[name='cb-check-all']").prop('checked', false);
			// 默认选中第一行
			$("tbody tr", $tblist.user_mgd).eq(0).click();
			
			if(data.json.ret == 0 && data.json.data.length > 0)
				refresh_role(data.json.data);
		},
		footerCallback: function (row, data, start, end, display ) {
			var api = this.api(), data;
			// Remove the formatting to get integer data for summation
			var intVal = function ( i ) {
				return typeof i === 'string' ?
					i.replace(/[\$,]/g, '')*1 :
					typeof i === 'number' ?
						i : 0;
			};
		},
		ajax: $.extend(true, {}, OPTIONS_CONSTANT.DATA_TABLES.AJAX, {
			url: 'api.php?r=user@list',
			data: function (d) {
				var search = $.trim($('#user_mgd .search-val').val());

				if(search != '') d.search.value = search;

				return $.extend({}, d, {
					extra_search: $('#user_mgd .extra').val()
				});
			}
		})
	})).on('xhr.dt', function ( e, settings, json, xhr ) {
		// Note no return - manipulate the data directly in the JSON object.
	}).on("click", ".btn-modify-ent", function() {
        $(this).closest('tr').addClass("active").siblings().removeClass("active");
        // window.location.href = 'index.php?r=group@edit&id=' + item.group_id;
		showAjaxModal('edit_entascription', {
			content:{
				ajax: {
					url: 'modal.php?r=user@option',
				}
			},
			options:{
				data: {
					data: function(e) {
						return $tblist.user_mgd.row($('#user_mgd table').find('tr.active')).data();
					},
					success: function(e, d, msg) {
						$tblist.user_mgd.ajax.reload();
					}
				},
				afterClose: function () {
					//var db = $tblist.user_mgd.data();
					$tblist.user_mgd.ajax.reload();
					//if(db.length > 0) refresh_package(db)
				}
			}
		}, true, 'modal-bgcolor modal-effect-16');
    }).on("change", ":checkbox", function() {
        if($(this).is("[name='cb-check-all']")) {
            //全选
            $(":checkbox", $('#user_mgd table')).prop("checked",$(this).prop("checked"));
        } else {
            //一般复选
            var checkbox = $("tbody :checkbox", $('#user_mgd table'));
            $(":checkbox[name='cb-check-all']", $('#user_mgd table')).prop('checked', checkbox.length == checkbox.filter(':checked').length);
        }
    }).on("click", ".td-checkbox", function(event) {
        !$(event.target).is(":checkbox") && $(":checkbox",this).trigger("click");
    }).on("click", ".btn-modify-role", function() {
        $(this).closest('tr').addClass("active").siblings().removeClass("active");
        // window.location.href = 'index.php?r=group@edit&id=' + item.group_id;
		showAjaxModal('edit_role', {
			content:{
				ajax: {
					url: 'modal.php?r=role@allot',
				}
			},
			options:{
				data: {
					data: function(e) {
						return $tblist.user_mgd.row($('#user_mgd table').find('tr.active')).data();
					},
					success: function(e, d, msg) {
						$tblist.user_mgd.ajax.reload();
					}
				},
				afterClose: function () {
					var db = $tblist.user_mgd.data();
					if(db.length > 0) refresh_role(db)
				}
			}
		}, true, 'modal-bgcolor modal-effect-16');
    }).on("click", ".btn-edit", function() {
        $(this).closest('tr').addClass("active").siblings().removeClass("active");
        // window.location.href = 'index.php?r=group@edit&id=' + item.group_id;
		showAjaxModal('edit_user', {
			content:{
				ajax: {
					url: 'modal.php?r=user@edit',
				}
			},
			options:{
				data: {
					data: function(e) {
						return $tblist.user_mgd.row($('#user_mgd table').find('tr.active')).data();
					},
					success: function(e, d, msg){
						$tblist.user_mgd.ajax.reload();
					}
				}
			}
		}, true, 'modal-bgcolor modal-effect-16');
    }).on("click", ".btn-del", function() {
        var item = $tblist.user_mgd.row($(this).closest('tr')).data();
        $(this).closest('tr').addClass("active").siblings().removeClass("active");
		showAjaxModal('itemdel_user', {
			content: {
				body: {
					content: [
						'<div class="text-center">',
						'<h3>帐号删除!</h3>',
						'<p>您是否要继续删除“<span style="color: #ea4335; font-weight: 700;">' + item.account + '</span>”帐号，确认后将无法找回！</p>',
						'<div class="mt-4">',
                            '<button type="button" data-dismiss="modal" class="btn btn-secondary btn-space modal-close btn-cancel">否</button>',
                            '<button type="button" data-dismiss="modal" class="btn btn-success btn-space modal-close btn-ok">是</button>',
						'</div>',
						'</div>'
					].join('')
				},
			},
			options: {
				data: item,
				buttons: [
				  {
					class: 'btn-ok',
					callback: function ( btn, modal, event ) {
					  //You can cancel the modal hide event by returning false
						var params = {user_id: item.user_id};
						ajaxgo({
							type: 'POST',
							url: 'api.php?r=user@remove',
							data: params
						},
						function (d, msg){
							// success reload
							$tblist.user_mgd.ajax.reload();
						});
						return true;
					}
				  }
				]
			}
		});
    }).on("click", ".edit-btn", function() {
		var tds = $(this).parents("tr").children();
		$.each(tds, function(i, val){
			var jqob = $(val);
			if(i < 2 || jqob.has('button').length ){return true;} //跳过第1项 序号,按钮
			var txt=jqob.text();
			var put=$("<input type='text'>");
			put.val(txt);
			jqob.html(put);
		});
		$(this).html("保存");
		$(this).toggleClass("edit-btn");
		$(this).toggleClass("save-btn");
	});

	$('#user_mgd .search-btn').click(function(){
		$tblist.user_mgd.draw();
	});
}

function role_init()
{
	$tblist.role_mgd = $('#role_mgd table').DataTable($.extend(true,{},OPTIONS_CONSTANT.DATA_TABLES.DEFAULT_OPTION, {
		pageLength: 50,
		displayLength: 20,
		dom: "<'row'><'row be-datatable-body'<'table-responsive'tr>><'row be-datatable-footer'<'col-sm-5'i><'col-sm-7'p>>",
		columns: [
			{
				title: '索引',
				data: 'index_js_id',
				width: 30,
				searchable: false,
				orderable: false,
				render: function(data, type, row, meta) {
					return meta.row + 1;
				}
			},
			{
				title: '角色',
				data: "name",
				width: 160
			},
			{
				title: '用户数',
				data: "usedcnt",
				width: 100
			},
			{
				title: '更新日期',
				data: "update_time",
				render: function (data, type, row, meta) {
					return $.myTime.UnixToStrDate(data, true);
				}
		},
		{
				title: "操作",
				orderable: false,
				data: null,
				width: 92,
				defaultContent: '<div class="row"><div class="icon-container icon-td col-md-4">\
									<div class="icon btn-modify-token"><span class="mdi mdi-settings"></span></div>\
								</div>\
								<div class="icon-container icon-td col-md-4">\
									<div class="icon btn-edit"><span class="mdi mdi-edit"></span></div>\
								</div>\
								<div class="icon-container icon-td col-md-4">\
									<div class="icon btn-del"><span class="mdi mdi-delete"></span></div>\
								</div></div>'
		}],
		createdRow: function( row, data, dataIndex ) {
			var id = getURL_val('id');
			if ( data.enable == 0)
				$(row).addClass('row-disabled');
			if ( data.group_id == id)
				$(row).addClass('row-select');
		},
		fnDrawCallback: function (data) {
			$(":checkbox[name='cb-check-all']").prop('checked', false);
			//默认选中第一行
			$("tbody tr", $tblist.role_mgd).eq(0).click();
		},
		footerCallback: function (row, data, start, end, display ) {
			var api = this.api(), data;
			// Remove the formatting to get integer data for summation
			var intVal = function ( i ) {
				return typeof i === 'string' ?
					i.replace(/[\$,]/g, '')*1 :
					typeof i === 'number' ?
						i : 0;
			};
		},
		ajax: $.extend(true, {}, OPTIONS_CONSTANT.DATA_TABLES.AJAX, {
			url: 'api.php?r=role@list',
			data: function (d) {
				var search = $.trim($('#role_mgd .search-val').val());

				if(search != '') d.search.value = search;

				return $.extend({}, d, {
					extra_search: $('#role_mgd .extra').val()
				});
			}
		})
	})).on('xhr.dt', function ( e, settings, json, xhr ) {
		// Note no return - manipulate the data directly in the JSON object.
	}).on("change", ":checkbox", function() {
        if($(this).is("[name='cb-check-all']")) {
            //全选
            $(":checkbox", $('#role_mgd table')).prop("checked",$(this).prop("checked"));
        } else {
            //一般复选
            var checkbox = $("tbody :checkbox", $('#role_mgd table'));
            $(":checkbox[name='cb-check-all']", $('#role_mgd table')).prop('checked', checkbox.length == checkbox.filter(':checked').length);
        }
    }).on("click", ".td-checkbox", function(event) {
        !$(event.target).is(":checkbox") && $(":checkbox",this).trigger("click");
    }).on("click", ".btn-modify-token", function() {
        $(this).closest('tr').addClass("active").siblings().removeClass("active");
        // window.location.href = 'index.php?r=group@edit&id=' + item.group_id;
		showAjaxModal('edit_token', {
			content:{
				ajax: {
					url: 'modal.php?r=role@token',
				}
			},
			options:{
				data: {
					data: function(e) {
						return $tblist.role_mgd.row($('#role_mgd table').find('tr.active')).data();
					},
					success: function(e, d, msg){
						$tblist.role_mgd.ajax.reload();
					}
				}
			}
		}, true, 'modal-bgcolor modal-effect-16');
    }).on("click", ".btn-edit", function() {
        $(this).closest('tr').addClass("active").siblings().removeClass("active");
        // window.location.href = 'index.php?r=group@edit&id=' + item.group_id;
		showAjaxModal('edit_user_role', {
			content:{
				ajax: {
					url: 'modal.php?r=role@edit',
				}
			},
			options:{
				data: {
					data: function(e) {
						return $tblist.role_mgd.row($('#role_mgd table').find('tr.active')).data();
					},
					success: function(e, d, msg){
						$tblist.role_mgd.ajax.reload();
					}
				}
			}
		}, true, 'modal-bgcolor modal-effect-16');
    }).on("click", ".btn-del", function() {
        var item = $tblist.role_mgd.row($(this).closest('tr')).data();
        $(this).closest('tr').addClass("active").siblings().removeClass("active");
		showAjaxModal('itemdel_role', {
			content: {
				body: {
					content: [
						'<div class="text-center">',
						'<h3>角色删除!</h3>',
						'<p>您是否要继续删除“<span style="color: #ea4335; font-weight: 700;">' + item.name + '</span>”角色吗？确认后将无法找回！</p>',
						'<div class="mt-4">',
                            '<button type="button" data-dismiss="modal" class="btn btn-secondary btn-space modal-close btn-cancel">否</button>',
                            '<button type="button" data-dismiss="modal" class="btn btn-success btn-space modal-close btn-ok">是</button>',
						'</div>',
						'</div>'
					].join('')
				},
			},
			options: {
				data: item,
				buttons: [
				  {
					class: 'btn-ok',
					callback: function ( btn, modal, event ) {
					  //You can cancel the modal hide event by returning false
						var params = {role_id: item.role_id};
						ajaxgo({
							type: 'POST',
							url: 'api.php?r=role@remove',
							data: params
						},
						function (d, msg){
							// success reload
							$tblist.role_mgd.ajax.reload();
						});
						return true;
					}
				  }
				]
			}
		});
    }).on("click", ".edit-btn", function() {
		var tds = $(this).parents("tr").children();
		$.each(tds, function(i, val){
			var jqob = $(val);
			if(i < 2 || jqob.has('button').length ){return true;} //跳过第1项 序号,按钮
			var txt=jqob.text();
			var put=$("<input type='text'>");
			put.val(txt);
			jqob.html(put);
		});
		$(this).html("保存");
		$(this).toggleClass("edit-btn");
		$(this).toggleClass("save-btn");
	});

	$('#role_mgd .search-btn').click(function(){
		$tblist.role_mgd.draw();
	});
}

function tabselect(id, reload)
{
	if(typeof $tblist[id] != "object") return;
	$('.mgd-tab').removeClass('show');

	if($tblist[id] == null) {
		if(id == 'user_mgd') user_init();
		if(id == 'role_mgd') role_init();
	}
	else
	if (reload) $tblist[id].ajax.reload();

	$('#' + id).addClass('show');
}

$(document).ready(function(){
	App.init();

	$(".datetimepicker").datetimepicker(OPTIONS_CONSTANT.DATA_DATETIMEPICKER);

	$('.nav-operator .list li>a.notselectd').click(function(){
		tabselect($(this).attr('href').substr(1), true);
	});
	
	if($('.mgd-tab').length > 0)
		tabselect($('.mgd-tab').eq(0).attr('id'), true);
	else
		tabselect('user_mgd', true);

	$(".reg-btn").click(function(){
		var e = $(this).parents('.mgd-tab');
		var id = e.attr('id');
		showAjaxModal('create_' + id, {
			content:{
				ajax: {
					url: 'modal.php?r='+id.substr(0, id.search('_'))+'@create',
				}
			},
			options:{
				data: {
					success: function(e, d, msg) {
						$tblist[id].ajax.reload();
					}
				}
			}
		}, true, 'modal-bgcolor modal-effect-16');
	});
	
	$('.search-btn').click(function(){
		var e = $(this).parents('.mgd-tab');
		var id = e.attr('id');
		$tblist[id].draw();
	});

});
