<?php
namespace raas\apps\notification;

// _group_count_inc load
ni_app_load('counter', '_lib');
ni_app_load('entowner', '_lib');
ni_app_load('enterpise', '_lib');


function _create($frmData)
{
	global $nidb;

	$frmData['update_time'] = time();
	$frmData['create_time'] = $frmData['update_time'];

	try {
		if(insert_data('cloud_notification', $frmData) === false) {
			$errmsg = implode(' ', $nidb->errorInfo());
			set_errmsg(MSG_LEVEL_DEF, __function__, $errmsg);
			return false;
		}
		$frmData['notif_id'] = $nidb->lastInsertId();
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	if(isset($frmData['ent_id']) && $frmData['ent_id'] > 0) {
		if(\raas\apps\enterpise\_notif_count_inc($frmData['ent_id'], 1) === false)
			return false;
	}
	if(\raas\apps\entowner\_notif_count_inc($frmData['own_id'], 1) === false) 
		return false;

	if(\raas\apps\counter\_notif_count_inc(COUNTER_RAAS_ID, 1) === false) 
		return false;
	
	return $frmData;
}

function create($data)
{
	global $nidb;

	$filter = array(
		'own_id'	=> new \FilterVarInt(true),
		'ent_id'	=> new \FilterVarID(),
		'user_id'	=> new \FilterVarID(),
		'disabled'	=> new \FilterVarInt(),
//		'send'		=> new \FilterVarInt(),
//		'count'		=> new \FilterVarInt(),
		'mask'		=> new \FilterVarInt(),
		'creator'	=> new \FilterVarStr(),
		'name'		=> new \FilterVarStr(true),
		'message'	=> new \FilterVarStr(true),
		'method'	=> new \FilterVarStr(),
		'content'	=> new \FilterVarStr(),
		'data'		=> new \FilterVarStr(true),
	);

	if(($frmData = filter_data($data, $filter, $errmsg)) === false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, $errmsg);
		return false;
	}
	if(empty($frmData['name'])) {
		set_errmsg(MSG_LEVEL_ARG, __function__, 'err: name can\'t empty.');
		return false;
	}
	if(empty($frmData['message'])) {
		set_errmsg(MSG_LEVEL_ARG, __function__, 'err: message can\'t empty.');
		return false;
	}
	if(empty($frmData['data'])) {
		set_errmsg(MSG_LEVEL_ARG, __function__, 'err: data can\'t empty.');
		return false;
	}

	$nidb->beginTransaction();

	if(($frmData = _create($frmData)) === false) {
		$nidb->rollBack();
		return false;
	}

	$nidb->commit();
	
	return $frmData;
}

