<?php
namespace raas\apps\notification;

// _group_count_inc load
ni_app_load('counter', '_lib');
ni_app_load('entowner', '_lib');
ni_app_load('enterpise', '_lib');


function remove($data)
{
	global $nidb;

	$filter = array(
		'notif_id'	=> new \FilterVarID(true),
		'own_id'	=> new \FilterVarID(true),
		'ent_id'	=> new \FilterVarID(),
	);
	if(($where = filter_data($data, $filter, $errmsg)) === false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, $errmsg);
		return false;
	}

	$frmData['disabled'] = TB_ROW_DEL_VALUE;
	$frmData['update_time'] = time();

	$nidb->beginTransaction();
	try {
		if(update_data('cloud_notification', $frmData, $where) === false) {
			$errmsg = implode(' ', $nidb->errorInfo());
			set_errmsg(MSG_LEVEL_DEF, __function__, $errmsg);
			$nidb->rollBack();
			return false;
		}
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		$nidb->rollBack();
		return false;
	}

	// inc count for ent?
	$sql = "select * from cloud_notification `notif_id` = " . $where['notif_id'];
	try {
		$sth = $nidb->prepare($sql);

		$sth->execute();
		$rows = $sth->fetchAll(\PDO::FETCH_CLASS);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		$nidb->rollBack();
		return false;
	}
	if(count($rows) > 0) {
		if(\raas\apps\enterpise\_notif_count_inc($rows[0]->ent_id, -1) === false) {
			$nidb->rollBack();
			return false;
		}
	}

	if(\raas\apps\entowner\_notif_count_inc($where['own_id'], -1) === false) {
		$nidb->rollBack();
		return false;
	}
	if(\raas\apps\counter\_notif_count_inc(COUNTER_RAAS_ID, -1) === false) {
		$nidb->rollBack();
		return false;
	}

	$nidb->commit();

	return true;
}

