<?php
namespace raas\apps\notification;


function save($data)
{
	global $nidb;

	$filter = array (
		'notif_id'	=> new \FilterVarID(true),
		'own_id'	=> new \FilterVarID(true),
		'ent_id'	=> new \FilterVarID(),
		'user_id'	=> new \FilterVarID(),
	);
	if(($where = filter_data($data, $filter, $errmsg)) === false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, $errmsg);
		return false;
	}

	$filter = array (
		'disabled'	=> new \FilterVarInt(),
		'send'		=> new \FilterVarInt(),
		'read'		=> new \FilterVarInt(),
		'mask'		=> new \FilterVarInt(),
		'name'		=> new \FilterVarStr(),
		'creator'	=> new \FilterVarStr(),
		'message'	=> new \FilterVarStr(),
		'method'	=> new \FilterVarStr(),
		'data'		=> new \FilterVarStr(),
		'content'	=> new \FilterVarStr(),
	);
	if(($frmData = filter_data($data, $filter, $errmsg)) === false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, $errmsg);
		return false;
	}

	if(count($frmData) <= 0) {
		set_errmsg(MSG_LEVEL_DEF, __function__, "修改已放弃！无任何内容需要保存。");
		return false;
	}

	$frmData['update_time'] = time();

	try {
		if(update_data('cloud_notification', $frmData, $where) === false) {
			$errmsg = implode(' ', $nidb->errorInfo());
			set_errmsg(MSG_LEVEL_DEF, __function__, $errmsg);
			return false;
		}
	}
	catch (PDOException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	return true;
}

