<?php
namespace raas\apps\notification_to;

// _notif_send_inc load
ni_app_load('notification', '_lib');

function _create($frmData)
{
	global $nidb;

	$frmData['update_time'] = time();
	$frmData['create_time'] = $frmData['update_time'];

	try {
		if(insert_data('cloud_notification_to', $frmData) === false) {
			$errmsg = implode(' ', $nidb->errorInfo());
			set_errmsg(MSG_LEVEL_DEF, __function__, $errmsg);
			return false;
		}
		$frmData['to_id'] = $nidb->lastInsertId();
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	if(\raas\apps\notification\_notif_send_inc($frmData['notif_id'], 1) === false)
		return false;
	
	return $frmData;
}

function create($data)
{
	global $nidb;

	$filter = array(
		'notif_id'	=> new \FilterVarID(true),
		'own_id'	=> new \FilterVarInt(true),
		'ent_id'	=> new \FilterVarID(),
		'user_id'	=> new \FilterVarID(),
		'disabled'	=> new \FilterVarInt(),
		'mask'		=> new \FilterVarInt(),
		'status'	=> new \FilterVarInt(),
		'creator'	=> new \FilterVarStr(),
		'name'		=> new \FilterVarStr(true),
		'message'	=> new \FilterVarStr(true),
	);

	if(($frmData = filter_data($data, $filter, $errmsg)) === false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, $errmsg);
		return false;
	}
	if(empty($frmData['name'])) {
		set_errmsg(MSG_LEVEL_ARG, __function__, 'err: name can\'t empty.');
		return false;
	}
	if(empty($frmData['message'])) {
		set_errmsg(MSG_LEVEL_ARG, __function__, 'err: message can\'t empty.');
		return false;
	}

	$nidb->beginTransaction();
	
	if(($frmData = _create($frmData)) === false) {
		$nidb->rollBack();
		return false;
	}

	$nidb->commit();
	
	return $frmData;
}

