<?php
namespace raas\apps\notification_to;

// _notif_send_inc load
ni_app_load('notification', '_lib');


function remove($data)
{
	global $nidb;

	$filter = array(
		'to_id'	=> new \FilterVarID(true),
		'own_id'	=> new \FilterVarID(true),
		'ent_id'	=> new \FilterVarID(),
	);
	if(($where = filter_data($data, $filter, $errmsg)) === false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, $errmsg);
		return false;
	}

	$frmData['disabled'] = TB_ROW_DEL_VALUE;
	$frmData['update_time'] = time();

	$nidb->beginTransaction();
	try {
		if(update_data('cloud_notification_to', $frmData, $where) === false) {
			$errmsg = implode(' ', $nidb->errorInfo());
			set_errmsg(MSG_LEVEL_DEF, __function__, $errmsg);
			$nidb->rollBack();
			return false;
		}
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		$nidb->rollBack();
		return false;
	}

	if(\raas\apps\notification\_notif_send_inc($where['notif_id'], -1) === false) {
		$nidb->rollBack();
		return false;
	}

	$nidb->commit();

	return true;
}

