<?php
namespace raas\apps\notification_to;


// _notif_read_inc load
ni_app_load('notification', '_lib');

function save($data)
{
	global $nidb;

	$filter = array (
		'to_id'		=> new \FilterVarID(true),
		'own_id'	=> new \FilterVarID(true),
		'ent_id'	=> new \FilterVarID(),
		'user_id'	=> new \FilterVarID(),
	);
	if(($where = filter_data($data, $filter, $errmsg)) === false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, $errmsg);
		return false;
	}

	$filter = array (
		'disabled'	=> new \FilterVarInt(),
		'mask'		=> new \FilterVarInt(),
		'status'	=> new \FilterVarInt(),
		'creator'	=> new \FilterVarStr(),
		'name'		=> new \FilterVarStr(),
		'message'	=> new \FilterVarStr(),
	);
	if(($frmData = filter_data($data, $filter, $errmsg)) === false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, $errmsg);
		return false;
	}

	if(isset($frmData['status'])) {
		$sql = "select * from cloud_notification_to where `to_id` = " . $where['to_id'];

		try {
			$sth = $nidb->prepare($sql);

			$sth->execute();
			$rows = $sth->fetchAll(\PDO::FETCH_CLASS);
		}
		catch (\NiDBException $e) {
			set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
			return false;
		}
		$status = 0;
		if(count($rows) > 0) {
			$notif = $rows[0];
			if(($notif->status & 1) == 0 && ($frmData['status'] & 1))
				$status |= 1;
			if(($notif->status & 2) == 0 && ($frmData['status'] & 2))
				$status |= 2;
			if(($notif->status & 4) == 0 && ($frmData['status'] & 4))
				$status |= 4;
			if(($notif->status & 8) == 0 && ($frmData['status'] & 8))
				$status |= 8;
			if(($notif->status & 16) == 0 && ($frmData['status'] & 16))
				$status |= 16;
			if(($notif->status & 32) == 0 && ($frmData['status'] & 32))
				$status |= 32;
			if(($notif->status & 64) == 0 && ($frmData['status'] & 64))
				$status |= 64;
			if(($notif->status & 128) == 0 && ($frmData['status'] & 128))
				$status |= 128;
		}

		if($status) 
			$frmData['status'] = $status |= $notif->status;
		else
			unset($frmData['status']);
	}

	if(count($frmData) <= 0) {
		set_errmsg(MSG_LEVEL_DEF, __function__, "修改已放弃！无任何内容需要保存。");
		return false;
	}

	$frmData['update_time'] = time();

	$nidb->beginTransaction();
	try {
		if(update_data('cloud_notification_to', $frmData, $where) === false) {
			$errmsg = implode(' ', $nidb->errorInfo());
			set_errmsg(MSG_LEVEL_DEF, __function__, $errmsg);
			return false;
		}
	}
	catch (PDOException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	if(isset($notif) && ($notif->status & 1) == 0 && ($status & 1)) {
		if(\raas\apps\notification\_notif_read_inc($notif->notif_id, 1) === false){
			set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
			$nidb->rollBack();
			return false;
		}
	}

	$nidb->commit();

	return true;
}

