<?php
namespace raas\apps\package;

ni_app_load('package', 'budget');
ni_app_load('account_book', 'create');
ni_app_load('account', 'save');
ni_app_load('group', 'info');
ni_app_load('enterpise', 'info');
ni_app_load('account', 'info');

function buy($data)
{
	global $nidb;

	$logger = array();
	$optional = budget($data);
	if($optional === false) return false;

	if(format_and_push($data, 'user_id', $optional, '', 'int', false) === false) {
		set_errmsg(MSG_LEVEL_DEF, __function__, "无效的操作员。");
		return false;
	}
	format_and_push($data, 'remark', $logger, '', 'string', false);

	$grp = \raas\apps\group\info(array(
		'own_id' => $data['own_id'],
		'group_id' => $optional['group_id']));
	if($grp === false) {
		set_errmsg(MSG_LEVEL_DEF, __function__, "无效的用户组。");
		return false;
	}
	
	$where = array('acct_id' => $optional['acct_id']);
	$frmData = array(
		'start_time'	=> $optional['start'],
		'expire_time'	=> $optional['expire'],
	);

	$nidb->beginTransaction();
	try {
		// save account
		if(update_data('cloud_account', $frmData, $where) === false) {
			$errmsg = implode(' ', $nidb->errorInfo());
			set_errmsg(MSG_LEVEL_DEF, __function__, $errmsg);
			$nidb->rollBack();
			return false;
		}
		$nidb->commit();
	}
	catch (PDOException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		$nidb->rollBack();
		return false;
	}

	// save logger
	$logger['own_id']	= $grp->own_id;
	$logger['ent_id']	= $grp->ent_id;
	$logger['user_id']	= $optional['user_id'];
	$logger['acct_id']	= $optional['acct_id'];
	$logger['expense']	= $optional['expense'];
	$logger['action']	= $optional['action'];
	$logger['data']		= array(
		'showmode'		=> 0,
		'count'			=> $optional['count'],
		'tmlong'		=> $optional['tmlong'],
		'tmtype'		=> $optional['tmtype'],
		'start'			=> $optional['start'],
		'expire'		=> $optional['expire'],
		'src_time'		=> $optional['src_time'],
	);
	$ret = \raas\apps\account_book\create($logger);

	$info = \raas\apps\account\info($where, 1);
	raaseye_acct_add($info);

	if($grp->ent_id > 0) {
		$ent = \raas\apps\enterpise\_info($grp->ent_id);
		raaseye_acct_remove($row->account . '@' . $ent->domain);
	}

	return $ret;
}

