<?php
namespace raas\apps\package;


function _find($name, $own_id = 0)
{
	global $nidb;

	// set custom options
	$keys = '`ide_id`,
		`parent_id`,
		`own_id`,
		`disabled`,
		`usedcnt`,
		`count`,
		`level`,
		`name`,
		`update_time`,
		`create_time`';

	$sql = "select $keys from cloud_package_item where `name` = ?";

	try {
		if($own_id > 0) {
			$sql.= " and `own_id` = ?";
			$sth = $nidb->prepare($sql);

			$sth->bindParam(1, $name, \PDO::PARAM_STR);
			$sth->bindParam(2, $own_id, \PDO::PARAM_INT);
		}
		else {
			$sth = $nidb->prepare($sql);

			$sth->bindParam(1, $name, \PDO::PARAM_STR);
		}

		$sth->execute();
		$row = $sth->fetch(\PDO::FETCH_LAZY);
		$sth = null;
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	if(!$row) {
		set_errmsg(MSG_LEVEL_DEF, __function__, "无此的套餐。");
		return false;
	}

	return $row;
}

function find($data)
{
	global $nidb;

	$optional = array();

	$where_str = '';

	// set custom options
	if(format_and_push($data, 'name', $optional, '', 'string', false) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, 'err: name can\'t empty.');
		return false;
	}

	if(format_and_push($data, 'own_id', $optional, '', 'int', false))
		return _find($optional['name'], $optional['own_id']);

	return _find($optional['name']);
}


