<?php
namespace raas\apps\package;


function _info($id, $own_id = 0)
{
	global $nidb;

	$sql = "select * from cloud_package_item where `package_id` = ?";

	try {
		if($own_id > 0) {
			$sql.= " and `own_id` = ?";
			$sth = $nidb->prepare($sql);

			$sth->bindParam(1, $id, \PDO::PARAM_INT);
			$sth->bindParam(2, $own_id, \PDO::PARAM_INT);
		}
		else {
			$sth = $nidb->prepare($sql);

			$sth->bindParam(1, $id, \PDO::PARAM_INT);
		}

		$sth->execute();
		$row = $sth->fetch(\PDO::FETCH_LAZY);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	if(!$row) {
		set_errmsg(MSG_LEVEL_DEF, __function__, "指定的套餐不存在！");
		return false;
	}
	
	return $row;
}

function info($data)
{
	global $nidb;

	$optional = array();

	$where_str = '';

	// set custom options
	if(format_and_push($data, 'package_id', $optional, '', 'int', false) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, 'err: package_id can\'t empty.');
		return false;
	}
	$where_str .= "`package_id` = " . $optional['package_id']  . " and ";

	if(format_and_push($data, 'own_id', $optional, '', 'int', false))
		$where_str .= "`own_id` = " . $optional['own_id']  . " and ";


	if($where_str != '')
		$where_str = substr("where $where_str", 0, -5);

	$sql = "select * from cloud_package_item $where_str";

	try {
		$sth = $nidb->prepare($sql);

		$sth->execute();
		$row = $sth->fetch(\PDO::FETCH_LAZY);
		$sth = null;
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	if(!$row) {
		set_errmsg(MSG_LEVEL_DEF, __function__, "无此的套餐。");
		return false;
	}
	
	return $row;
}




