<?php
namespace raas\apps\package;


function remove($data)
{
	global $nidb;

	$filter = array(
		'package_id'	=> new \FilterVarID(true),
		'own_id'		=> new \FilterVarID(true),
	);
	if(($where = filter_data($data, $filter, $errmsg)) === false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, $errmsg);
		return false;
	}

	$frmData['disabled'] = TB_ROW_DEL_VALUE;
	$frmData['update_time'] = time();

	try {
		if(update_data('cloud_package_item', $frmData, $where) === false) {
			$errmsg = implode(' ', $nidb->errorInfo());
			set_errmsg(MSG_LEVEL_DEF, __function__, $errmsg);
			$nidb->rollBack();
			return false;
		}
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		$nidb->rollBack();
		return false;
	}
	
	return true;
}

