<?php
namespace raas\apps\presale_card\item;


function card_down($data)
{
	global $nidb;

	$filter = array(
		'psc_id'		=> new \FilterVarID(true),
		'own_id'		=> new \FilterVarID(true),
		'create_time'	=> new \FilterVarInt(true),
	);
	if(($where = filter_data($data, $filter, $errmsg)) === false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, $errmsg);
		return false;
	}

	$frmData = array_values($where);
	try {
		$sql = "select `name`, `psi_code` as `code` , `tmtype`, `tmlong`, `start_time`, `expire_time`, `expense`, `rate_out`, `rate_in` from cloud_presale_item where `psc_id` = ? and `own_id` = ? and `create_time` = ?";

		$sth = $nidb->prepare($sql);
		$sth->execute($frmData);
		$rows = $sth->fetchAll(\PDO::FETCH_ASSOC);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	if(!$rows) {
		set_errmsg(MSG_LEVEL_DEF, __function__, "指定的卡不存在！");
		return false;
	}

	return $rows;
}

