<?php
namespace raas\apps\presale_card\item;


function remove($data)
{
	global $nidb;

	$filter = array(
		'psc_id'		=> new \FilterVarID(true),
		'own_id'		=> new \FilterVarID(true),
		'psi_code'		=> new \FilterVarStr(true),
	);
	if(($where = filter_data($data, $filter, $errmsg)) === false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, $errmsg);
		return false;
	}

	$frmData = array_values($where);
	try {
		$sql = "select * from cloud_presale_item where `psc_id` = ? and `own_id` = ? and `psi_code` = ?";
		
		$sth = $nidb->prepare($sql);
		$sth->execute($frmData);
		$row = $sth->fetch(\PDO::FETCH_ASSOC);
		if(!$row) {
			set_errmsg(MSG_LEVEL_DEF, __function__, "指定的卡不存在！");
			return false;
		}
		$row['operation'] = 0;
		$row['update_time'] = time();

		if(insert_data('cloud_presale_logger', $row, $where) === false) {
			$errmsg = implode(' ', $nidb->errorInfo());
			set_errmsg(MSG_LEVEL_DEF, __function__, $errmsg);
			return false;
		}
		
		$sql = "delete from cloud_presale_item where `psc_id` = ? and `own_id` = ? and `psi_code` = ?";

		$sth = $nidb->prepare($sql);
		$sth->execute($frmData);
		
		$sql = 'update cloud_presale_card set `rmvcnt` = `rmvcnt` + 1';
		$sql.= ' where `psc_id` = ?';

		$sth = $nidb->prepare($sql);
		$sth->bindParam(1, $where['psc_id'], \PDO::PARAM_INT);
		$sth->execute();
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}
	
	return true;
}

