<?php
namespace raas\apps\presale_card;


function _info($id, $own_id = 0, $ent_id = 0, $group_id = 0)
{
	global $nidb;

	$sql = "select * from cloud_presale_card where `psc_id` = ?";

	try {
		if($own_id > 0)
			$sql.= " and `own_id` = ?";
		if($ent_id > 0)
			$sql.= " and `ent_id` = ?";
		if($group_id > 0)
			$sql.= " and `group_id` = ?";

		$sth = $nidb->prepare($sql);
		
		$index = 1;
		$sth->bindParam($index++, $id, \PDO::PARAM_INT);
		if($own_id > 0)
			$sth->bindParam($index++, $own_id, \PDO::PARAM_INT);
		if($ent_id > 0)
			$sth->bindParam($index++, $ent_id, \PDO::PARAM_INT);
		if($group_id > 0)
			$sth->bindParam($index++, $group_id, \PDO::PARAM_INT);

		$sth->execute();
		$row = $sth->fetch(\PDO::FETCH_LAZY);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	if(!$row) {
		set_errmsg(MSG_LEVEL_DEF, __function__, "指定的套餐不存在！");
		return false;
	}
	
	return $row;
}

function info($data)
{
	global $nidb;

	$optional = array();

	$where_str = '';

	// set custom options
	if(format_and_push($data, 'psc_id', $optional, '', 'int', false) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, 'err: psc_id can\'t empty.');
		return false;
	}
	$where_str .= "`psc_id` = " . $optional['psc_id']  . " and ";

	if(format_and_push($data, 'own_id', $optional, '', 'int', false))
		$where_str .= "`own_id` = " . $optional['own_id']  . " and ";
	if(format_and_push($data, 'ent_id', $optional, '', 'int', false))
		$where_str .= "`ent_id` = " . $optional['ent_id']  . " and ";
	if(format_and_push($data, 'group_id', $optional, '', 'int', false))
		$where_str .= "`group_id` = " . $optional['group_id']  . " and ";


	if($where_str != '')
		$where_str = substr("where $where_str", 0, -5);

	$sql = "select * from cloud_presale_card $where_str";

	try {
		$sth = $nidb->prepare($sql);

		$sth->execute();
		$row = $sth->fetch(\PDO::FETCH_LAZY);
		$sth = null;
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	if(!$row) {
		set_errmsg(MSG_LEVEL_DEF, __function__, "无此的套餐。");
		return false;
	}
	
	return $row;
}




