<?php
namespace raas\apps\presale_card;


function _save($frmData, $where)
{
	global $nidb;

	if(isset($frmData['name'])) {
		// find name is exist
		$sql = "select `psc_id` from cloud_presale_card where `disabled` < " . TB_ROW_DEL_VALUE;
		$sql .=" and `name` = ? and `own_id` = ? and `psc_id` != ?";
		if(isset($where['ent_id']))
			$sql .=" and `ent_id` = ?";

		try {
			$sth = $nidb->prepare($sql);

			$index = 1;
			$sth->bindParam($index++, $frmData['name'], \PDO::PARAM_STR);
			$sth->bindParam($index++, $where['own_id'], \PDO::PARAM_INT);
			$sth->bindParam($index++, $where['psc_id'], \PDO::PARAM_INT);
			if(isset($where['ent_id']))
				$sth->bindParam($index++, $where['ent_id'], \PDO::PARAM_INT);

			$sth->execute();
			$row = $sth->fetch(\PDO::FETCH_LAZY);
			$sth = null;
		}
		catch (\NiDBException $e) {
			set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
			return false;
		}
		if($row) {
			set_errmsg(MSG_LEVEL_DEF, __function__, '“' . $frmData['name'] . '”已存在');
			return false;
		}
	}

	$frmData['update_time'] = time();

	try {
		if(update_data('cloud_presale_card', $frmData, $where) === false) {
			$errmsg = implode(' ', $nidb->errorInfo());
			set_errmsg(MSG_LEVEL_DEF, __function__, $errmsg);
			return false;
		}
	}
	catch (PDOException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	return true;
}

function save($data)
{
	global $nidb;

	$filter = array(
		'psc_id'		=> new \FilterVarID(true),
		'own_id'		=> new \FilterVarID(true),
	);
	if(($where = filter_data($data, $filter, $errmsg)) === false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, $errmsg);
		return false;
	}

	$filter = array(
//		'disabled'		=> new \FilterVarInt(),
		'name'			=> new \FilterVarStr(),
		'ent_id'		=> new \FilterVarInt(),
		'group_id'		=> new \FilterVarInt(),
		'tmlong'		=> new \FilterVarInt(),
		'tmtype'		=> new \FilterVarInt(),
		'expense'		=> new \FilterVarInt(),
		'rate_out'		=> new \FilterVarKBit(),
		'rate_in'		=> new \FilterVarKBit(),
	);
	if(($frmData = filter_data($data, $filter, $errmsg)) === false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, $errmsg);
		return false;
	}
	if(count($frmData) <= 0) {
		set_errmsg(MSG_LEVEL_DEF, __function__, "修改已放弃！无任何内容需要保存。");
		return false;
	}

	$frmData['update_time'] = time();

	if(($ret = _save($frmData, $where)) == false) {
		return false;
	}

	return $ret;
}
