<?php
namespace raas\apps\role;

//$libdir = dirname(dirname(__FILE__));
//require_once ($libdir . "/include/token.php");
//require_once ($libdir . "/include/user.php");

//use raas\apps\token as token;
//use raas\apps\user as user;

//	权限bit位值，最大支持映射32种权限，
//	目前为8种：
//	1：info、2：list、4：search、8：disable、
//	16：enable、32：save、64：create、128：remove、256：menu

define('ROLE_TOKEN_INFO',	'info');
define('ROLE_TOKEN_LIST',	'list');
define('ROLE_TOKEN_SEARCH',	'search');
define('ROLE_TOKEN_DISABLE','disable');
define('ROLE_TOKEN_ENABLE',	'enable');
define('ROLE_TOKEN_SAVE',	'save');
define('ROLE_TOKEN_CREATE',	'create');
define('ROLE_TOKEN_REMOVE',	'remove');
define('ROLE_TOKEN_MENU',	'menu');
define('ROLE_USER_SUPERMAN','admin');

/*
 this json data same:
 /appname/conf/token.json
*/
define('IDENTITY_DEFTOKEN', 
'{
	"name": "",
	"desc": "",
	"system": 0,
	"disabled": 0,
	"defval": 0,
	"loaderr": 0,
	"mask": 511,
	"tokenmap": {
		"create" : {"name": "创建", "val": 1, "desc": "创建操作"},
		"remove" : {"name": "删除", "val": 2, "desc": "删除操作"},
		"save"   : {"name": "修改", "val": 4, "desc": "修改操作"},
		"disable": {"name": "禁用", "val": 8, "desc": "禁用操作"},
		"enable" : {"name": "启用", "val": 16, "desc": "启用操作"},
		"list"   : {"name": "浏览", "val": 32, "desc": "浏览也支持查询"},
		"search" : {"name": "查询", "val": 64, "desc": "查询操作"},
		"info"   : {"name": "详细", "val": 128, "desc": "显示详细"},
		"menu"   : {"name": "菜单", "val": 256, "desc": "主菜单上是否可见"}
	}
}'
);


function create($data)
{
	global $nidb, $user;

	$filter = array(
		'parent_id'	=> new \FilterVarID(),
		'own_id'	=> new \FilterVarInt(),
		'disabled'	=> new \FilterVarInt(),
		'usercnt'	=> new \FilterVarInt(),
		'name'		=> new \FilterVarStr(true),
	);

	if(($frmData = filter_data($data, $filter, $errmsg)) === false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, $errmsg);
		return false;
	}
	if(empty($frmData['name'])) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '名称不能为空！');
		return false;
	}

	$frmData['parent_id'] = 1;

	// find name is exist
	$sql = "select `role_id` from cloud_role where `disabled` < " . TB_ROW_DEL_VALUE;
	$sql .=" and `own_id` = ? and `name` = ?";
	try {
		$sth = $nidb->prepare($sql);

		$index = 1;
		$sth->bindParam($index++, $frmData['own_id'], \PDO::PARAM_INT);
		$sth->bindParam($index++, $frmData['name'], \PDO::PARAM_STR);

		$sth->execute();
		$rows = $sth->fetchAll(\PDO::FETCH_CLASS);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}
	if(count($rows) > 0) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '“' . $frmData['name'] . '”已存在');
		return false;
	}

	$frmData['update_time'] = time();
	$frmData['create_time'] = $frmData['update_time'];

/*
	// get role
	if(isset($data['op_account']) == false
	|| is_superman(trim($data['op_account'])) == false) {
		if($info->own_id > 0 && $info->own_id != $own_id) {
			set_errmsg(MSG_LEVEL_ARG, __function__, '指定的角色不存在！');
			return false;
		}
	
	if(is_superman($user->account))
	$frmData['parent_id'] = 1;
	$info->parent_id = ;
*/
	

	$nidb->beginTransaction();

	try {
		if(insert_data('cloud_role', $frmData) === false) {
			$errmsg = implode(' ', $nidb->errorInfo());
			set_errmsg(MSG_LEVEL_DEF, __function__, $errmsg);
			$nidb->rollBack();
			return false;
		}
		$frmData['role_id'] = $nidb->lastInsertId();

		$nidb->commit();
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		$nidb->rollBack();
		return false;
	}

	return $frmData;
}

function disable($data)
{
	global $nidb;

	$filter = array(
		'role_id'	=> new \FilterVarID(true),
		'own_id'	=> new \FilterVarID(),
	);
	if(($where = filter_data($data, $filter, $errmsg)) === false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, $errmsg);
		return false;
	}

	$frmData['disabled'] = 1;
	$frmData['update_time'] = time();

	try {
		if(update_data('cloud_role', $frmData, $where) === false) {
			$errmsg = implode(' ', $nidb->errorInfo());
			set_errmsg(MSG_LEVEL_DEF, __function__, $errmsg);
			return false;
		}
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	return true;
}


function enable($data)
{
	global $nidb;

	$filter = array(
		'role_id'	=> new \FilterVarID(true),
		'own_id'	=> new \FilterVarID(),
	);
	if(($where = filter_data($data, $filter, $errmsg)) === false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, $errmsg);
		return false;
	}

	$frmData['disabled'] = 0;
	$frmData['update_time'] = time();

	try {
		if(update_data('cloud_role', $frmData, $where) === false) {
			$errmsg = implode(' ', $nidb->errorInfo());
			set_errmsg(MSG_LEVEL_DEF, __function__, $errmsg);
			return false;
		}
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	return true;
}


function _find($name, $own_id = 0)
{
	global $nidb;

	// set custom options
	$sql = "select * from cloud_role where `name` = ?";

	try {
		if($own_id > 0) {
			$sql.= " and (`own_id` = 0 or `own_id` = ?)";
			$sth = $nidb->prepare($sql);

			$sth->bindParam(1, $name, \PDO::PARAM_STR);
			$sth->bindParam(2, $own_id, \PDO::PARAM_INT);
		}
		else {
			$sth = $nidb->prepare($sql);

			$sth->bindParam(1, $name, \PDO::PARAM_STR);
		}

		$sth->execute();
		$rows = $sth->fetchAll(\PDO::FETCH_CLASS);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	if(count($rows) <= 0) {
		set_errmsg(MSG_LEVEL_DEF, __function__, "无效的角色。");
		return false;
	}
	
	return $rows[0];
}

function find($data)
{
	global $nidb;

	$optional = array();

	$where_str = '';

	// set custom options
	if(format_and_push($data, 'name', $optional, '', 'string', false) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, 'err: name can\'t empty.');
		return false;
	}

	if(format_and_push($data, 'own_id', $optional, '', 'int', false))
		return _find($optional['name'], $optional['own_id']);

	return _find($optional['name']);
}


function _info($id, $own_id = 0)
{
	global $nidb;

	$sql = "select * from cloud_role where `role_id` = ?";
	try {
		if($own_id > 0) {
			$sql.= " and (`own_id` = 0 or `own_id` = ?)";
			$sth = $nidb->prepare($sql);

			$sth->bindParam(1, $id, \PDO::PARAM_INT);
			$sth->bindParam(2, $own_id, \PDO::PARAM_INT);
		}
		else {
			$sth = $nidb->prepare($sql);

			$sth->bindParam(1, $id, \PDO::PARAM_INT);
		}

		$sth->execute();
		$row = $sth->fetch(\PDO::FETCH_LAZY);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	if(!$row) {
		set_errmsg(MSG_LEVEL_DEF, __function__, "指定的角色不存在！");
		return false;
	}
	
	return $row;
}

function info($data)
{
	global $nidb;

	$optional = array();

	$where_str = '`own_id` = 0 or ';

	// set custom options
	if(format_and_push($data, 'role_id', $optional, '', 'int', false) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, 'err: role_id can\'t empty.');
		return false;
	}
	$where_str .= "`role_id` = " . $optional['role_id']  . " and ";

	if(format_and_push($data, 'own_id', $optional, '', 'int', false))
		$where_str .= "`own_id` = " . $optional['own_id']  . " and ";


	if($where_str != '')
		$where_str = substr("where $where_str", 0, -5);

	$sql = "select * from cloud_role $where_str";

	try {
		$sth = $nidb->prepare($sql);

		$sth->execute();
		$rows = $sth->fetchAll(\PDO::FETCH_CLASS);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	if(count($rows) <= 0) {
		set_errmsg(MSG_LEVEL_DEF, __function__, "无效的角色。");
		return false;
	}
	
	return $rows[0];
}

function select($data)
{
	global $nidb;

	$values = array();
	$optional = array();
	// set order, limit, offset value
	format_list_arg($data, $optional);

	$where_str = '';
	
	if(format_and_push($data, 'disabled', $optional, '', 'int', false))
		$where_str .= "`disabled` = " . $optional['disabled'] . " and ";
	else
		$where_str .= "`disabled` < " . TB_ROW_DEL_VALUE . " and ";
	
	if(format_and_push($data, 'upstartm', $optional, '', 'int', false))
		$where_str .= "`update_time` >= " . $optional['upstartm'] . " and ";

	if(format_and_push($data, 'endtm', $optional, '', 'int', false)) 
		$where_str .= "`update_time` < " . $optional['upendtm']  . " and ";

	if(format_and_push($data, 'startm', $optional, '', 'int', false))
		$where_str .= "`create_time` >= " . $optional['startm'] . " and ";

	if(format_and_push($data, 'endtm', $optional, '', 'int', false))
		$where_str .= "`create_time` < " . $optional['endtm']  . " and ";

	// set custom options
	if(format_and_push($data, 'own_id', $optional, '', 'int', false))
		$where_str .= "(`own_id` = 0 or `own_id` = " . $optional['own_id']  . ") and ";

	if(format_and_push($data, 'parent_id', $optional, '', 'int', false))
		$where_str .= "`parent_id` = " . $optional['parent_id']  . " and ";

	if(format_and_push($data, 'role_id', $optional, '', 'int', false))
		$where_str .= "`role_id` = " . $optional['role_id']  . " and ";
	
	if(format_and_push($data, 'name', $optional, '', 'string', false)) {
		$where_str .= "`name` = ? and ";
		array_push($values, $optional['name']);
	}

	if(isset($data['search'])) {
		if(format_and_push($data['search'], 'value', $optional, 'search', 'string', false)) {
			$where_str .= "(`name` like ?) and ";
			array_push($values, "%" . $optional['search'] . "%");
		}
	}

	if($where_str != '')
		$where_str = substr("where $where_str", 0, -5);


	$order_map = array(
		"role_id",
		"parent_id",
		"disabled",
		"usedcnt",
		"name",
		"update_time",
		"create_time",
	);

	$order = array();
	if(isset($optional['order'])) {
		foreach($optional['order'] as $op) {
			if(isset($op['column']) && isset($data['columns'][$op['column']]['data'])) {
				if(in_array($data['columns'][$op['column']]['data'], $order_map))
					array_push($order, "`" . $data['columns'][$op['column']]['data'] . "` " . $op['dir']);
			}
		}
	}

	if(count($order) > 0)
		$order_by = 'order by `own_id` asc, ' . implode(', ', $order);
	else
		$order_by = '';

	$sql = "select count(*) as `total` from cloud_role $where_str";

	try {
		$sth = $nidb->prepare($sql);
		$sth->execute($values);
		$rows = $sth->fetchAll(\PDO::FETCH_CLASS);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}
	
	if(count($rows) > 0) {
		$result = array(
			'total' => $rows[0]->total,
		);
	}
	else {
		$result = array(
			'total' => 0,
		);
	}

	$keys = '`role_id`,
		`parent_id`,
		`own_id`,
		`disabled`,
		`usedcnt`,
		`name`,
		`update_time`,
		`create_time`';

	$sql = "select $keys from cloud_role $where_str $order_by limit ? offset ? ";

	array_push($values, $optional['limit']);
	array_push($values, $optional['offset']);

	try {
		$sth = $nidb->prepare($sql);
		$sth->execute($values);
		$rows = $sth->fetchAll(\PDO::FETCH_CLASS);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	$result['rows'] = $rows;

	if(isset($data['draw'])) $result['draw'] = $data['draw'];

	return $result;
}

function remove($data)
{
	global $nidb;

	$filter = array(
		'role_id'	=> new \FilterVarID(true),
		'own_id'	=> new \FilterVarID(true),
	);
	if(($where = filter_data($data, $filter, $errmsg)) === false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, $errmsg);
		return false;
	}

	$frmData['disabled'] = TB_ROW_DEL_VALUE;
	$frmData['update_time'] = time();

	$nidb->beginTransaction();
	try {
		if(update_data('cloud_role', $frmData, $where) === false) {
			$errmsg = implode(' ', $nidb->errorInfo());
			set_errmsg(MSG_LEVEL_DEF, __function__, $errmsg);
			$nidb->rollBack();
			return false;
		}

		$nidb->commit();
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		$nidb->rollBack();
		return false;
	}


	return true;
}

function _save($frmData, $where)
{
	global $nidb;

	if(isset($frmData['name'])) {
		// find name is exist
		$sql = "select `role_id` from cloud_role where `disabled` < " . TB_ROW_DEL_VALUE;
		$sql .=" and `name` = ? and `role_id` != ?";
		if(isset($where['own_id']))
			$sql .=" and `own_id` = ?";

		try {
			$sth = $nidb->prepare($sql);

			$sth->bindParam(1, $frmData['name'], \PDO::PARAM_STR);
			$sth->bindParam(2, $where['role_id'], \PDO::PARAM_INT);
			if(isset($frmData['own_id']))
				$sth->bindParam(3, $where['own_id'], \PDO::PARAM_INT);

			$sth->execute();
			$rows = $sth->fetchAll(\PDO::FETCH_CLASS);
		}
		catch (\NiDBException $e) {
			set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
			return false;
		}
		if(count($rows) > 0) {
			set_errmsg(MSG_LEVEL_DEF, __function__, '“' . $frmData['name'] . '”角色已存在');
			return false;
		}
	}

	$frmData['update_time'] = time();

	try {
		if(update_data('cloud_role', $frmData, $where) === false) {
			$errmsg = implode(' ', $nidb->errorInfo());
			set_errmsg(MSG_LEVEL_DEF, __function__, $errmsg);
			return false;
		}
	}
	catch (PDOException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	return true;
}

function save($data)
{
	global $nidb;

	$filter = array(
		'role_id'	=> new \FilterVarID(true),
		'own_id'	=> new \FilterVarID(true),
	);
	if(($where = filter_data($data, $filter, $errmsg)) === false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, $errmsg);
		return false;
	}

	$filter = array(
		'disabled'	=> new \FilterVarInt(),
		'parent_id'	=> new \FilterVarID(true),
		'name'		=> new \FilterVarStr(),
	);
	if(($frmData = filter_data($data, $filter, $errmsg)) === false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, $errmsg);
		return false;
	}
	if(count($frmData) <= 0) {
		set_errmsg(MSG_LEVEL_DEF, __function__, "修改已放弃！无任何内容需要保存。");
		return false;
	}
	
	if($where['role_id'] == 1)
		$frmData['parent_id'] = 0;

	if($frmData['parent_id'] == $where['role_id']) {
		set_errmsg(MSG_LEVEL_DEF, __function__, "修改失败！继承角色不能是自己。");
		return false;
	}

	if($where['parent_id'] > 0) {
		$info = _info($frmData['parent_id']);
		if($info === false) {
			set_errmsg(MSG_LEVEL_DEF, __function__, "修改失败！继承角色无效。");
			return false;
		}
	}

	if(isset($data['op_account']) && is_superman(trim($data['op_account'])))
		unset($where['own_id']);
	else 
	if($info->own_id != 0 && $info->own_id != $where['own_id']) {
		set_errmsg(MSG_LEVEL_EXP, __function__, '修改失败！无效的继承角色。');
		return false;
	}

//	$nidb->beginTransaction();
	if(_save($frmData, $where) === false) {
//		$nidb->rollBack();
		return false;
	}

//	$nidb->commit();
	
	if($frmData['parent_id'] > 0)
		token_repair($frmData['parent_id'], $where['role_id']);

	return $ret;
}

function token_repair($src_role_id, $dst_role_id)
{
	global $nidb;

	// is user's role?
	$now = time();
	$sql = "select dst.`role_id`, (src.`authority` & dst.`authority`) as authority, $now as `update_time` from cloud_role_token as `dst`";
	$sql.= " inner join cloud_role_token as `src`";
	$sql.= " on src.`name` = dst.`name`";
	$sql.= " where src.`role_id` = ? and dst.`role_id` = ? && (~src.`authority` & dst.`authority`)";

	try {
		$sth = $nidb->prepare($sql);

		$sth->bindParam(1, $src_role_id, \PDO::PARAM_INT);
		$sth->bindParam(2, $dst_role_id, \PDO::PARAM_INT);

		$sth->execute();
		$repair = $sth->fetchAll(\PDO::FETCH_ASSOC);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	if(!$repair) {
//		set_errmsg(MSG_LEVEL_EXP, __function__, '无需修改！');
		return true;
	}

	$nidb->beginTransaction();
	try {
		foreach($repair as $val) {
			$sql = "update cloud_role_token set `authority` = ?, `update_time` = ? where `role_id` = ?";
			$sth = $nidb->prepare($sql);

			$sth->bindParam(1, $val['authority'], \PDO::PARAM_INT);
			$sth->bindParam(2, $val['update_time'], \PDO::PARAM_INT);
			$sth->bindParam(3, $val['role_id'], \PDO::PARAM_INT);
			$sth->execute();
		}
		$nidb->commit();
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		$nidb->rollBack();
		return false;
	}

	return true;
}

function _role_used_count_inc($role_id, $count)
{
	global $nidb;

	$sql = "update cloud_role
			set `usedcnt` = `usedcnt` + ?
			where `role_id` = ?";

	try {
		$sth = $nidb->prepare($sql);

		$index = 1;
		$sth->bindParam($index++, $count, \PDO::PARAM_INT);
		$sth->bindParam($index++, $role_id, \PDO::PARAM_INT);

		$sth->execute();
		return $sth->rowCount();
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
	}

	return false;
}

function is_superman($account)
{
	return $account == ROLE_USER_SUPERMAN;
}

function remove_user($data)
{
	// 删除指定角色上绑定的指定用户
	// int role_id, int own_id, array user_id, 
	global $nidb;

	if(isset($data['role_id']) == false
	|| ($role_id = intval($data['role_id'])) <= 0) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '操作失败，指定的角色不正确。');
		return false;
	}
	
	if(isset($data['user_id']) == false
	|| is_array($data['user_id']) == false || ($uidcnt = count($data['user_id'])) < 0) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '操作失败，未指定要删除的用户。');
		return false;
	}

	if(isset($data['op_account']) == false
	|| is_superman(trim($data['op_account'])) == false) {
		
		if(isset($data['own_id']) == false
		|| ($own_id = intval($data['own_id'])) <= 0) {
			set_errmsg(MSG_LEVEL_ARG, __function__, '无效的归属，请先登陆。');
			return false;
		}
		
		// is user's role?
		$sql = "select user.`role_id`, user.`user_id` from cloud_role_user as `user`";
		$sql.= " inner join cloud_role as `role`";
		$sql.= " on user.`role_id` = role.`role_id`";
		$sql.= " where role.`own_id` = ? and role.`role_id` = ?";
	
		try {
			$sth = $nidb->prepare($sql);

			$sth->bindParam(1, $own_id, \PDO::PARAM_INT);
			$sth->bindParam(2, $role_id, \PDO::PARAM_INT);

			$sth->execute();
			$rows = $sth->fetchAll(\PDO::FETCH_CLASS);
		}
		catch (\NiDBException $e) {
			set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
			return false;
		}
		
		if(count($rows) <= 0) {
			set_errmsg(MSG_LEVEL_DEF, __function__, '删除失败，用户没有配置该角色。');
			return false;
		}
	}

	$sql = "delete form cloud_role_user where";
	$sql.= " and `user_id` in (".implode(',', $uidcnt).") and `role_id` = ?";

	array_push($data['user_id'], $role_id);
	
	$nidb->beginTransaction();
	try {
		$sth = $nidb->prepare($sql);
		$sth->execute($data['user_id']);
		$count = $sth->rowCount();

		if($count <= 0) {
			set_errmsg(MSG_LEVEL_EXP, __function__, '没有删除任何用户。');
			$nidb->rollBack();
			return false;
		}
		
		if(_role_used_count_inc($where['role_id'], $count * -1) === false) {
			set_errmsg(MSG_LEVEL_EXP, __function__, '删除用户时，计数失败。');
			$nidb->rollBack();
			return false;
		}

		$nidb->commit();
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		$nidb->rollBack();
		return false;
	}

	return true;
}


function get_apps()
{
	$app_root = dirname(dirname(dirname(__FILE__)));
	$apps = array();

	if (is_dir($app_root)) {
		if ($dh = opendir($app_root)) {
			while (($pathname = readdir($dh)) !== false) {
				if($pathname != "." && $pathname != "..") {
					if (is_dir($app_root . '/' . $pathname)) 
						array_push($apps, $pathname);
				}
			}
			closedir($dh);
		}
	}

	return $apps;
}

function get_token_template($app)
{
	$app_root = dirname(dirname(dirname(__FILE__)));
	$file = $app_root . '/' . $app . '/conf/token.json';
	$ret = json_decode(IDENTITY_DEFTOKEN);
	if(json_last_error() != JSON_ERROR_NONE) {
		$ret->loaderr = 2;
		$ret->errorn = array($app . ' token decode fail.');
		return $ret;
	}
	$ret->name = $app;

	if(file_exists($file) === false) {
		$ret->loaderr = 1;
		$ret->errorn = array($app . ' token file not exist.');
		return $ret;
	}

	$data = json_decode(file_get_contents($file));
	if(json_last_error() != JSON_ERROR_NONE) {
		$ret->loaderr = 3;
		$ret->errorn = array($app . ' token file decode fail.'); 
		return $ret;
	}

//	权限bit位值，最大支持映射32种权限，
//	目前为8种：
//	1：info、2：list、4：search、8：disable、
//	16：enable、32：save、64：create、128：remove、256：menu

	// "name" => 0,
	if(isset($data->name) && empty($data->name) === false)
		$ret->name = $data->name;

	// "desc" => 0,
	if(isset($data->desc) && empty($data->desc) === false)
		$ret->desc = $data->desc;

	// "defval" => 0,
	if(isset($data->defval) && empty($data->defval) === false)
		$ret->defval = $data->defval;

	$max = 32;
	$mask = 0;
	$tokenmap = array();
	$ret->errorn = array();

	if(isset($data->tokenmap) && empty($data->tokenmap) === false) {

		foreach($data->tokenmap as $key => $val) {

			if(isset($val->name) == false) {
				array_push($ret->errorn, $app . ' token “'.$ret->name.'->tokenmap->'. $key .'->name” is empty, now already skipped.');
				continue;
			}
			if(isset($val->val) == false) {
				array_push($ret->errorn, $app . ' token “'.$ret->name.'->tokenmap->'. $key .'->val” is empty, now already skipped.');
				continue;
			}
			
			$token = array(
				'name'	=> $val->name,
				'val'	=> $val->val,
				'desc'	=> '',
			);
			if(isset($val->desc))
				$token['desc'] = $val->desc;

			$mask |= $val->val;

			$tokenmap[$key] = (object)$token;

			if(--$max < 0) break;
		}

		if(empty($ret->errorn) == false)
			$ret->loaderr = 4;

		$ret->tokenmap = (object)$tokenmap;
		$ret->mask = $mask;
	}

	return $ret;
}

function read_apps_token_file($apps)
{
	$config = array();

	foreach($apps as $app) {
		$data = get_token_template($app);
		if($data->loaderr) continue;
//		unset($data->errorn);
		$config[$app] = $data; 
	}

	return $config;
}

function get_app_token_template($role_id, $app = '')
{
	global $nidb;

	if(empty($app) == false)
		$apps = array($app);
	else
		$apps = get_apps();

	if(($appcnt = count($apps)) <= 0)
		return array();

	if($role_id > 0) {
		// get apps
		$sql = "select `name`, `authority`, `disabled` from cloud_role_token";
		$sql.= " where `role_id` = " . intval($role_id) . " and `name` in (" . substr(str_repeat(',?', $appcnt), 1) . ")";

		try {
			$sth = $nidb->prepare($sql);

			$sth->execute($apps);
			$identity = $sth->fetchAll(\PDO::FETCH_CLASS);
		}
		catch (\NiDBException $e) {
			set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
			return false;
		}
		$apps = array();
		foreach($identity as $val)
			array_push($apps, $val->name);

		$result = read_apps_token_file($apps);
		foreach($result as $key => $app) {
			$post = array_search($key, $apps);
			$result[$key]->defval = $identity[$post]->authority;
			$result[$key]->disabled = $identity[$post]->disabled;
		}
	}
	else
		$result = read_apps_token_file($apps);

	return $result;
}

function list_template($data)
{
	// 用户编辑模版 与 get_option 成对

	if(isset($data['role_id'])) 
		$role_id = intval($data['role_id']);
	else
		$role_id = 0;
	
	if(isset($data['own_id'])) 
		$own_id = intval($data['own_id']);
	else
		$own_id = 0;
	
	if(isset($data['app']))
		$appname = trim($data['app']);
	else
		$appname = '';


	// get info
	$info = _info($role_id);
	if($info === false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '指定的角色不存在！');
		return false;
	}

	if($info->parent_id > 0)
		$dst_role_id = $info->parent_id;
	else
		$dst_role_id = 0;

	// get role
	if(isset($data['op_account']) == false
	|| is_superman(trim($data['op_account'])) == false) {
		if($info->own_id > 0 && $info->own_id != $own_id) {
			set_errmsg(MSG_LEVEL_ARG, __function__, '指定的角色不存在！');
			return false;
		}

		// 非 ROLE_SUPERMAN 帐号 删除系统功能模板
		$tp = get_app_token_template($dst_role_id, $appname);
		foreach($tp as $key => $val) {
			if($tp[$key]->system) unset($tp[$key]);
		}
	}
	else {
		// ROLE_SUPERMAN 帐号 获取全局的角色token配置时，
		// 允许 ROLE_SUPERMAN 帐号可以编辑。
		$tp = get_app_token_template($dst_role_id, $appname);
		if($info->own_id == 0 && $dst_role_id == 0) {
			foreach($tp as $key => $val) {
				$tp[$key]->defval = $val->mask;
			}
		}
	}

	return $tp;
}

function get_option($data)
{
	// 用户编辑模版 与 role_template 成对
	global $nidb;

	if(isset($data['role_id']) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '无效的请求，请指定一个身份！');
		return false;
	}
	if(($role_id = intval($data['role_id'])) <= 0) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '无效的请求，指定的身份不正确！');
		return false;
	}
	
	if(isset($data['name']) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '无效的请求，请指定一个功能！');
		return false;
	}
	if(empty($appname = trim($data['name']))) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '无效的请求，指定的功能为空！');
		return false;
	}

	if(isset($data['own_id']) == false
	|| ($own_id = intval($data['own_id'])) <= 0) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '无效的归属，请先登陆。');
		return false;
	}

	// 获取用户 token 
	$sql = "select token.`role_id`, identity.`own_id`, token.`name`, token.`authority`, token.`disabled` from cloud_role_token as `token`";
	$sql.= " INNER JOIN cloud_role as `identity`";
	$sql.= " ON token.`role_id` = identity.`role_id`";
	$sql.= " where identity.`role_id` = ? and token.`name` = ? limit 1";

	try {
		$sth = $nidb->prepare($sql);
		$sth->bindParam(1, $role_id, \PDO::PARAM_INT);
		$sth->bindParam(2, $appname, \PDO::PARAM_STR);

		$sth->execute();
		$rows = $sth->fetchAll(\PDO::FETCH_CLASS);
	} catch (\PDOException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	if($rows === false || count($rows) <= 0) 
		return (object)array();

	$option = $rows[0];

	if($own_id != $option->own_id) {
		// 所有者不匹配，也不是超级帐号，且返回的配置不是全局的，则需要至空
		if($result->own_id != 0 
		&& (isset($data['op_account']) == false || is_superman(trim($data['op_account'])) == false))
			$result = (object)array();
	}

	return $rows[0];
}

function get_token($appname)
{
	// 用户单独认证
	global $nidb, $user;
/*
	if(isset($user) == false || $user === false 
	|| isset($user->user_id) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '无效的请求，请先登陆！');
		return false;
	}
*/
	$tp = get_token_template($appname);
	if($tp->loaderr > 1) {
		$errmsg = implode(' ', $tp->errorn);
		set_errmsg(MSG_LEVEL_ARG, __function__, $errmsg);
		return false;
	}
	if($tp->loaderr == 1)
		$tp->curval = $tp->mask;
	else
		$tp->curval = 0;

	// 获取用户 token 
	// 如果是所有者ID
	if($user->webmanage & 2) {
		$sql = "select role.`parent_id`, token.`authority` from cloud_role as `role`";
		$sql.= " INNER JOIN cloud_role_token as `token`";
		$sql.= " ON token.`role_id` = role.`role_id`";
		$sql.= " where role.`disabled` = 0 and token.`disabled` = 0";
		$sql.= " and role.`role_id` = 1 and token.`name` = ? limit 1";
	}
	else {
		$sql = "select role.`parent_id`, token.`authority` from cloud_role_user as `user`";
		$sql.= " INNER JOIN cloud_role_token as `token`";
		$sql.= " INNER JOIN cloud_role as `role`";
		$sql.= " ON token.`role_id` = user.`role_id` and role.`role_id` = user.`role_id`";
		$sql.= " where role.`disabled` = 0 and token.`disabled` = 0";
		$sql.= " and token.`name` = ? and user.`user_id` = ? limit 1";
	}

	try {
		$sth = $nidb->prepare($sql);
		
		$sth->bindParam(1, $appname, \PDO::PARAM_STR);
		if(($user->webmanage & 2) == 0)
			$sth->bindParam(2, $user->user_id, \PDO::PARAM_INT);

		$sth->execute();
		$row = $sth->fetch(\PDO::FETCH_LAZY);
	} catch (\PDOException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	if($row)
		$tp->curval = $row->authority;

	return $tp;
}

function set_token($data)
{
	// 用户单独认证
	global $nidb, $user;

	// arg check
	if(isset($data['role_id']) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '无效的请求，请指定一个角色！');
		return false;
	}
	if(($role_id = intval($data['role_id'])) <= 0) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '无效的请求，指定的身份不正确！');
		return false;
	}
	
	if(isset($data['name']) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '操作放弃，未指定配置值！');
		return false;
	}
	if(empty($appname = trim($data['name']))) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '操作放弃，请指定功能！');
		return false;
	}
	
	if(isset($data['authority']) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '操作放弃，未指定配置值！');
		return false;
	}
	$authority = intval($data['authority']);
	
	$own_id = intval($data['own_id']);
	if($own_id < 0 ) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '无效的请求，请先正确登陆！');
		return false;
	}
	
	$app_root = dirname(dirname(dirname(__FILE__)));
	$file = $app_root . '/' . $appname . '/conf/token.json';
	if(file_exists($file) === false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '操作失败，此功能可能不存在！');
		return false;
	}

	// 获取用户 role
	$sql = "select `role_id`, `own_id` from cloud_role where `role_id` = ?";
	try {
		$sth = $nidb->prepare($sql);
		$sth->bindParam(1, $role_id, \PDO::PARAM_INT);

		$sth->execute();
		$rows = $sth->fetchAll(\PDO::FETCH_CLASS);
	} catch (\PDOException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}
	if($rows === false || count($rows) <= 0) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '操作失败，无效的角色！');
		return false;
	}

	$row = $rows[0];
	// 不是超级帐号，不能修改 own_id 为 0 的角色访问权限，也不能修改非自己组织的权限。
	if(is_superman($user->account) == false) {
		if($row->own_id != 0 && $own_id != $row->own_id) {
			set_errmsg(MSG_LEVEL_ARG, __function__, '操作失败，您的权限不足！');
			return false;
		}
	}

	// 获取用户 token
	$sql = "select `role_id`, `authority` from cloud_role_token where `role_id` = ? and `name` = ?";
	try {
		$sth = $nidb->prepare($sql);
		$sth->bindParam(1, $role_id, \PDO::PARAM_INT);
		$sth->bindParam(2, $appname, \PDO::PARAM_STR);

		$sth->execute();
		$rows = $sth->fetchAll(\PDO::FETCH_CLASS);
	} catch (\PDOException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}
	if($rows === false || count($rows) <= 0) {
		$row->authority = null;
	}
	else
		$row->authority = $rows[0]->authority;

	$frmData = array(
		'role_id'		=> $row->role_id,
		'name'			=> $appname,
		'authority'		=> $authority,
		'update_time'	=> time()
	);

	if($row->authority === null) {
		// insert data
		$frmData['create_time'] = $frmData['update_time'];
		try {
			if(insert_data('cloud_role_token', $frmData) === false) {
				$errmsg = implode(' ', $nidb->errorInfo());
				set_errmsg(MSG_LEVEL_DEF, __function__, $errmsg);
				return false;
			}
		}
		catch (\NiDBException $e) {
			set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
			return false;
		}
	}
	else
	if($row->authority == $authority) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '无需修改。');
	}
	else {
		// update data
		$where = array (
			'role_id'		=> $row->role_id,
			'name'			=> $appname,
		);
		try {
			if(update_data('cloud_role_token', $frmData, $where) === false) {
				$errmsg = implode(' ', $nidb->errorInfo());
				set_errmsg(MSG_LEVEL_DEF, __function__, $errmsg);
				return false;
			}
		}
		catch (\NiDBException $e) {
			set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
			return false;
		}
	}

	return true;
}

function get_role($data)
{
	// 获取指定用户的角色
	global $nidb;

	if(isset($data['uids']) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '无效的请求，参数无效！');
		return false;
	}
	if(is_array($data['uids']) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '无效的请求，指定的身份不正确！');
		return false;
	}

	if(isset($data['own_id']) == false
	|| ($own_id = intval($data['own_id'])) <= 0) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '无效的归属，请先登陆。');
		return false;
	}

	// 获取用户 token 
	$sql = "select user.`user_id`, role.`role_id`, role.`name` from cloud_role_user as `user`";
	$sql.= " INNER JOIN cloud_role as `role`";
	$sql.= " ON role.`role_id` = user.`role_id`";
	$sql.= " where user.`user_id` in (" . substr(str_repeat(',?', count($data['uids'])), 1) . ")";
//	$sql.= " and role.`own_id` = ?";

//	array_push($data['uids'], $data['own_id']);
	
	try {
		$sth = $nidb->prepare($sql);
		$sth->execute($data['uids']);
		$rows = $sth->fetchAll(\PDO::FETCH_CLASS);
	} catch (\PDOException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	if($rows === false || count($rows) <= 0) 
		return (object)array();

	return $rows;
}

function add_user($data)
{
	global $nidb, $user;

	$filter = array(
		'role_id'	=> new \FilterVarID(true),
		'user_id'	=> new \FilterVarID(true),
		'own_id'	=> new \FilterVarID(true),
	);

	if(($frmData = filter_data($data, $filter, $errmsg)) === false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, $errmsg);
		return false;
	}

	// 检查用户是否是自己组织的 
	$sql = "select `user_id`, `own_id` from cloud_user where `user_id` = ?";
	try {
		$sth = $nidb->prepare($sql);
		$sth->bindParam(1, $frmData['user_id'], \PDO::PARAM_INT);
		$sth->execute();
		$opuser = $sth->fetch(\PDO::FETCH_LAZY);
	} catch (\PDOException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	if(!$opuser) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '无效的操作员！');
		return false;
	}
	if($opuser->own_id != 0 && $opuser->own_id != $data['own_id']) {
		if((isset($data['op_account']) == false || is_superman(trim($data['op_account'])) == false)) {
			set_errmsg(MSG_LEVEL_EXP, __function__, '无法配置该操作员！');
			return false;
		}
	}

	// 检查角色是否是自己组织的 
	$sql = "select `role_id`, `own_id` from cloud_role where `role_id` = ?";
	try {
		$sth = $nidb->prepare($sql);
		$sth->bindParam(1, $frmData['role_id'], \PDO::PARAM_INT);
		$sth->execute();
		$row = $sth->fetch(\PDO::FETCH_LAZY);
	} catch (\PDOException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	if(!$row) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '无效的角色！');
		return false;
	}

	if($row->own_id != 0 && $row->own_id != $data['own_id']) {
		if((isset($data['op_account']) == false || is_superman(trim($data['op_account'])) == false)) {
			set_errmsg(MSG_LEVEL_EXP, __function__, '无法配置该角色！');
			return false;
		}
	}

	unset($frmData['own_id']);
	
	$nidb->beginTransaction();
	
	if(insert_data('cloud_role_user', $frmData) === false) {
		$errmsg = implode(' ', $nidb->errorInfo());
		set_errmsg(MSG_LEVEL_DEF, __function__, $errmsg);
		$nidb->rollBack();
		return false;
	}
	_role_used_count_inc($frmData['role_id'], 1);
	
	$nidb->commit();

	return true;
}

function del_user($data)
{
	global $nidb, $user;

	$filter = array(
		'role_id'	=> new \FilterVarID(true),
		'user_id'	=> new \FilterVarID(true),
		'own_id'	=> new \FilterVarID(true),
	);

	if(($frmData = filter_data($data, $filter, $errmsg)) === false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, $errmsg);
		return false;
	}

	// 检查用户是否是自己组织的 
	$sql = "select `user_id`, `own_id` from cloud_user where `user_id` = ?";
	try {
		$sth = $nidb->prepare($sql);
		$sth->bindParam(1, $frmData['user_id'], \PDO::PARAM_INT);
		$sth->execute();
		$opuser = $sth->fetch(\PDO::FETCH_LAZY);
	} catch (\PDOException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	if(!$opuser) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '无效的操作员！');
		return false;
	}

	if($opuser->own_id != 0 && $opuser->own_id != $data['own_id']) {
		if((isset($data['op_account']) == false || is_superman(trim($data['op_account'])) == false)) {
			set_errmsg(MSG_LEVEL_EXP, __function__, '无法配置该角色！');
			return false;
		}
	}

	$nidb->beginTransaction();

	$sql = "delete from cloud_role_user where `user_id` = ? and `role_id` = ?";
	try {
		$sth = $nidb->prepare($sql);
		$sth->bindParam(1, $frmData['user_id'], \PDO::PARAM_INT);
		$sth->bindParam(2, $frmData['role_id'], \PDO::PARAM_INT);

		$sth->execute();
		$count = $sth->rowCount();
	} catch (\PDOException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}
	
	if($count > 0)
		_role_used_count_inc($frmData['role_id'], -1);

	$nidb->commit();

	return true;
}

function lst_role($data)
{
	global $nidb;

	$filter = array(
		'user_id'	=> new \FilterVarID(true),
		'own_id'	=> new \FilterVarID(true),
	);

	if(($frmData = filter_data($data, $filter, $errmsg)) === false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, $errmsg);
		return false;
	}


	// 检查角色是否是自己组织的 
	$sql = "select `role_id` from cloud_role_user where `user_id` = ?";
	try {
		$sth = $nidb->prepare($sql);
		$sth->bindParam(1, $frmData['user_id'], \PDO::PARAM_INT);
		$sth->execute();
		$rows = $sth->fetchAll(\PDO::FETCH_OBJ);
	} catch (\PDOException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	if($rows === false || count($rows) <= 0) 
		return (object)array();

	return $rows;
}
