<?php
namespace raas\apps\user;


function _find($account, $own_id = 0)
{
	global $nidb;

	// set custom options
	$keys = '`user_id`,
		`parent_id`,
		`own_id`,
		`account`,
		`disabled`,
		`forgotcnt`,
		`webmanage`,
		`name`,
		`email`,
		`idcard`,
		`phone`,
		`address`,
		`update_time`,
		`create_time`';

	$sql = "select $keys from cloud_user where `account` = ?";

	try {
		if($own_id > 0) {
			$sql.= " and `own_id` = ?";
			$sth = $nidb->prepare($sql);

			$index = 1;
			$sth->bindParam($index++, $account, \PDO::PARAM_STR);
			$sth->bindParam($index++, $own_id, \PDO::PARAM_INT);
		}
		else {
			$sth = $nidb->prepare($sql);

			$index = 1;
			$sth->bindParam($index++, $account, \PDO::PARAM_STR);
		}

		$sth->execute();
		$rows = $sth->fetchAll(\PDO::FETCH_CLASS);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	if(count($rows) <= 0) {
		set_errmsg(MSG_LEVEL_DEF, __function__, "无效的帐号。");
		return false;
	}
	
	return $rows[0];
}

function find($data)
{
	global $nidb;

	$optional = array();

	$where_str = '';

	// set custom options
	if(format_and_push($data, 'account', $optional, '', 'string', false) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, 'err: account can\'t empty.');
		return false;
	}

	if(format_and_push($data, 'own_id', $optional, '', 'int', false))
		return _find($optional['account'], $optional['own_id']);

	return _find($optional['account']);
}

