<?php
namespace raas\apps\user;


function _info($user_id, $own_id = 0)
{
	global $nidb;

	$keys = '`user_id`,
		`parent_id`,
		`own_id`,
		`entcnt`,
		`account`,
		`forgotcnt`,
		`disabled`,
		`webmanage`,
		`name`,
		`email`,
		`idcard`,
		`phone`,
		`address`,
		`update_time`,
		`create_time`';
		
	$sql = "select $keys from cloud_user where `user_id` = ?";

	try {
		if($own_id > 0) {
			$sql.= " and `own_id` = ?";
			$sth = $nidb->prepare($sql);

			$index = 1;
			$sth->bindParam($index++, $user_id, \PDO::PARAM_INT);
			$sth->bindParam($index++, $own_id, \PDO::PARAM_INT);
		}
		else {
			$sth = $nidb->prepare($sql);

			$index = 1;
			$sth->bindParam($index++, $user_id, \PDO::PARAM_INT);
		}

		$sth->execute();
		$rows = $sth->fetchAll(\PDO::FETCH_CLASS);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	if(count($rows) <= 0) {
		set_errmsg(MSG_LEVEL_DEF, __function__, "无效的帐号。");
		return false;
	}
	
	return $rows[0];
}

function info($data)
{
	global $nidb;

	$optional = array();

	$where_str = '';

	// set custom options
	if(format_and_push($data, 'user_id', $optional, '', 'int', false) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, 'err: user_id can\'t empty.');
		return false;
	}
	$where_str .= "`user_id` = " . $optional['user_id']  . " and ";

	if(format_and_push($data, 'own_id', $optional, '', 'int', false))
		$where_str .= "`own_id` = " . $optional['own_id']  . " and ";


	if($where_str != '')
		$where_str = substr("where $where_str", 0, -5);

	$keys = '`user_id`,
		`parent_id`,
		`own_id`,
		`entcnt`,
		`account`,
		`forgotcnt`,
		`disabled`,
		`webmanage`,
		`name`,
		`email`,
		`idcard`,
		`phone`,
		`address`,
		`update_time`,
		`create_time`';
		
	$sql = "select $keys from cloud_user $where_str";

	try {
		$sth = $nidb->prepare($sql);

		$sth->execute();
		$rows = $sth->fetchAll(\PDO::FETCH_CLASS);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	if(count($rows) <= 0) {
		set_errmsg(MSG_LEVEL_DEF, __function__, "无效的帐号。");
		return false;
	}
	
	return $rows[0];
}

