<?php
namespace raas\apps\user;


function select($data)
{
	global $nidb;

	$values = array();
	$optional = array();
	// set order, limit, offset value
	format_list_arg($data, $optional);

	$where_str = '';
	if(format_and_push($data, 'disabled', $optional, '', 'int', false))
		$where_str .= "`disabled` = " . $optional['disabled'] . " and ";
	else
		$where_str .= "`disabled` < " . TB_ROW_DEL_VALUE . " and ";
	
	if(format_and_push($data, 'upstartm', $optional, '', 'int', false))
		$where_str .= "`update_time` >= " . $optional['upstartm'] . " and ";

	if(format_and_push($data, 'endtm', $optional, '', 'int', false)) 
		$where_str .= "`update_time` < " . $optional['upendtm']  . " and ";

	if(format_and_push($data, 'startm', $optional, '', 'int', false))
		$where_str .= "`create_time` >= " . $optional['startm'] . " and ";

	if(format_and_push($data, 'endtm', $optional, '', 'int', false))
		$where_str .= "`create_time` < " . $optional['endtm']  . " and ";

	// set custom options
	if(format_and_push($data, 'own_id', $optional, '', 'int', false))
		$where_str .= "`own_id` = " . $optional['own_id']  . " and ";

	if(format_and_push($data, 'user_id', $optional, '', 'int', false))
		$where_str .= "`user_id` = " . $optional['user_id']  . " and ";
	
	if(format_and_push($data, 'account', $optional, '', 'int', false))
		$where_str .= "`account` = " . $optional['account']  . " and ";
	
	if(format_and_push($data, 'name', $optional, '', 'string', false)) {
		$where_str .= "`name` = ? and ";
		array_push($values, $optional['name']);
	}
	if(format_and_push($data, 'email', $optional, '', 'string', false)) {
		$where_str .= "`email` = ? and ";
		array_push($values, $optional['email']);
	}
	if(format_and_push($data, 'idcard', $optional, '', 'string', false)) {
		$where_str .= "`idcard` = ? and ";
		array_push($values, $optional['idcard']);
	}
	if(format_and_push($data, 'phone', $optional, '', 'string', false)) {
		$where_str .= "`phone` = ? and ";
		array_push($values, $optional['phone']);
	}

	if(format_and_push($data, 'remark', $optional, '', 'string', false)) {
		$where_str .= "`remark` = ? and ";
		array_push($values, "%" . $optional['remark'] . "%");
	}

	if(isset($data['search'])) {
		if(format_and_push($data['search'], 'value', $optional, 'search', 'string', false)) {
			$where_str .= "(`name` like ? or `remark` like ?) and ";
			array_push($values, "%" . $optional['search'] . "%");
			array_push($values, "%" . $optional['search'] . "%");
		}
	}

	if($where_str != '')
		$where_str = substr("where $where_str", 0, -5);


	$order_map = array(
		"user_id",
		"parent_id",
		"own_id",
		"entcnt",
		"forgotcnt",
		"account",
		"disabled",
		"webmanage",
		"name",
		"email",
		"idcard",
		"phone",
		"address",
		"update_time",
		"create_time"
	);
		
	$order = array();
	if(isset($optional['order'])) {
		foreach($optional['order'] as $op) {
			if(isset($op['column']) && isset($data['columns'][$op['column']]['data'])) {
				if(in_array($data['columns'][$op['column']]['data'], $order_map))
					array_push($order, "`" . $data['columns'][$op['column']]['data'] . "` " . $op['dir']);
			}
		}
	}

	if(count($order) > 0)
		$order_by = 'order by ' . implode(', ', $order);
	else
		$order_by = '';

	$sql = "select count(*) as `total` from cloud_user $where_str";

	try {
		$sth = $nidb->prepare($sql);
		$sth->execute($values);
		$rows = $sth->fetchAll(\PDO::FETCH_CLASS);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}
	
	if(count($rows) > 0) {
		$result = array(
			'total' => $rows[0]->total,
		);
	}
	else {
		$result = array(
			'total' => 0,
		);
	}

	$keys = '`user_id`,
		`parent_id`,
		`own_id`,
		`entcnt`,
		`forgotcnt`,
		`account`,
		`disabled`,
		`webmanage`,
		`name`,
		`email`,
		`idcard`,
		`phone`,
		`address`,
		`update_time`,
		`create_time`';

	$sql = "select $keys from cloud_user $where_str $order_by limit ? offset ? ";

	array_push($values, $optional['limit']);
	array_push($values, $optional['offset']);


	try {
		$sth = $nidb->prepare($sql);
		$sth->execute($values);
		$rows = $sth->fetchAll(\PDO::FETCH_CLASS);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	$result['rows'] = $rows;

	if(isset($data['draw'])) $result['draw'] = $data['draw'];

	return $result;
}

