<?php
namespace raas\apps\user;

// _user_count_inc load 
ni_app_load('entowner', '_lib');
ni_app_load('counter', '_lib');

function remove($data)
{
	global $nidb, $user;

	$filter = array(
		'user_id'	=> new \FilterVarID(true),
		'own_id'	=> new \FilterVarID(true),
	);
	if(($where = filter_data($data, $filter, $errmsg)) === false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, $errmsg);
		return false;
	}
	
	if($where['user_id'] == $user->user_id) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '无法删除自己的帐号！');
		return false;
	}

	// user is exist?
	$sql = "select `own_id` from cloud_user where `user_id` = ? and `own_id` = ? and `disabled` < " . TB_ROW_DEL_VALUE;
	try {
		$sth = $nidb->prepare($sql);

		$index = 1;
		$sth->bindParam($index++, $where['user_id'], \PDO::PARAM_INT);
		$sth->bindParam($index++, $where['own_id'], \PDO::PARAM_INT);

		$sth->execute();
		$rows = $sth->fetchAll(\PDO::FETCH_CLASS);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}
	if(count($rows) <= 0) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '找不到此帐号。');
		return false;
	}
	$row = $rows[0];


	
	$frmData['entcnt'] = 0;
	$frmData['disabled'] = TB_ROW_DEL_VALUE;
	$frmData['update_time'] = time();

	$nidb->beginTransaction();
	try {
		if(update_data('cloud_user', $frmData, $where) === false) {
			$errmsg = implode(' ', $nidb->errorInfo());
			set_errmsg(MSG_LEVEL_DEF, __function__, $errmsg);
			$nidb->rollBack();
			return false;
		}
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		$nidb->rollBack();
		return false;
	}

	if(\raas\apps\entowner\_user_count_inc($row->own_id, -1) === false) {
		$nidb->rollBack();
		return false;
	}
	if(\raas\apps\counter\_user_count_inc(COUNTER_RAAS_ID, -1) === false) {
		$nidb->rollBack();
		return false;
	}


	// 删除操作员的关联
	try {
		// 删除企业下的用户组关联
		$sql = 'delete from cloud_user_group_list where `user_id` = ?';
		$sth = $nidb->prepare($sql);

		$sth->bindParam(1, $where['user_id'], \PDO::PARAM_INT);
		$sth->execute();
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		$nidb->rollBack();
		return false;
	}

	$nidb->commit();

	return true;
}

