<?php
namespace raas\apps\user;

function _save($frmData, $where)
{
	global $nidb;


	$frmData['update_time'] = time();

	try {
		if(update_data('cloud_user', $frmData, $where) === false) {
			$errmsg = implode(' ', $nidb->errorInfo());
			set_errmsg(MSG_LEVEL_DEF, __function__, $errmsg);
			return false;
		}
	}
	catch (PDOException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	return true;
}

function save($data)
{
	global $nidb, $user;

	$filter = array(
		'user_id'	=> new \FilterVarID(true),
		'own_id'	=> new \FilterVarID(true),
	);
	if(($where = filter_data($data, $filter, $errmsg)) === false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, $errmsg);
		return false;
	}

	$filter = array(
		'parent_id'	=> new \FilterVarInt(),
		'pass'		=> new \FilterVarStr(),
		'disabled'	=> new \FilterVarInt(),
		'webmanage'	=> new \FilterVarInt(),
		'name'		=> new \FilterVarStr(),
		'email'		=> new \FilterVarEmail(),
		'idcard'	=> new \FilterVarStr(),
		'phone'		=> new \FilterVarStr(),
		'address'	=> new \FilterVarStr(),
	);
	if(($frmData = filter_data($data, $filter, $errmsg)) === false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, $errmsg);
		return false;
	}
	if(count($frmData) <= 0) {
		set_errmsg(MSG_LEVEL_DEF, __function__, "修改已放弃！无任何内容需要保存。");
		return false;
	}
	if($where['user_id'] == 1 && $user->user_id != 1) {
		set_errmsg(MSG_LEVEL_DEF, __function__, "修改已放弃！您的权限不足。");
		return false;
	}

	$frmData['update_time'] = time();

	$nidb->beginTransaction();
	
	if(_save($frmData, $where) == false) {
		$nidb->rollBack();
		return false;
	}

	$nidb->commit();

	return true;
}

