<?php
if(PHP_SAPI != 'cli') exit;


function my_install_logger($msg)
{
	$logdir = ROOT_DIR . '/logger';
	if(!is_dir($logdir) && !mkdir($logdir)) return;
	$fd = fopen($logdir . date('/Y-m-d') . '.log', 'a');
	if(!$fd) return;
	fwrite($fd, date('[H:i:s]') . " {$msg}\n");
	fclose($fd);
}

// order apps install
$file = ROOT_DIR . '/install/install_order_table.dat';
if(file_exists($file) && ($lines = file($file))) {
	foreach($lines as $line) {
		if(empty($app = trim($line, " \t\n\r\0\x0B")))
			continue;

		$msg = 'app: ' . $app . ' install: ';
		$dir = ROOT_DIR . '/install/apps/' . $app;
		if(!file_exists($dir . '/install.php')) {
			my_install_logger($msg . 'No Exists');
			continue;
		}

		if(require_once($dir . '/install.php'))
			my_install_logger($msg . ($errmsg?$errmsg:'Success'));
		else
			my_install_logger($msg . ($errmsg?$errmsg:'Fail'));
		$errmsg = '';

		exec('rm -rf ' . $dir);
	}

	unlink($file);
}

// other apps install
$apps_root =  ROOT_DIR . '/install/apps';

if (is_dir($apps_root)) {
	$install_list = array();
	
	if ($dh = opendir($apps_root)) {
		while (($pathname = readdir($dh)) !== false) {
			if($pathname != "." && $pathname != "..") {
				$file = $apps_root . '/' . $pathname . '/install.php';
				if(file_exists($file))
					array_push($install_list, array('name' => $pathname, 'file' => $file));
			}
		}
		closedir($dh);
	}

	$errmsg = '';
	foreach($install_list as $install) {
		$msg = 'app: ' . $install['name'] . ' install: ';
		if(require_once($install['file']))
			my_install_logger($msg . ($errmsg?$errmsg:'Success'));
		else
			my_install_logger($msg . ($errmsg?$errmsg:'Fail'));
		$errmsg = '';
	}

	exec('rm -rf ' . $apps_root);
	
	$logger_root =  ROOT_DIR . '/logger';
	if ($dh = opendir($logger_root)) {
		$install_list = array();
		$sort_list = array();
		while (($pathname = readdir($dh)) !== false) {
			if($pathname != "." && $pathname != ".." 
			&& pathinfo($pathname, PATHINFO_EXTENSION) == 'log') {
				$date = substr($pathname, 0, strpos($pathname, '.'));
				$date = mktime(0, 0, 0, intval(substr($date, 5, 2)), intval(substr($date, 8, 2)), intval(substr($date, 0, 4)));
				$file = $logger_root . '/' . $pathname;
				array_push($install_list, $file);
				array_push($sort_list, $date);
			}
		}
		closedir($dh);

		$logger_file_count = count($install_list) - 120;
		if($logger_file_count > 0) {

			array_multisort($sort_list, SORT_ASC, SORT_NUMERIC, $install_list);

			for($i = 0; $i < $logger_file_count; $i++)
				unlink($install_list[$i]);

		}
	}

}
