<?php
define('ABS_PATH', __DIR__);

if(file_exists(dirname(ABS_PATH) . '/conf/email.php'))
	require_once(dirname(ABS_PATH) . '/conf/email.php');

// ********************************************************
// email of config
// ********************************************************
defined('NIMS_ON') or define('NIMS_ON', true);
defined('NIMS_MAIL_FROM') or define('NIMS_MAIL_FROM', 'From Email');
defined('NIMS_MAIL_FROM_NAME') or define('NIMS_MAIL_FROM_NAME', 'From Name');
defined('NIMS_MAILER') or define('NIMS_MAILER', 'smtp'); // Possible values 'smtp', 'mail', or 'sendmail'
defined('NIMS_SET_RETURN_PATH') or define('NIMS_SET_RETURN_PATH', 'false'); // Sets $phpmailer->Sender if true
defined('NIMS_SMTP_AUTH') or define('NIMS_SMTP_AUTH', true); // True turns on SMTP authentication, false turns it off

defined('NIMS_SMTP_HOST') or define('NIMS_SMTP_HOST', 'smtp.ym.163.com'); // The SMTP mail host
defined('NIMS_SMTP_PORT') or define('NIMS_SMTP_PORT', 25); // The SMTP server port number
defined('NIMS_SSL') or define('NIMS_SSL', ''); // Possible values '', 'ssl', 'tls' - note TLS is not STARTTLS
defined('NIMS_SMTP_USER') or define('NIMS_SMTP_USER', ''); // SMTP authentication username, only used if NIMS_SMTP_AUTH is true
defined('NIMS_SMTP_NAME') or define('NIMS_SMTP_NAME', '北京派网软件有限公司');
defined('NIMS_SMTP_PASS') or define('NIMS_SMTP_PASS', '');


// Import PHPMailer classes into the global namespace
// These must be at the top of your script, not inside a function
require_once(ABS_PATH . '/PHPMailer/src/SMTP.php');
require_once(ABS_PATH . '/PHPMailer/src/Exception.php');
require_once(ABS_PATH . '/PHPMailer/src/PHPMailer.php');

use \PHPMailer\PHPMailer\PHPMailer;
use \PHPMailer\PHPMailer\Exception;

// Load composer's autoloader
// require 'vendor/autoload.php';

require_once(ABS_PATH . '/ni_db.php');
require_once(ABS_PATH . '/config.php');

/** crontab scan start **/

define('ROOT_DIR', dirname(__DIR__));
$crontab_root =  ROOT_DIR . '/conf/crontab';
$crons = array();

if (is_dir($crontab_root)) {
	if ($dh = opendir($crontab_root)) {
		while (($pathname = readdir($dh)) !== false) {
			if($pathname != "." && $pathname != "..") {
				if(pathinfo($pathname, PATHINFO_EXTENSION) == 'php'
				&& !is_dir($crontab_root . '/' . $pathname))
					array_push($crons, $crontab_root . '/' . $pathname);
			}
		}
		closedir($dh);
	}

	if(count($crons)) {
		require_once(ROOT_DIR . '/ni-core/loader.php');

		$nidb->setAttribute(PDO::ATTR_ERRMODE,PDO::ERRMODE_WARNING);
		foreach($crons as $cronfile) 
			require_once($cronfile);
		$nidb->setAttribute(PDO::ATTR_ERRMODE,PDO::ERRMODE_EXCEPTION);
	}
}

/** end **/

	
function email_status_logger($id, $status)
{
	global $nidb;

	$where = array('email_id' => $id);
	$data = array(
		'status' => $status,
		'send_time'=> time(),
	);

	$nidb->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
	try {
		if(update_data('cloud_email_logger', $data, $where) === false) {
			$errmsg = implode(' ', $nidb->errorInfo());
			set_errmsg(MSG_LEVEL_EXP, __function__, '创建邮件日志失败！' . $errmsg);
			return false;
		}
	} catch (PDOException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, '创建邮件日志失败！' . $e->getMessage());
		return false;
	}

	return true;
}

function mail_get_logger()
{
	global $nidb;

	// get use wallet
	$nidb->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
	try {
		$sql = "select count(*) as count from cloud_email_logger where `status` = 'SENDING'";
		$sth = $nidb->prepare($sql);

		$sth->execute();
		$rows = $sth->fetchAll(PDO::FETCH_CLASS);
		$count = $rows[0]->count;

		if($count > 0) {
			$sql = "select * from cloud_email_logger where `status` = 'SENDING' limit 50";
			$sth = $nidb->prepare($sql);

			$sth->execute();
			$rows = $sth->fetchAll(PDO::FETCH_CLASS);
		}
		else {
			$rows = array();
		}
	} catch (PDOException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, '创建邮件日志失败！' . $e->getMessage());
		return false;
	}

	return array('count' => $count, 'rows' => $rows);
}

if(empty(NIMS_SMTP_USER))
	exit;

if(($loggers = mail_get_logger()) === false) {
//	email_add_logger('test', 'test1s');
	exit;
}

$mail = new PHPMailer(true);  // Passing `true` enables exceptions


	//Server settings
	$mail->setLanguage('zh_cn', ABS_PATH . '/PHPMailer/language/');
	$mail->CharSet = 'UTF-8';
	
	$mail->SMTPDebug = 0;                                 // Enable verbose debug output
	$mail->isSMTP();                                      // Set mailer to use SMTP
	$mail->Host = NIMS_SMTP_HOST;						  // Specify main and backup SMTP servers
	$mail->SMTPAuth = true;                               // Enable SMTP authentication
	$mail->Username = NIMS_SMTP_USER;					  // SMTP username
	$mail->Password = NIMS_SMTP_PASS;					  // SMTP password
	$mail->SMTPSecure = NIMS_SSL;						  // Enable TLS encryption, `ssl` also accepted
	$mail->Port = NIMS_SMTP_PORT;						  // TCP port to connect to
	
	// Recipients
	$mail->setFrom(NIMS_SMTP_USER, NIMS_SMTP_NAME);
//		$mail->addAddress('dnssy@qq.net', 'Joe User');     // Add a recipient
//		$mail->addAddress('dnssy@qq.com');                 // Name is optional

//		$mail->addReplyTo('dnssy@qq.com', 'Information');
//		$mail->addCC('dnssy@qq.com');
//		$mail->addBCC('dnssy@qq.com');

	//Attachments
	//$mail->addAttachment('/var/tmp/file.tar.gz');         // Add attachments
	//$mail->addAttachment('/tmp/image.jpg', 'new.jpg');    // Optional name

	//Content
	$mail->isHTML(true);
	
	foreach ($loggers['rows'] as $node) {

	// Set email format to HTML
/*
		$mail->Subject = 'Here is the subject';
		$mail->Body    = 'This is the HTML message body <b>in bold!</b>';
		$mail->AltBody = 'This is the body in plain text for non-HTML mail clients';
*/

		try {
				$to = explode('|', $node->to);
				foreach($to as $val) {
					if(($pos = strpos($val, '<')) === false) continue;
					$name = substr($val, 0, $pos - 2);
					$email = substr($val, $pos + 1, strlen($val) - $pos - 2);
					$mail->addAddress($email, $name);     // Name is optional
				}

				$mail->Subject = $node->subject;
				$mail->Body    = $node->body;

				//$mail->AltBody = 'This is the body in plain text for non-HTML mail clients';

				$mail->send();
				email_status_logger($node->email_id, 'SENT');
				// echo 'Message has been sent';
				$mail->clearAddresses();
		} catch (Exception $e) {
			if(strpos($mail->ErrorInfo, '地址是无效') !== false ||
				strpos($mail->ErrorInfo, '地址错误') !== false)
				email_status_logger($node->email_id, 'CANCEL');
			echo 'Message could not be sent. Mailer Error: ', $mail->ErrorInfo . '[' . $node->to . ']';
			var_dump($node);
		}

	}
