<?php

/*
SET FOREIGN_KEY_CHECKS=0;

-- ----------------------------
-- Table structure for cloud_presale_card
-- ----------------------------
*/

$sql = "
CREATE TABLE IF NOT EXISTS `cloud_presale_card` (
  `psc_id` int(11) NOT NULL AUTO_INCREMENT,
  `ent_id` int(11) NOT NULL DEFAULT '0' COMMENT '企业ID',
  `group_id` int(11) NOT NULL DEFAULT '0' COMMENT '用户组ID',
  `own_id` int(11) NOT NULL DEFAULT '0' COMMENT '企业组ID',
  `name` char(30) NOT NULL DEFAULT '' COMMENT '充值卡名',
  `count` int(11) NOT NULL DEFAULT '0' COMMENT '已发行数',
  `usedcnt` int(11) NOT NULL DEFAULT '0' COMMENT '已使用数',
  `rmvcnt` int(11) NOT NULL DEFAULT '0' COMMENT '已删除数',
  `disabled` tinyint(4) NOT NULL DEFAULT '0' COMMENT '是否禁用',
  `tmtype` tinyint(4) NOT NULL DEFAULT '0' COMMENT '时间类型：0：无；1：分：2：时；3：天；4：月；5：年；',
  `tmlong` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '时长',
  `expense` decimal(20,2) NOT NULL DEFAULT '0.00' COMMENT '面值',
  `rate_out` bigint(20) NOT NULL DEFAULT '0' COMMENT '单IP上行限速',
  `rate_in` bigint(20) NOT NULL DEFAULT '0' COMMENT '单IP下行限速',
  `update_time` bigint(20) NOT NULL DEFAULT '0' COMMENT '最后更新时间',
  `create_time` bigint(20) NOT NULL DEFAULT '0' COMMENT '开户时间',
  PRIMARY KEY (`psc_id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT;
";

if($nidb->query($sql) === false) {
	$errmsg = "sql create table cloud_presale_card fail";
	return 0;
}

$sql = "
ALTER TABLE `cloud_presale_card`
ADD COLUMN `group_id` int(11) NOT NULL DEFAULT '0' COMMENT '用户组ID' AFTER `ent_id`;
";
$nidb->query($sql);


/*
-- ----------------------------
-- Table structure for cloud_presale_item
-- ----------------------------
*/

$sql = "
CREATE TABLE IF NOT EXISTS `cloud_presale_item` (
  `psi_code` varchar(32) NOT NULL DEFAULT '' COMMENT '充值卡编码',
  `psc_id` int(11) NOT NULL DEFAULT '0' COMMENT '充值卡ID',
  `ent_id` int(11) NOT NULL DEFAULT '0' COMMENT '企业ID',
  `group_id` int(11) NOT NULL DEFAULT '0' COMMENT '用户组ID',
  `own_id` int(11) NOT NULL DEFAULT '0' COMMENT '企业组ID',
  `name` varchar(30) NOT NULL DEFAULT '' COMMENT '充值卡名称',
  `start_time` bigint(20) NOT NULL DEFAULT '0' COMMENT '开始有效时间',
  `expire_time` bigint(20) NOT NULL DEFAULT '0' COMMENT '截止有效时间',
  `expense` decimal(20,2) NOT NULL DEFAULT '0.00' COMMENT '面值',
  `tmtype` tinyint(4) NOT NULL DEFAULT '0' COMMENT '时间类型：0：无；1：分：2：时；3：天；4：月；5：年；',
  `tmlong` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '时长',
  `rate_out` bigint(20) NOT NULL DEFAULT '0' COMMENT '单IP上行限速',
  `rate_in` bigint(20) NOT NULL DEFAULT '0' COMMENT '单IP下行限速',
  `update_time` bigint(20) NOT NULL DEFAULT '0' COMMENT '最后更新时间',
  `create_time` bigint(20) NOT NULL DEFAULT '0' COMMENT '开户时间',
  PRIMARY KEY (`psi_code`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
";

if($nidb->query($sql) === false) {
	$errmsg = "sql create table cloud_presale_item fail";
	return 0;
}

$sql = "
ALTER TABLE `cloud_presale_item`
ADD COLUMN `group_id` int(11) NOT NULL DEFAULT '0' COMMENT '用户组ID' AFTER `ent_id`;
";
$nidb->query($sql);

/*
-- ----------------------------
-- Table structure for cloud_presale_logger
-- ----------------------------
*/

$sql = "
CREATE TABLE IF NOT EXISTS `cloud_presale_logger` (
  `psi_code` varchar(32) NOT NULL DEFAULT '' COMMENT '充值卡编码',
  `psc_id` int(11) NOT NULL DEFAULT '0' COMMENT '充值卡ID',
  `ent_id` int(11) NOT NULL DEFAULT '0' COMMENT '企业ID',
  `group_id` int(11) NOT NULL DEFAULT '0' COMMENT '用户组ID',
  `own_id` int(11) NOT NULL DEFAULT '0' COMMENT '企业组ID',
  `account` varchar(64) NOT NULL DEFAULT '' COMMENT '被充值的帐号',
  `name` varchar(30) NOT NULL DEFAULT '' COMMENT '充值卡名称',
  `operation` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '操作方法：0：强制删除，1：到期删除。2：使用后删除。',
  `start_time` bigint(20) NOT NULL DEFAULT '0' COMMENT '开始有效时间',
  `expire_time` bigint(20) NOT NULL DEFAULT '0' COMMENT '截止有效时间',
  `expense` decimal(20,2) NOT NULL DEFAULT '0.00' COMMENT '面值',
  `tmtype` tinyint(4) NOT NULL DEFAULT '0' COMMENT '时间类型：0：无；1：分：2：时；3：天；4：月；5：年；',
  `tmlong` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '时长',
  `rate_out` bigint(20) NOT NULL DEFAULT '0' COMMENT '单IP上行限速',
  `rate_in` bigint(20) NOT NULL DEFAULT '0' COMMENT '单IP下行限速',
  `update_time` bigint(20) NOT NULL DEFAULT '0' COMMENT '最后更新时间',
  `create_time` bigint(20) NOT NULL DEFAULT '0' COMMENT '开户时间'
) ENGINE=ARCHIVE DEFAULT CHARSET=utf8;
";

if($nidb->query($sql) === false) {
	$errmsg = "sql create table cloud_presale_logger fail";
	return 0;
}

$sql = "
ALTER TABLE `cloud_presale_logger`
ADD COLUMN `group_id` int(11) NOT NULL DEFAULT '0' COMMENT '用户组ID' AFTER `ent_id`;
";
$nidb->query($sql);


$nidb->setAttribute(\PDO::ATTR_ERRMODE, \PDO::ERRMODE_WARNING);

$sql = "
ALTER TABLE `cloud_presale_item`
ADD COLUMN `ordernum`  char(32) NOT NULL DEFAULT '' COMMENT '商户订单号' AFTER `own_id`;
";
$nidb->query($sql);
/*
if($nidb->query($sql) === false) {
	$errmsg = "sql create table cloud_presale_item fail";
}
*/
$sql = "
ALTER TABLE `cloud_presale_logger`
ADD COLUMN `ordernum`  char(32) NOT NULL DEFAULT '' COMMENT '商户订单号' AFTER `own_id`;
";
$nidb->query($sql);
/*
if($nidb->query($sql) === false) {
	$errmsg = "sql create table cloud_presale_logger fail";
}
*/
// $nidb->setAttribute(\PDO::ATTR_ERRMODE,\PDO::ERRMODE_EXCEPTION);
