<?php
// ********************************************************
// db init of manage
// ********************************************************
require_once(ROOT_DIR . '/conf/db.php');

// init
if (isset($GLOBALS['nidb']))
	return;
try {
	// . ';charset=utf8'
    $GLOBALS['nidb'] = new ni_db('mysql:host=' . DB_HOST . ';dbname=' . DB_NAME . ';charset=' . DB_CHARSET, 
								DB_USER, DB_PASSWORD,
								array(
									PDO::ATTR_PERSISTENT		=> true,
									PDO::ATTR_EMULATE_PREPARES	=> false,
									PDO::ATTR_ERRMODE			=> PDO::ERRMODE_EXCEPTION
								)
							);
/*
需要修改my.ini

[client]下添加
default_character_set = utf8

[mysql]下添加
default_character_set = utf8

[mysqld]下添加
character_set_server = utf8

show variables like "%char%";
+--------------------------+----------------------------------+
| Variable_name            | Value                            |
+--------------------------+----------------------------------+
| character_set_client     | utf8                             |
| character_set_connection | utf8                             |
| character_set_database   | utf8                             |
| character_set_filesystem | binary                           |
| character_set_results    | utf8                             |
| character_set_server     | latin1                           |
| character_set_system     | utf8                             |
| character_sets_dir       | /usr/local/share/mysql/charsets/ |
+--------------------------+----------------------------------+

ATTR_ERRMODE: 错误报告是针对执行的sql出错时
PDO::ERRMODE_SILENT（0） ：默认 不提示任何错误 ，连接时无论如何都会提示，只有在执行后面的方法时才会起作用
PDO::ERRMODE_WARNING（1） ： 警告
PDO::ERRMODE_EXCEPTION（2）：异常（推荐使用） 用try catch捕获，也可以手动抛出异常 new PDOException($message, $code, $previous)
	$stm = $GLOBALS['nidb']->prepare('set names gbk ;');  
	if( $stm && $stm->execute() ) {
		$result = $stm->rowCount(); 
		echo "set names gbk: " . $result . "\n";
	}

	$stm = $GLOBALS['nidb']->prepare("set names 'utf8' ;");  
	if( $stm && $stm->execute() ) {
		$result = $stm->rowCount(); 
		echo "set names utf8: " . $result . "\n";
	}
*/
} catch (PDOException $e) {
	json_error_exit(ERR_FAILURE, "nidb err: " . $e->getMessage());
    die();
}



function insert_data($dbname, $data)
{
	global $nidb;
	
	$keys = array_keys($data);
	
	$fields = '`'.implode('`, `',$keys).'`';
	$placeholder = substr(str_repeat('?,',count($keys)),0,-1);

	return $nidb->prepare("insert into `$dbname` ($fields) values ($placeholder)")->execute(array_values($data));
}

function update_data($dbname, $data, $where)
{
	global $nidb;
	
	$values = array();
	$placeholder = '';
	foreach($data as $key => $val) {
		array_push($values, $val);
		$placeholder = "$placeholder`$key` = ?, ";
	}

	if($placeholder == '')
		return false;
	$placeholder = substr($placeholder, 0, -2);

	$where_str = '';
	foreach($where as $key => $val) {
		$where_str = "$where_str`$key` = ? and ";
		array_push($values, $val);
	}

	if($where_str != '') 
		$where_str = substr("where $where_str", 0, -5);

	return $nidb->prepare("update `$dbname` set $placeholder $where_str")->execute($values);
}

function insert_data_duplicate_key_sum($dbname, array $data, array $sum_key, array $update_key = array())
{
	global $nidb;

	// auto insert, if exist then add intval for $sum_key or $update_key
	$keys = array_keys($data);
	$values = array_values($data);

	$fields = '`'.implode('`, `',$keys).'`';
	$placeholder = substr(str_repeat('?,',count($keys)),0,-1);

	$updatekey = '';
	foreach($sum_key as $key => $val) {
		$updatekey .= ", `$key` = `$key` + $val";
	}
	foreach($update_key as $key => $val) {
		$updatekey .= ", `$key` = $val";
	}

	$updatekey = substr($updatekey, 1);

	return $nidb->prepare("insert into `$dbname` ($fields) values ($placeholder) on duplicate key update $updatekey")->execute($values);
}

define('RA_SYNC_ACCOUNT',	1);
define('RA_SYNC_GROUP',		2);
define('RA_SYNC_ENT',		3);

function synclog_push($type, $ids)
{
	global $nidb;

	return $nidb->prepare("insert into `cloud_synclog` (`type`, `ids`) value ($type, '$ids')")->execute();
}

