<?PHP

define( 'RAASEYE', '/usr/bin/raaseye');

/*

 * test code

$data = array(
	'ent_id'	=> 100,
	'domain'	=> 'test.inc',
	'secret'	=> '123',
	'disabled' => 0,
);
raaseye_enterpise_add($data);

$data = array(
	'group_id'	=> 1000,
	'ent_id'	=> 100,
	'name'		=> 'test.inc',
	'ifname'	=> '',
	'disabled' => 0,
	'clntepa'	=> 0,
	'startip'	=> 0,
	'endip'		=> 0,
	'rate_out'	=> 0,
	'rate_in'	=> 0,
	'dns0'		=> 0,
	'dns1'		=> 0,
	'maxonlinetm'=>0,
	'vlan_out'	=> 0,
	'vlan_in'	=> 0,
);
raaseye_group_add($data);

$data = array(
	'group_id'	=> 1000,
	'ent_id'	=> 100,
	'account'	=> 'qcll',
	'pass'		=> 1245,
	'disabled'	=> 0,
	'maxcnt'	=> 10,
	'create_time'=> '1531909148',
	'start_time'=> '1531843200',
	'expire_time'=> '1572969600',
	'bind_v4mac'=> '',
	'bind_ipv4'	=> 0,
	'bind_vlan'	=> 0,
	'pxyvlan_in'=> 0,
	'pxyvlan_out'=> 0,
	'pxyacct'	=> '',
	'pxypass'	=> '',
	'name'		=> 'cname',
	'idcard'	=> 'card',
	'phone'		=> 'phone',
	'remark'	=> 'other',
);
raaseye_acct_add($data);


var_dump(raaseye_enterpise_list(array()));
var_dump(raaseye_group_list(array()));
var_dump(raaseye_acct_list(array()));

var_dump(raaseye_acct_remove('qcll@test.inc'));
var_dump(raaseye_group_remove(1000, 100));
var_dump(raaseye_enterpise_remove(100));
*/

function raaseye_acct_add($data)
{
	$map = array(
		'acct_id'	=> 'acctid',
		'group_id'	=> 'gid',
		'ent_id'	=> 'entid',
		'account'	=> 'acct',
		'pass'		=> 'pass',
		'disabled'	=> 'disabled',
		'maxcnt'	=> 'maxonline',
		'create_time'=> 'birthtm',
		'start_time'=> 'starttm',
		'expire_time'=> 'expiretm',
		'bind_v4mac'=> 'bindmac',
		'bind_ipv4'	=> 'bindip',
		'bind_vlan'	=> 'bindvlan',
		'pxyvlan_in'=> 'pxyvlan_in',
		'pxyvlan_out'=> 'pxyvlan_out',
		'pxyacct'	=> 'pxyacct',
		'pxypass'	=> 'pxypass',
		'name'		=> 'cname',
		'idcard'	=> 'card',
		'rate_out'	=> 'rate_out',
		'rate_in'	=> 'rate_in',
		'phone'		=> 'phone',
		'remark'	=> 'other',
	);

	$arg = '';
	foreach($data as $k => $v) {
		if(isset($map[$k]))
			$arg .= $map[$k] . "=$v ";
	}
	
	if(empty($arg)) return array('ret' => 100, 'data' => 'err: arg is empty.');
	$cmd = RAASEYE . " account add " . $arg;
//	$cmd .= iconv("utf-8", "gb2312", $arg);

	exec($cmd, $ret, $retval);

	return array('ret' => $retval, 'data' => $ret);
}

function raaseye_acct_remove($acct)
{
//	$cmd = RAASEYE . " account remove acct=" . iconv("utf-8", "gb2312", $acct);
	$cmd = RAASEYE . " account remove acct=" . $acct;

	exec($cmd, $ret, $retval);

	return array('ret' => $retval, 'data' => $ret);
}

function raaseye_acct_allowlist_reload($reload)
{
	$cmd = RAASEYE . " allowlst config reload={$reload}";

	exec($cmd, $ret, $retval);

	return array('ret' => $retval, 'data' => $ret);
}

function raaseye_acct_bindmac_reload($reload)
{
	$cmd = RAASEYE . " bindmac config reload={$reload}";

	exec($cmd, $ret, $retval);

	return array('ret' => $retval, 'data' => $ret);
}

function raaseye_acct_list($data)
{
	$cmd = RAASEYE . " account list";


	exec($cmd, $ret, $retval);

	return array('ret' => $retval, 'data' => $ret);
}

function raaseye_group_add($data)
{
	$cmd = RAASEYE . " group add ";
	$arg = '';

	$map = array(
		'group_id'	=> 'gid',
		'ent_id'	=> 'entid',
		'name'		=> 'name',
		'ifname'	=> 'ifname',
		'disabled' => 'disabled',
		'clntepa'	=> 'clntepa',
		'startip'	=> 'startip',
		'endip'		=> 'endip',
		'rate_out'	=> 'rate_out',
		'rate_in'	=> 'rate_in',
		'dns0'		=> 'dns0',
		'dns1'		=> 'dns1',
		'maxonlinetm'=>'maxonlinetime',
		'vlan_out'	=> 'vlan_out',
		'vlan_in'	=> 'vlan_in',
	);

	foreach($data as $k => $v) {
		if(isset($map[$k]))
			$arg .= $map[$k] . "=$v ";
	}

	if(empty($arg)) return array('ret' => 100, 'data' => 'err: arg is empty.');
	$cmd .= $arg;
//	$cmd .= iconv("utf-8", "gb2312", $arg);

	exec($cmd, $ret, $retval);

	return array('ret' => $retval, 'data' => $ret);
}

function raaseye_group_remove($gid, $entid)
{
	$cmd = RAASEYE . " group remove gid=" . $gid . " entid=" . $entid;


	exec($cmd, $ret, $retval);

	return array('ret' => $retval, 'data' => $ret);
}

function raaseye_group_list($data)
{
	$cmd = RAASEYE . " group list";


	exec($cmd, $ret, $retval);

	return array('ret' => $retval, 'data' => $ret);
}

function raaseye_enterpise_add($data)
{
	$cmd = RAASEYE . " ent add ";
	$arg = '';
	
	$map = array(
		'own_id'	=> 'ownid',
		'ent_id'	=> 'entid',
		'domain'	=> 'domain',
		'secret'	=> 'secret',
		'disabled' => 'disabled',
	);

	foreach($data as $k => $v) {
		if(isset($map[$k]))
			$arg .= $map[$k] . "=$v ";
	}

	if(empty($arg)) return array('ret' => 100, 'data' => 'err: arg is empty.');
//	$cmd .= iconv("utf-8", "gb2312", $arg);
	$cmd .= $arg;

	exec($cmd, $ret, $retval);

	return array('ret' => $retval, 'data' => $ret);
}

function raaseye_enterpise_remove($entid)
{
	$cmd = RAASEYE . " ent remove entid=" . $entid;

	exec($cmd, $ret, $retval);

	return array('ret' => $retval, 'data' => $ret);
}

function raaseye_enterpise_list($data)
{
	$cmd = RAASEYE . " ent list";

	exec($cmd, $ret, $retval);

	return array('ret' => $retval, 'data' => $ret);
}

function raaseye_enterpise_set_default_domain($domain)
{
	$cmd = RAASEYE . " ent config default_domain=${domain}";

	exec($cmd, $ret, $retval);

	return $retval;
}

function raaseye_iwacct_add($data)
{
	// iwacct add keyno=x iwacct_id=x [acct_id=x iwan_id=x flag=x]
	$map = array(
		'iwacct_id'	=> 'iwacct_id',
		'serialno'	=> 'keyno',
		'acct_id'	=> 'acct_id',
		'iwan_id'	=> 'iwan_id',
		'flag'		=> 'flag',
	);

	$arg = '';
	foreach($data as $k => $v) {
		if(isset($map[$k]))
			$arg .= $map[$k] . "=$v ";
	}
	
	if(empty($arg)) return array('ret' => 100, 'data' => 'err: arg is empty.');
	$cmd = RAASEYE . " iwacct add " . $arg;

	exec($cmd, $ret, $retval);

	return array('ret' => $retval, 'data' => $ret);
}

function raaseye_iwacct_remove($iwacct_id)
{
	// iwacct remove iwacct_id=x
	$cmd = RAASEYE . " iwacct remove iwacct_id=" . $iwacct_id;

	exec($cmd, $ret, $retval);

	return array('ret' => $retval, 'data' => $ret);
}


function raaseye_iwanpop_add($data)
{
	// iwanpop add ent_id=x iwan_id=x [ipaddr=x port=x mtu=x isp=x level=x name=x]
	$map = array(
		'iwan_id'	=> 'iwan_id',
		'name'		=> 'name',
		'ent_id'	=> 'ent_id',
		'ipaddr'	=> 'ipaddr',
		'port'		=> 'port',
		'mtu'		=> 'mtu',
		'isp'		=> 'isp',
		'level'		=> 'level'
	);

	$arg = '';
	foreach($data as $k => $v) {
		if(isset($map[$k])) {
			if('name' == $k) $v = iconv("utf-8", "gb2312", $v);
			$arg .= $map[$k] . "=$v ";
		}
	}
	
	if(empty($arg)) return array('ret' => 100, 'data' => 'err: arg is empty.');
	$cmd = RAASEYE . " iwanpop add " . $arg;
	// $cmd .= iconv("utf-8", "gb2312", $arg);

	exec($cmd, $ret, $retval);

	return array('ret' => $retval, 'data' => $ret);
}

function raaseye_iwanpop_remove($iwan_id)
{
	// iwanpop remove iwan_id=x
	$cmd = RAASEYE . " iwanpop remove iwan_id=" . $iwan_id;

	exec($cmd, $ret, $retval);

	return array('ret' => $retval, 'data' => $ret);
}
